	PROGRAM GDTTOCSV
C
C	CREATES CSV FILE WITH ALL RUN DATA FROM GDT FILES
C	USE: GDTTOCSV runid [outfile]
C	OUTPUT GOES TO runid.CSV
C
	PARAMETER (MAXCHN=255,MAXDAT=2000)
	REAL T(MAXCHN,MAXDAT),C(MAXCHN,MAXDAT)
	INTEGER NPT(MAXCHN),PRI(MAXCHN)
	CHARACTER NAME(MAXCHN)*8,INST(MAXCHN)*8,OUTSTR*5000,OUTCHN*19
	CHARACTER INLIN*80,FILNAM*80,OUTFIL*80,GDTUIC*60,RUNID*8
	LOGICAL EOF,ERRIND
	INTEGER ORDR(MAXCHN)
C
	CALL GETARG (1,RUNID)
	IF (RUNID(1:1).EQ.' ') THEN
		WRITE (6,*) 'Creates CSV file with all run data in '
     &		 //'GDT files.'
		WRITE (6,*) 'Use: GDTTOCSV runid [GDT=gdtloc] [outfile]'
		CALL EXIT
	ENDIF
	LRUNID=LNBLNK(RUNID)
	CALL GETARG (2,OUTFIL)
	IF (OUTFIL(1:4).EQ.'GDT=') THEN
		GDTUIC=OUTFIL(5:)
		LGDTUC=LNBLNK(GDTUIC)
		IF (GDTUIC(LGDTUC:LGDTUC).NE.'\') THEN
			GDTUIC=GDTUIC(1:LGDTUC)//'\'
			LGDTUC=LGDTUC+1
		ENDIF
		CALL GETARG (3,OUTFIL)
	ELSE
		LGDTUC=0
	ENDIF
	IF (OUTFIL(1:1).EQ.' ') THEN
		OUTFIL=RUNID(1:LRUNID)//'.CSV'
		LOUTFL=LRUNID+4
	ELSE
		LOUTFL=LNBLNK(OUTFIL)
		OUTFIL(LOUTFL+1:)='.CSV'
		LOUTFL=LOUTFL+4
	ENDIF
C
C	GET GDT LOCATION FROM MODELING.PRM IF NOT SPECIFIED ON
C	COMMAND LINE
C
	IF (LGDTUC.EQ.0) THEN
		OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10		READ (1,1,END=12) INLIN
    1		FORMAT (A)
		IF (INLIN(1:4).EQ.'GDT=') THEN
			GDTUIC=INLIN(5:)
			LGDTUC=LNBLNK(GDTUIC)
		ENDIF
		GOTO 10
   12		CLOSE (UNIT=1)
	ENDIF
C
C	OPEN GDT FILE
C
	IF (LGDTUC.NE.0) THEN
		FILNAM=GDTUIC(1:LGDTUC)//RUNID(1:LRUNID)//'.GDT'
		LFIL=LGDTUC+LRUNID+4
	ELSE
		FILNAM=RUNID(1:LRUNID)//'.GDT'
		LFIL=LRUNID+4
	ENDIF
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=21)
	GOTO 22
   21	WRITE (6,*) 'File = '//FILNAM(1:LFIL)//' does not exist'
	CALL EXIT
   22	CONTINUE
C
C	INITIALIZE AND READ HEADERS
C
	NCHN=0
	NDATMAX=0
	EOF=.FALSE.
	READ (1,'(/A)',END=90) INLIN
	IF (INLIN(1:1).NE.' ') THEN
		RUNID=INLIN
		LRUNID=LNBLNK(INLIN)
	ENDIF
C
C	READ NEXT CHANNEL
C
   30	READ (1,1,END=90) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 30
	IF (INLIN(1:1).EQ.' ') GOTO 30
	IF (NCHN.EQ.MAXCHN) THEN
		WRITE (6,*) 'Too many channels.  Output truncated'
		GOTO 90
	ENDIF
	NCHN=NCHN+1
	CALL PARSE0 (3,INLIN,80)
	CALL PARSE1 (1,NAME(NCHN),I,8,INLIN)
	CALL PARSE1 (2,INST(NCHN),I,8,INLIN)
	CALL PARSEI (3,PRI(NCHN),ERRIND,INLIN)
	IF (ERRIND) PRI(NCHN)=9
C
C	READ CHANNEL DATA
C
	NPTI=0
   40	READ (1,1,END=48) INLIN
	IF (INLIN(1:1).EQ.'.') THEN
		GOTO 49
	ELSEIF (INLIN(1:1).EQ.'!') THEN
		GOTO 40
	ENDIF
	IF (NPTI.EQ.MAXDAT) THEN
		WRITE (6,*) 'INCREASE MAXDAT'
		CLOSE (UNIT=1)
		CALL EXIT
	ENDIF
	CALL PARSE0 (2,INLIN,80)
	NPTI=NPTI+1
	CALL PARSER (1,T(NCHN,NPTI),ERRIND,INLIN)
	IF (ERRIND) THEN
		NPTI=NPTI-1
	ELSE
		CALL PARSER (2,C(NCHN,NPTI),ERRIND,INLIN)
		IF (ERRIND) NPTI=NPTI-1
	ENDIF
	GOTO 40
C
   48	EOF=.TRUE.
   49	IF (NPTI.EQ.0) THEN
		NCHN=NCHN-1
	ELSE
		NPT(NCHN)=NPTI
		NDATMAX=MAX0(NPTI,NDATMAX)
	ENDIF
	IF (EOF) GOTO 90
	GOTO 30
C
C	END OF INPUT.  CLOSE INPUT AND OPEN OUTPUT FILE
C
   90	CLOSE (UNIT=1)
C
	OPEN (UNIT=1,FILE=OUTFIL,STATUS='UNKNOWN',ERR=91)
	GOTO 92
   91	WRITE (6,*) 'Cannot open '//OUTFIL(1:LOUTFL)//' for output.'
	CALL EXIT
   92	CONTINUE
C
C	ORDER CHANNELS BY PRIORITY.  FIRST 1, THEN 2, THEN REST
C	(REST IN NO PARTICULAR ORDER)
C
	IORD=0
	DO 95 I=1,NCHN
	IF (PRI(I).EQ.1) THEN
		IORD=IORD+1
		ORDR(IORD)=I
	ENDIF
   95	CONTINUE
	DO 96 I=1,NCHN
	IF (PRI(I).EQ.2) THEN
		IORD=IORD+1
		ORDR(IORD)=I
	ENDIF
   96	CONTINUE
	DO 97 I=1,NCHN
	IF (PRI(I).NE.1.AND.PRI(I).NE.2) THEN
		IORD=IORD+1
		ORDR(IORD)=I
	ENDIF
   97	CONTINUE
	IF (IORD.NE.NCHN) STOP 'PROGRAM ERROR. BAD IORD'
C
C	WRITE OUTPUT HEADERS
C
	WRITE (1,101,ERR=91) RUNID(1:LRUNID),NCHN,NDATMAX
C
	WRITE (1,102) (NAME(ORDR(I))(1:LNBLNK(NAME(ORDR(I))))//';'
     &	 //INST(ORDR(I))(1:LNBLNK(INST(ORDR(I)))),I=1,NCHN),'.'
	WRITE (1,102) (NAME(ORDR(I))(1:LNBLNK(NAME(ORDR(I)))),I=1,NCHN)
     &	 ,'.'
	WRITE (1,102) (INST(ORDR(I))(1:LNBLNK(INST(ORDR(I)))),I=1,NCHN)
     &	 ,'.'
	WRITE (1,103) (PRI(ORDR(I)),I=1,NCHN)
	WRITE (1,103) (NPT(ORDR(I)),I=1,NCHN)
  101	FORMAT (A,',',I5,',',I5/)
  102	FORMAT (1000(A,',,'))
  103	FORMAT (1000(I5,',,'))
C
	DO 110 I=1,NDATMAX
	OUTSTR=' '
	LOUTST=0
	DO 112 JCHN=1,NCHN
	ICHN=ORDR(JCHN)
	IF (I.GT.NPT(ICHN)) THEN
		OUTSTR(LOUTST+1:)=',,'
		LOUTST=LOUTST+2
	ELSE
		WRITE (OUTCHN,104) T(ICHN,I),C(ICHN,I)
  104		FORMAT (F7.1,',',0PE10.3,',')
		OUTSTR(LOUTST+1:)=OUTCHN
		LOUTST=LOUTST+19
	ENDIF
  112	CONTINUE
  110	WRITE (1,1) OUTSTR(1:LOUTST)
C
	CLOSE (UNIT=1)
	WRITE (6,*) 'File = '//OUTFIL(1:LOUTFL)//' created.'
	CALL EXIT
	END
		