C --- NEWSTP.FOR.
C        ENTRY NEWST
C --- CALLED BY LSODE (NEWSTP ENTRY)
C         OR BY PRNTC (NEWST ENTRY).  BOTH ARE CALLED ONLY BY INT.
C --- CALLS DIFFUN, KBLDUP
C --- NO I/O OTHER THAN WRITES TO OUT,ICRT
C
	SUBROUTINE NEWSTP (TARG,Y)
C
C	CALLED BY LSODE WHEN A SUCCESSFUL STEP TAKEN (NEWSTP: FLSOD=T)
C	OR CALLED BY PRNTC BEFORE PRINTING OUT VALUES (NEWST: FLSOD=F).
C	THIS UPDATES STEADY STATE AND BUILDUP SPECIES.
C
	INCLUDE 'MAINSPC.FOR'
	REAL Y(NDY)
	LOGICAL FLSOD        !TRUE IF CALLED FROM LSODE.
C
C	USED FOR INTRATE FEATURE.  SHARED WITH PRNTC
C
	COMMON /RIDATA/ RINT(MAXRXI),RINTSV(MAXRXI),RLAST(MAXRXI)
C
C
C -----------------------------------------------------------
C	ENTRY FROM LSODE
C
C	WRITE ANY MESSAGES REQUIRED
C
	IF (SHOWT) THEN
		DTIM=SECNDS(TIMINT)/60.0
		WRITE (ICRT,4) RUN(1:8),NRUN,DTIM,TARG,NSTP,NJEVAL,
     &		 Y(1),Y(2),Y(3)
   4     	FORMAT ('+',A8,' (#',I4,'):',F7.2,F11.4,I5,I4,1P3G11.3)
	ENDIF
C
C	IF CALC IS TO FIND A MAXIMUM CONC, UPDATE IT.  NO OTHER ACTION
C	IS NEEDED IN THIS CASE.
C
	IF (NMAXO.GT.0) THEN
		DO 1001 I=1,NMAXO
		IF (Y(IMAXO(I)).GT.CMAXO(I,1)) THEN
			CMAXO(I,1)=Y(IMAXO(I))
			CMAXO(I,2)=TARG
		ENDIF
 1001		CONTINUE
		IF (AIRSHD) THEN
			F=COEF(INDHT)/COEF(INDEF)
			DO 1002 I=1,NMAXO
			IF (F*Y(IMAXO(I)).GT.CMAXO(I,4)) THEN
				CMAXO(I,4)=F*Y(IMAXO(I))
				CMAXO(I,5)=TARG
			ENDIF
 1002			CONTINUE
		ENDIF
		IF (MAXONL) RETURN
	ENDIF
C
	IF (DBGPRT) WRITE (OUT,2) NSTP,TARG,NFEVAL,NJEVAL
   2	FORMAT (' STEP',I5,':  T =',1PG15.6,I12,' EVALUATIONS, AND',
     &   I12,' INVERSIONS')
C
	FLSOD=.TRUE.
	GOTO 1
C -----------------------------------------------------------
C	ENTRY FROM PRNTC
C
	ENTRY NEWST (TARG,Y)
	FLSOD=.FALSE.
C -----------------------------------------------------------
C
C	CODE COMMON TO BOTH ENTRIES
C
    1	CONTINUE
C
C	CALCULATE SS CONC'S.
C
	CALL DIFFUN (TARG,DY)
	IF (NSB.EQ.0) RETURN
C
C	INITIALIZE ARRAYS FOR BO CALC AND (IF APPLICABLE) INTRATE
C	IF FIRST CALL
C
	IF (FIRST) THEN
		CALL KBLDUP (TARG,DY(NDY+1))
		BOLAST=T0
		DO 5 I=1,NSB
		CBO(I)=C(I+NB0)
    5		DYBO(I)=DY(NDY+I)
		CALL KSXTRA (TARG)
C
		IF (INTRAT) THEN
			IF (CONTC) THEN
				DO 51 I=1,NRK
   51				RLAST(I)=R(I)
			ELSE
				DO 52 I=1,NRK
				RLAST(I)=R(I)
   52				RINT(I)=0.0
			ENDIF
		ENDIF
		RETURN
	ENDIF
C
C	B.O. CALC FOR SUBSEQUENT CALLS.
C
	IF (BOLAST-TARG) 100,200,300
C
C	T > LAST T.  CALCULATE NEW BO CONC'S.  CBO, DYBO ARE 'ACTIVE'
C               VALUES
C
  100	CALL KBLDUP (TARG,DY(NDY+1))
C
C	CALCULATE BO CONC'S USING THE LAST CONC'S, THE LAST AND THE
C	CURRENT DERIVATIVES, BY AVERAGING THE DERIVATIVES.
C
	DT2=0.5*(TARG-BOLAST)
	DO 10 I=1,NSB
	DYI=DY(NDY+I)
	CBO(I)=CBO(I)+DT2*(DYI+DYBO(I))
   10	DYBO(I)=DYI
C
C	CALCULATE INTEGRATED RATE
C
	IF (INTRAT) THEN
		DO 101 I=1,NRK
		RINT(I)=RINT(I)+DT2*(R(I)+RLAST(I))
  101		RLAST(I)=R(I)
	ENDIF
C
	BOLAST=TARG
C
C	IF CALLED BY PRNTC, COPY CURRENT VALUES INTO C
C
	IF (FLSOD) RETURN
	DO 20 I=1,NSB
   20	C(NB0+I)=CBO(I)
C
	IF (INTRAT) THEN
		DO 201 I=1,NRK
  201		RINTSV(I)=RINT(I)
	ENDIF
	CALL KSXTRA (TARG)
	RETURN
C
C	IF NO CHANGE IN T, DO NOTHING IF CALLED BY PRNTC.
C	IF CALLED BY LSODE, UPDATE DY'S.
C
  200	IF (FLSOD) THEN
		CALL KBLDUP (TARG,DYBO)
	ELSE
		DO 30 I=1,NSB
   30		C(NB0+I)=CBO(I)
C
		IF (INTRAT) THEN
			DO 301 I=1,NRK
  301			RINTSV(I)=RINT(I)
		ENDIF
C
		CALL KSXTRA (TARG)
	ENDIF
	RETURN
C
C	IF T < TLAST, DON'T CHANGE CBO OR DYBO.  ABORT IF CALLED BY
C	LSODE, OR BACK-EXTRAPOLATE TO GET VALUES FOR T IF CALLED BY
C	PRNTC.  USE THE AVERAGE OF THE DERIVITIVES TO EXTRAPOLATE.
C
  300	IF (FLSOD) THEN
		WRITE (OUT,302) TARG,BOLAST
  302		FORMAT (' PGM ERR.  LSODE CALLED NEWSTP WITH'
     &		,' T =',1PG13.5,', WHICH IS LESS THAN',G13.5,
     &		'USED BEFORE.')
		RETURN
	ENDIF
C
	CALL KBLDUP (TARG,DY(NDY+1))
	DT2=0.5*(TARG-BOLAST)
	DO 310 I=1,NSB
  310	C(NB0+I)=CBO(I)+DT2*(DY(NDY+I)+DYBO(I))
C
	IF (INTRAT) THEN
		DO 3101 I=1,NRK
 3101		RINTSV(I)=RINT(I)+DT2*(R(I)+RLAST(I))
	ENDIF
C
	CALL KSXTRA (TARG)
	RETURN
	END
