C.-        THIS FILE PROCESSED USING PARMS = I,  DEBUG=T
C --- NEWRK.FOR
C
C       CALCULATE RK'S FOR NEW TEMPERATURE.  MUST BE IN MAIN SEGMENT
C --- CALLED BY MODL, RDCKC, DIFFUN
C --- UNITS USED: NONE
C --- CALLS: NOTHING
C
C --- CONDITIONAL COMPILATION:  V = VAX,   S = SMALL RSX, B = BIG RSX(PDP)
C                               C = CYBER, U = UCSD/CRAY, I = IBM/AT
C -------------------------------------------------------------------------
C
      SUBROUTINE NEWRK (INDRXN)
C
C     CALCULATES TEMPERATURE-DEPENDENT RATE PARMS AND TEMPERATURE-
C     VARYING COEFFICIENTS FOR T = TEMP
C
C     INDRXN > 0:  INDRXN=REACTION NO. TO CALC RK., DON'T CALC COEFS
C     INDRXN = 0:  CALC NEW VALUES FOR ALL RXNS AND COEFS
C     INDRXN = -1:  CALC NEW VALUES FOR COEFS ONLY
C
C-VBSC
C.      INCLUDE 'MAINSPC/NOLIST'
C-U
C.      macro mainspc (mainspc)
C.      use mainspc
C-I
	INCLUDE 'MAINSPC.FOR'
C-
      REAL K0
      LOGICAL TXACT
C
      ARREN(A,EA,B)=A*((TEMP/TREF)**B)*EXP(-EA/RT)
      TXACT=.FALSE.
C
      IF (INDRXN.EQ.0) THEN
          I1=1
          I2=NRK
      ELSEIF (INDRXN.EQ.-1) THEN
          GOTO 1200
      ELSE
          I1=INDRXN
          I2=INDRXN
      ENDIF
      RT=0.0019872*TEMP
C
C     LOOP OVER REACTIONS INVOLVED
C
      DO 1000 IRXN=I1,I2
CD         WRITE (OUT,*) 'TEMP,RXTYP(',IRXN,')= ',TEMP,RXTYP(IRXN)
	    ITYP=RXTYP(IRXN)
          IF (ITYP.EQ.4) THEN
C
C     CALCULATE RK USING ARRHENIUS EXPRESSION
C
              LOCB=LKBUF(IRXN)
              RK(IRXN)=ARREN(KPBUF(LOCB),KPBUF(LOCB+1),KPBUF(LOCB+2))
CD             WRITE (OUT,10) IRXN,KPBUF(LOCB),KPBUF(LOCB+1),KPBUF
CD    &           (LOCB+2),RK(IRXN)
CD  10 FORMAT (' NEWRK: RXN#',I4,'   A,EA,B= ',1PE11.3,0PF8.2,
CD    & F9.3,'  NEW RK= ',1PE12.3)
C
          ELSEIF (ITYP.EQ.5) THEN
C
C               CALCULATES RATE CONSTANT USING TROE FALLOFF EXPERSSION
C               FOR TEMPERATURE = TEMP
C               KPBUF(1) = RESULTING K
C               KPBUF(2-4) = A,EA,B FOR P=0
C               KPBUF(5-7) = A,EA,B FOR P=INF.
C               KPBUF(8,9) = F AND N PARAMETERS
C
                LOCB=LKBUF(IRXN)
CD               WRITE (OUT,*) 'INDATM= ',INDATM,'  C= ',C(INDATM)
                IF (INDATM.EQ.0) THEN
                    K0=ARREN(KPBUF(LOCB),KPBUF(LOCB+1),KPBUF(LOCB+2))
                ELSE
                    IF (C(INDATM).EQ.0) THEN
                        RK(IRXN)=0.0
CD                       WRITE (OUT,*) 'RXN',IRXN,': M=0, K=0'
                        GOTO 1000
                    ELSE
                        K0=C(INDATM)*ARREN(KPBUF(LOCB),KPBUF
     &                  (LOCB+1),KPBUF(LOCB+2))
                    ENDIF
                ENDIF
CD               WRITE (OUT,20) IRXN,KPBUF(LOCB),KPBUF(LOCB+1),KPBUF
CD    &           (LOCB+2),K0
CD  20 FORMAT (' NEWRK: RXN#',I4,'   A,EA,B= ',1PE11.3,0PF8.2,
CD    &           F9.3,'  K0= ',1PE12.3)
                RATIO=K0/ARREN(KPBUF(LOCB+3),KPBUF(LOCB+4),KPBUF(LOCB+5
     &           ))
CD               WRITE (OUT,30) IRXN,KPBUF(LOCB+3),KPBUF(LOCB+4),KPBUF
CD    &           (LOCB+5),RATIO
CD  30 FORMAT (' NEWRK: RXN#',I4,'   AI,EAI,BI= ',1PE11.3,
CD    &           0PF8.2,F9.3,'  RATIO= ',1PE12.3)
                RK(IRXN)=(K0/(1.0+RATIO))*KPBUF(LOCB+6)**(1.0/(1.0+
     &           (0.43429*ALOG(RATIO)/KPBUF(LOCB+7))**2))
C
          ELSEIF (ITYP.EQ.9) THEN
C
C               CALCULATES RATE CONSTANT USING K= K1 + K2 [M]
C
                LOCB=LKBUF(IRXN)
                IF (INDATM.EQ.0) THEN
                    RK2=ARREN(KPBUF(LOCB+3),KPBUF(LOCB+4),KPBUF(LOCB+5))
                ELSE
                    RK2=C(INDATM)*ARREN(KPBUF(LOCB+3),KPBUF
     &                  (LOCB+4),KPBUF(LOCB+5))
                ENDIF
		    RK(IRXN)=RK2+ARREN(KPBUF(LOCB),KPBUF(LOCB+1),KPBUF(LOCB+2))
C
          ELSEIF (ITYP.EQ.10) THEN
C
C               CALCULATES RATE CONSTANT USING K= K0+K3[M]/(1+K3[M]/K2)
C
                LOCB=LKBUF(IRXN)
                IF (INDATM.EQ.0) THEN
                    RK3=ARREN(KPBUF(LOCB+6),KPBUF(LOCB+7),KPBUF(LOCB+8))
                ELSE
                    RK3=C(INDATM)*ARREN(KPBUF(LOCB+6),KPBUF
     &                  (LOCB+7),KPBUF(LOCB+8))
                ENDIF
		    RK(IRXN)=ARREN(KPBUF(LOCB),KPBUF(LOCB+1),KPBUF(LOCB+2))
     &		+ RK3/(1.0+(RK3/
     &		 ARREN(KPBUF(LOCB+3),KPBUF(LOCB+4),KPBUF(LOCB+5))))
C
          ELSEIF (ITYP.EQ.6) THEN
C
C             K IS INTERPOLATED LINEARLY BETWEEN 2 K'S WITH
C             ASSOCIATED TEMPERATURES.
C
              LOCB=LKBUF(IRXN)+1
C                                       ! LOC OF FIRST RXN # -1
              LOCT=IKPBUF(LOCB-1)-1
C                                       ! LOC OF FIRST T -1
              NJRX=IKPBUF(LOCB)
C                                       ! NO. RXNS/T'S
CD             WRITE (OUT,*) 'TYP6: LOCB,LOCT,NJRX=',LOCB,LOCT,NJRX
              DO 40 I=1,NJRX
C                               ! TEMPERATURES MUST BE IN ASCENDING ORDER
                  TI=KPBUF(LOCT+I)
CD                 WRITE (OUT,*) 'I,TI=',I,TI
                  IF (TI-TEMP) 42,44,46
   42             TILAST=TI
C                                       ! TEMP > TI.  SAVE VALUE
CD                 WRITE (OUT,*) 'TEMP>TI.'
                  GOTO 40
   44             RK(IRXN)=RK(IKPBUF(LOCB+I))
C                                       ! TEMP=TI.  USE K REF'D.
CD                 WRITE (OUT,*) 'TEMP=TI.  RK,IKP=',
CD    &                           RK(IRXN),IKPBUF(LOCB+I)
                  GOTO 1000
C                                       ! AND QUIT.
   46             IF (I.EQ.1) THEN
C                                       ! TEMP < TI.
                      RK(IRXN)=RK(IKPBUF(LOCB+1))
C                                       ! IF FIRST, USE IT
CD                     WRITE (OUT,*) 'TEMP<TI. I=1,  RK,IKP=',
CD    &                              RK(IRXN),IKPBUF(LOCB+1)
                      GOTO 1000
C                                       ! AND QUIT
                  ELSE
C                                       ! TILAST < TEMP < TI.  INTERPOLATE
                      RK1=RK(IKPBUF(LOCB+I-1))
                      RK(IRXN)=RK1+(RK(IKPBUF(LOCB+I))-RK1)*(TEMP-
     &                   TILAST)/(TI-TILAST)
CD     WRITE (OUT,*) 'EXT.  RK1,RK2,RK,TI,TILAST,TEMP,IKP1,IKP2='
CD     WRITE (OUT,*) RK1,RK(IKPBUF(LOCB+I)),RK(IRXN),TI,TILAST,TEMP,
CD    &   IKPBUF(LOCB+I-1),IKPBUF(LOCB+I)
                  ENDIF
                  GOTO 1000
   40         CONTINUE
              RK(IRXN)=RK(IKPBUF(LOCB+NJRX))
C                                               ! TEMP > ALL T'S.  USE LAST.
CD             WRITE (OUT,*) 'TEMP>ALL TS.  RK,IPP,NJRX=',RK(IRXN),
CD    &                       IKPBUF(LOCB+NJRX),NJRX
          ENDIF
C
 1000 CONTINUE
      IF (INDRXN.GT.0) RETURN
C
C     CALCULATE NEW VALUES FOR TEMPERATURE-DEPENDENT COEFFICIENTS
C
 1200 IF (NVTCO.EQ.0) RETURN
      TEMPVC=TEMP
      IF (TEMPVC.LT.VTEMP(1)) THEN
                TEMPVC=VTEMP(1)
      ELSEIF (TEMPVC.GT.VTEMP(NVTEMP)) THEN
                TEMPVC=VTEMP(NVTEMP)
      ENDIF
      DO 1500 IVT=1,NVTEMP
          IF (TEMPVC.EQ.VTEMP(IVT)) THEN
              TXACT=.TRUE.
CD             WRITE (OUT,*) 'TEMP=VTEMP(',IVT,')=',TEMPVC
              GOTO 1600
          ELSEIF (IVT.LT.NVTEMP) THEN
              IF(VTEMP(IVT).LT.TEMPVC .AND. TEMPVC.LT.VTEMP(IVT+1))THEN
                  F=(TEMPVC-VTEMP(IVT))/(VTEMP(IVT+1)-VTEMP(IVT))
CD                 WRITE (OUT,1022) TEMPVC,IVT,IVT+1
CD1022 FORMAT (' TEMP=',F5.1,'   VTEMP(',I2,')< TEMP <','VTEMP(',I2,')')
                  GOTO 1600
              ENDIF
          ENDIF
 1500 CONTINUE
C
 1600 DO 2000 I=1,NVTCO
          IF (TXACT) THEN
              COEF(IVTCO(I))=VTCO(I,IVT)
CD             WRITE (OUT,1023) IVTCO(I),COEF(IVTCO(I))
CD1023 FORMAT (' TXACT=.TRUE.  COEF(',I2,')= ',F6.2)
          ELSE
C                                               !INTERPOLATE
               F1=(VTCO(I,IVT+1)-VTCO(I,IVT))
               COEF(IVTCO(I))=VTCO(I,IVT) + F1*F
CD              WRITE (OUT,1024) IVTCO(I),COEF(IVTCO(I))
CD1024 FORMAT (' INTERPOLATE.  COEF(',I2,')= ',F6.2)
          ENDIF
 2000 CONTINUE
C
      RETURN
      END
C --- END OF NEWRK.FOR
