C --- OPTINI.FOR
C --- CALLED BY INTMAIN
C --- CALLS INBUF, ALIN16, MOVLFT
C --- UNITS USED:  LOGU, OPT1  (OPEN,READ/WRITE,CLOSE).  NONE LEFT OPEN
C
C	CONTAINS ENTRY OPTEND
C
C -------------------------------------------------------------------------
C
      SUBROUTINE OPTINI
C
C     INITIALIZATION SUBROUTINE FOR OPTIMIZATION TO FIND BEST FIT FOR
C     INTEGRATION PARMS (WHICH MUST BE READABLE BY RDCKC SUBROUTINE)
C
	INCLUDE 'MAINSPC.FOR'
	INCLUDE 'OPTSPEC.FOR'
C
      LOGICAL NOCHG,ERRIND
      INTEGER INX(MAXCHN),INX2(MAXCHN),NTIM(MAXCHN)
      CHARACTER NAMEIN*16
C
      PARAMETER (BIG=1.0E+38)
C
C     MODIFY INT PARMS TO BE CONSISTANT WITH OPT
C
      PASS=.FALSE.
C
C     DELETE ALL TEMPORARY DATA SETS USED, SO IF ONE IS LOCKED,
C     PROGRAM WILL DUMP NOW RATHER THAN LATER.
C
      CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT0.TMP ',' ')
      OPEN (UNIT=TMP1,FILE=IOB160,STATUS='UNKNOWN')
      CLOSE (UNIT=TMP1,STATUS='DELETE')
C
      IOB160=' '
      CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT1.TMP ',' ')
      OPEN (UNIT=TMP1,FILE=IOB160,STATUS='UNKNOWN')
      CLOSE (UNIT=TMP1,STATUS='DELETE')
C
      IOB160=' '
      CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT2.TMP ',' ')
      OPEN (UNIT=TMP1,FILE=IOB160,STATUS='UNKNOWN')
      CLOSE (UNIT=TMP1,STATUS='DELETE')
C
      IOB160=' '
      CALL FILNAM (NLEN,IOB160,TMPUIC,'INTOPT.TMP ',' ')
      OPEN (UNIT=TMP1,FILE=IOB160,STATUS='UNKNOWN')
      CLOSE (UNIT=TMP1,STATUS='DELETE')
C
      IOB160=' '
      CALL FILNAM (NLEN,IOB160,TMPUIC,'INTOP2.TMP ',' ')
      OPEN (UNIT=TMP1,FILE=IOB160,STATUS='UNKNOWN')
      CLOSE (UNIT=TMP1,STATUS='DELETE')
C
	OPEN (UNIT=TMP1,FILE='OPT.CMD',STATUS='UNKNOWN')
	CLOSE (UNIT=TMP1,STATUS='DELETE')
C
C     READ NAMES AND VALUES OF PARMS.
C     INPUT TERMINATED BY BLANK RECORD
C
       NPRM=0
       MAXITR=100
       FLAMDA=0.001
       MINFAC=1.0001
       MINCHI=0.0
       SHOFIT=.FALSE.
C
 1000  CALL INBUF ('OPT: ',5)
       IF (IORET.EQ.2) GOTO 9900
       IF (IOB160(1:4).EQ.'    ') GOTO 1110
       CALL ALIN16(5,IOB160)
       CALL MOVLFT(IOB160)
C
       IF (IOB160(1:8).EQ.'*MAXITR ') GOTO 1010
       IF (IOB160(1:8).EQ.'*FLAMDA ') GOTO 1020
       IF (IOB160(1:8).EQ.'*MINFAC ') GOTO 1030
       IF (IOB160(1:8).EQ.'*MINCHI ') GOTO 1040
       IF (IOB160(1:8).EQ.'*SHOWFIT') GOTO 1050
C
       NPRM=NPRM+1
       PRMLBL(NPRM)=IOB160(1:16)
       READ (IOB160(17:80),1001,ERR=9910) PARMS(NPRM),DPARMS(NPRM),
     &  PMAX(NPRM),PMIN(NPRM)
 1001  FORMAT (4G16.0)
       IF (DPARMS(NPRM).EQ.0.0) DPARMS(NPRM)=0.005*PARMS(NPRM)
       IF (DPARMS(NPRM).EQ.0.0) GOTO 9920
       IF (PMAX(NPRM).EQ.0.0) PMAX(NPRM)=BIG
       GOTO 1000
C
 1010  READ (IOB160(17:32),1102,ERR=9910) MAXITR
 1102  FORMAT (I16)
       GOTO 1000
 1020  READ (IOB160(17:32),1001,ERR=9910) FLAMDA
       IF (FLAMDA.EQ.0.0) FLAMDA=10.0
       GOTO 1000
 1030  READ (IOB160(17:32),1001,ERR=9910) MINFAC
       IF (MINFAC.LT.1.0) MINFAC=1.0
       GOTO 1000
 1040  READ (IOB160(17:32),1001,ERR=9910) MINCHI
       IF (MINCHI.LT.0.0) MINCHI=0.0
       GOTO 1000
 1050  SHOFIT=.TRUE.
       GOTO 1000
C
C      WRITE INITIAL PARM VALUES
C
 1110  WRITE (OUT,1112) MAXITR,FLAMDA,MINFAC,MINCHI,
     &  (PRMLBL(I),PARMS(I),PMIN(I),PMAX(I),
     &  DPARMS(I),I=1,NPRM)
 1112  FORMAT (/' NONLINEAR OPTIMIZATION'//' MAXIMUM NUMBER',
     &  ' OF ITERATIONS =',I5//' INITIAL FLAMDA =',1PG12.4//
     &  ' MINIMUM FACTOR FOR CHISQR CHANGE =',0PF10.6//
     &  ' MINIMUM CHISQR =',1PG12.3//1X,16X,
     &  'INIT. VALUE   MINIMUM     MAXIMUM     F. FOR DERIV'
     &  /(' ',A16,4G12.3))
C
C      OPEN DATA SET TO SAVE DATA VALUES AND WEIGHTS
C
       IOB160=' '
C
       CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT0.TMP ',' ')
       OPEN (UNIT=OPT1,FILE=IOB160,STATUS='UNKNOWN',
     &  FORM='UNFORMATTED')
C
C      OPEN TEMPORARY DATA SET WHICH IS USED AS INT INPUT STREAM
C      DURING OPTIMIZATION STEP.  PARMS WILL BE STORED IN FILE=
C      INTOP2.TMP, WHICH WILL BE INSERTED AT BEGINNING OF STREAM.
C
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'INTOPT.TMP ',' ')
        OPEN (UNIT=LOGU,FILE=IOB160,STATUS='UNKNOWN')
C
C ---------------------------------------------------------------
C      FOR EACH RUN TO BE USED IN OPT, READ DATA AND PARMS
C      RELATING TO DATA.
C
       NRUNS=0
       SUMY2=0.0
       WRITE (LOGU,1) '.SETDEF'
    1	FORMAT (A)
C
 1200  CALL INBUF ('RUN LABEL: ',11)
       IF (IORET.EQ.2) GOTO 9940
       IF (IOB160(1:8).EQ.'        ') GOTO 1300
       IF (IOB160(1:4).EQ.'*END') GOTO 1300
C
       IF (NRUNS.EQ.MAXRUN) STOP 'INCREASE MAXRUN'
       NRUNS=NRUNS+1
C
       RUNLBL(NRUNS)=IOB160(1:8)
       WRITE (OUT,1202) NRUNS,RUNLBL(NRUNS)
 1202  FORMAT (/1X//' RUN',I3,' LABEL = ''',A8,'''')
C
C      LOOP OVER CHANNELS FOR THIS RUN.
C
	NCHNS=0
 1210	NCHNS=NCHNS+1
	CALL INBUF ('CHANNEL NAME: ',14)
	IF (IORET.EQ.2) GOTO 9940
	CALL PARSE0 (2,IOB160,80)
	CALL PARSE1 (1,NAMEIN,I,16,IOB160)
	IF (NAMEIN(1:1).EQ.' ') GOTO 1230
	CALL PARSR2 (2,WTFAC,1.0,ERRIND,IOB160)
	IF (ERRIND.OR.WTFAC.LT.0.0) GOTO 9940
C
       CALL INBUF ('CHANNEL PRMS:',14)
       IF (IORET.EQ.2) GOTO 9940
       CALL PARSE0 (4,IOB160,80)
       CALL PARSI2 (1,NTIMS,0,ERRIND,IOB160)
       IF (ERRIND.OR.NTIMS.LT.0) GOTO 9940
       IF (NTIMS.GT.MAXTIM) STOP 'INCREASE MAXTIM'
       CALL PARSR2 (2,FRCUNC,0.0,ERRIND,IOB160)
       IF (ERRIND) GOTO 9940
       CALL PARSR2 (3,SENS,-1.0,ERRIND,IOB160)
       IF (ERRIND) GOTO 9940
       CALL PARSR2 (4,CHNWT,0.0,ERRIND,IOB160)
       IF (ERRIND) GOTO 9940
C
C
C      WRITE CHAN INFO AND DATA
C
       WRITE (OUT,1222) NAMEIN,FRCUNC,SENS,CHNWT
 1222  FORMAT (/' CHANNEL = ''',A16,''', FRCUNC =',
     &  1PG12.3,', SENS =',G12.3,', CHN WT =',G12.3,
     &	/' ',4X,'TIME',T17,'VALUE',T30,'WEIGHT')
C
	IF (NTIMS.EQ.0) THEN
 1423		CALL INBUF('OPT DATA:',9)
		IF (IORET.EQ.2) GOTO 9940
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (1,T1,ERRIND,IOB160)
		IF (ERRIND) GOTO 1424
		NTIMS=NTIMS+1
		IF (NTIMS.GT.MAXTIM) STOP 'INCREASE MAXTIM'
		TIMES(NTIMS,NCHNS)=T1
		CALL PARSER(2,DATA(NTIMS,NCHNS),ERRIND,IOB160)
		IF (ERRIND) GOTO 9940
		GOTO 1423
 1424		CONTINUE
	ELSE
		READ (IN,*,END=9940,ERR=9940) (TIMES(I,NCHNS),I=1,NTIMS),
     & 	 (DATA(I,NCHNS),I=1,NTIMS)
	ENDIF
	NTIM(NCHNS)=NTIMS
C
C	DEFAULT SENSITIVITY IS 1% OF MAXIMUM
C
	IF (WTFAC.EQ.0.0) THEN
		DO 1226 I=1,NTIMS
 1226		WT(I,NCHNS)=0.0
	ELSE
		IF (SENS.LT.0.0) THEN
			XMAX=0.0
			DO 1223 I=1,NTIMS
 1223			IF (DATA(I,NCHNS).GT.XMAX) XMAX=DATA(I,NCHNS)
			SENS=0.01*(-SENS)*XMAX
		ENDIF
C
		IF (SENS.EQ.0.0.AND.FRCUNC.EQ.0.0) SENS=1.0
		S2=SENS*SENS
C
C		EACH POINT WEIGHED ACCORDING TO 1/UNC**2, WHERE UNC
C		IS COMBINATION OF ABSOLUTE UNC ('MEASUREMENT SENSITIVITY')
C		AND FRACTIONAL UNCERTAINTY ('PRECISION')
C
		TOTWT=0.0
		DO 1227 I=1,NTIMS
		WT(I,NCHNS)=1.0/(S2+(FRCUNC*DATA(I,NCHNS))**2)
 1227		TOTWT=TOTWT+((DATA(I,NCHNS)**2)*WT(I,NCHNS))
		IF (CHNWT.NE.0.0) THEN
			TOTWT=CHNWT/TOTWT
			DO 1228 I=1,NTIMS
 1228			WT(I,NCHNS)=TOTWT*WT(I,NCHNS)
		ENDIF
	ENDIF
	DO 1229 I=1,NTIMS
C	REJECT NEGATIVE POINTS
	IF (DATA(I,NCHNS).LT.0.0) THEN
		WT(I,NCHNS)=0.0
	ELSE
		WT(I,NCHNS)=WTFAC*WT(I,NCHNS)
	ENDIF
 1229	WRITE (OUT,1224) TIMES(I,NCHNS),DATA(I,NCHNS),WT(I,NCHNS)
 1224	FORMAT (' ',1P3G12.3)
C
C      SEE WHICH CHANNEL THIS IS
C
       DO 1214 I=1,NS
       IF (NAME(I).EQ.NAMEIN) GOTO 1216
 1214  CONTINUE
       GOTO 9950
 1216  INX(NCHNS)=I
       GOTO 1210
C
C              END LOOP OVER CHANNELS.
C
 1230  NCHNS=NCHNS-1
       NOCHN(NRUNS)=NCHNS
C      WRITE (OUT,*) ' NOCHN(',NRUNS,')=',NOCHN(NRUNS)
       IF (NCHNS.EQ.0) STOP 'NO CHANNELS, THIS RUN'
C
C      READ IN RDCKC INPUT FOR THIS RUN, AND PASS IT TO TEMP. DS
C
 1232  CALL INBUF('FOR RDCKC: ',11)
       IF (IORET.EQ.2) GOTO 1240
       IF (IOB160.EQ.' ') GOTO 1240
C
C	SKIP .INT RECORDS NOT APPLICABLE TO .LPT
	IF (IOB160(1:5).EQ.'.TEND') GOTO 1232
	IF (IOB160(1:5).EQ.'.DPRN') GOTO 1232
	IF (IOB160(1:5).EQ.'.NAME') THEN
		WRITE (ICRT,*) 'Warning:  .NAME input in ',RUNLBL(NRUNS)
		GOTO 1232
	ENDIF
	IF (IOB160(1:5).EQ.'.INT') GOTO 1240
	IF (IOB160(1:8).EQ.RUNLBL(NRUNS)) GOTO 1232
	IF (IOB160(1:6).EQ.'MODEL=') GOTO 1232
	IF (IOB160(1:6).EQ.'Model ') GOTO 1232
	IF (IOB160(1:5).EQ.'SAVE ') GOTO 1232
	IF (IOB160(1:5).EQ.'NOOUT') GOTO 1232
	IF (IOB160(1:2).EQ.'. ') GOTO 1232
C
       IF (IOB160(1:4).EQ.'*END') GOTO 1240
       WRITE (LOGU,1234) (BYT160(I),I=1,IOLEN)
 1234  FORMAT (80A1)
       GOTO 1232
C
 1240   LTMPU=LNBLNK(TMPUIC)
	IF (LTMPU.NE.0) THEN
		WRITE (LOGU,1) '@'//TMPUIC(1:LTMPU)//'INTOP2.TMP'
	ELSE
		WRITE (LOGU,1) '@INTOP2.TMP'
	ENDIF
       WRITE (LOGU,1) '.INT'
C
C      WRITE DATA IN ORDER OF INCREASING TIME ON DATA SET AT OPT1
C
       NTIMS=0
       NDAT=0
       DO 1250 I=1,NCHNS
 1250  INX2(I)=1
C
 1252  NOCHG=.TRUE.
       TX=BIG
       DO 1254 J=1,NCHNS
       K=INX2(J)
       IF (K.GT.NTIM(J)) GOTO 1254
       IF (TIMES(K,J).GE.TX) GOTO 1254
       TX=TIMES(K,J)
       NOCHG=.FALSE.
 1254  CONTINUE
       IF (NOCHG) GOTO 1260
C  -     UPDATE INDICES AND SAVE DATA
       DO 1256 J=1,NCHNS
       K=INX2(J)
       IF (K.GT.NTIM(J)) GOTO 1256
       IF (TIMES(K,J).GT.TX) GOTO 1256
       WRITE (OPT1) J,INX(J),TIMES(K,J),DATA(K,J),WT(K,J)
C@@
C       WRITE (OUT,*) 'TO OPT1: ',J,INX(J),TIMES(K,J),DATA(K,J),WT(K,J)
C 1255  FORMAT (' WRITING TO OPT1: ',2I4,F6.2,F8.3,1PG11.3)
C@@
       NDAT=NDAT+1
       SUMY2=SUMY2+(WT(K,J)*(DATA(K,J)**2))
       INX2(J)=K+1
 1256  CONTINUE
       NTIMS=NTIMS+1
       IF (NTIMS.GT.MAXTIM) STOP 'TOO MANY TIMES/RUN'
       GOTO 1252
 1260  NDATRN(NRUNS)=NDAT
C
 1300	IF (IORET.NE.2.AND.IOB160(1:4).NE.'*END') GOTO 1200
C
C
C      ALL RUNS DEFINED.  CLOSE TEMP. DATA SETS
C
	WRITE (LOGU,'(''.END'')')
	CLOSE (UNIT=LOGU)
	CLOSE (UNIT=OPT1)
C
	WRITE (OUT,'(/'' Sum (wt*y^2) ='',1PE12.3/)') SUMY2
C
C      INITIALIZE NO. ITERATIONS AND INDICATE
C      THAT THIS FIRST PASS THRU RDCKC IS JUST TO
C      READ THE COMMON SETDEF PARAMETERS
C
 1310  NITER=0
       INDOPT=0
C
       WRITE (OUT,1390)
 1390  FORMAT (//' INTEGRATIONS WITH INITIAL PARAMETERS FOLLOW:'
     &         //1X)
C
       RETURN
C
C      ERRORS.  ABORT OPT
C
 9900  WRITE (ICRT,*) '<EOF> ON OPT INPUT STREAM'
       GOTO 9990
 9910  WRITE (ICRT,*) 'OPT: ERROR DECODING INIT. PARMS.'
       GOTO 9990
 9920  WRITE (ICRT,*) 'OPT: DPARMS, PARM, AND PMAX ALL 0'
       GOTO 9990
C 9930  WRITE (ICRT,*) 'ERROR IN READING ''.OPD'' DATA SET.'
C       GOTO 9990
 9940  WRITE (ICRT,*) '<EOF> OR ERROR IN READING DATA TO FIT.'
       WRITE (ICRT,*) 'Last record = ',IOB160(1:LNBLNK(IOB160))
       GOTO 9990
 9950  WRITE (ICRT,*) 'Channel = ',NAMEIN,' not on model.'
C
C
 9990   ABORT=.TRUE.
	CLOSE (UNIT=LOGU)
	CLOSE (UNIT=OPT1)
        RETURN
C
C
C	ENTRY TO WRITE SUMMARY OF RESULTS TO UNIT=OUT
C
	ENTRY OPTEND
C
	WRITE (OUT,9999) FILES,NITER,NPRM,CHISQR,
     &	 (PRMLBL(I)(1:8),PARMS(I),I=1,NPRM)
 9999	FORMAT (A16,' OPT OK',2I4,1PG12.4/(A8,E12.4))
	RETURN
C
        END
C --- END OF OPTINI.FOR
