	PROGRAM INTRUN
C
C	** THIS VERSION FOR SAVE FORMAT FOR F77L INT **
C
C	DOES MODEL CALCULATION FOR CHAMBER RUNS.  FIRST RUNS LUMPING PGM
C	ON .INP FILE, THEN DOES CALC ON .INT FILE CREATED.
C
C	PARAMETERS ON COMMAND LINE:
C
C	P1	RUN ID
C	P2	PARAMETER FILE.  THIS IS COPIED TO MODELING.PRM.
C		(DEFAULT = "MODEL"; NO FAILURE IF NO MODEL.PRM)
C		(ALSO CALC OUTPUT LOCATION IF NO 2ND PARM FILE)
C	P3	(OPTIONAL)  IF DEFINED, 2ND PARM FILE AND OUTPUT LOC.
C		OR "CHECK" TO CHECK TO SEE IF CALC DONE BEFORE.
C		OR gn1file.GN1 ... TO RUN AS 4TH PARAMETER TO 'INTRUN'.
C	P4	(OPTIONAL) IF "INTFILE", ONLY PRODUCES FILES.
C
C	CREATES TMP.PRM, MODDOC.IN AS TEMPORARY FILES; DELETES WHEN DONE.
C
C	THIS VERSION ALWAYS USES .INP FILES AS INPUT FILES.  THEY
C	CAN BE IN A DIFFERENT UIC, SPECIFIED BY THE INP= INPUT
C	IN MODELING.PRM
C
C	IF NO .INP FILE EXISTS THEN LOOKS FOR ALREADY EXISTING .INT
C	FILE AND USES THAT.
C
C	LUMPING PROGRAM DEPENDS ON 'LMPPGM=' INPUT IN MODELING.PRM
C
C
	CHARACTER INLIN*80,RUNID*8,PRMFIL*8,MDCFIL*8,OUTFIL*80
	CHARACTER INTNAM*40,INPFIL*40,GN1FILE*60,OPTCHR*16
	CHARACTER CALUIC*40,MODDOC*40,MODUIC*40,INPUIC*40,
     &	 DFLMOD*8,MODUSD*8,LMPPGM*40,TRY2*8,TRY3*8,PGMUIC*40,SAVLOC*8
C
	PARAMETER (MAXL=8)
	INTEGER L,LRUNID,LPRMFL,LMDCFL
	LOGICAL ANS,LOGERR,CDTSAV,CHECK,INTFIL,DEBUG,RATE,RATE2,NOINP
	DATA LOGERR/.FALSE./
C
C
C	GET AND DECODE COMMAND LINE
C
	CALL GETARG(1,RUNID)
	LRUNID=LNBLNK(RUNID)
	IF (RUNID(1:1).EQ.' '.OR.RUNID(1:1).EQ.'?'
     &	 .OR.RUNID(1:2).EQ.'/?') THEN
		WRITE (6,*) 'Does model simulation with specified set ',
     &		 'of model parameters in prmfil.PRM'
		WRITE (6,*) 'file, and loggs calculation results in .E',
     &		 'XT file.  RunID.INP file must exist.'
		WRITE (6,*)
		WRITE (6,*) 'Use:  INTRUN runid prmfil [mdcfile|'//
     &		 'option] [option]'
		WRITE (6,*) '- Calc saved in [caluic]prmfil\runid.CDA.'
		WRITE (6,*) '  or [caluic]CALCS\runid.CDA if no prmfile,'
		WRITE (6,*) '  or [caluic]mdcfile\runid.CDA if mdcfile'
     &		 //' given.'
		WRITE (6,*) '- If mdcfile given, file= mdcfile.IN',
     &			' copied to MODDOC.IN, and calc saved in '
		WRITE (6,*) 'Options:'
		WRITE (6,*) '  CHECK -- no calc if already done.'
		WRITE (6,*) '  INTRATE or RATE -- Run calc with '
     &		 //'these options, then run INTRATE'
		WRITE (6,*) '  INTRATE2 or RATE2 -- Run calc with '
     &		 //'these options, then run INTRATE2'
		WRITE (6,*) '  GN1=file ... GN1 file input'
		WRITE (6,*) '  DEBUG ... do not delete temp files'
		WRITE (6,*) '  LOCALINP ... input in local folder'
     &		 //', not [inpuic]'
		CALL EXIT
	ENDIF
C
C	PARAMETER FILE MUST BE SPECIFIED FOR THIS VERSION
C
	CALL GETARG(2,PRMFIL)
	IF (PRMFIL(1:1).EQ.' ') THEN
		WRITE (6,*) 'No parm file specified.'
		GOTO 999
	ENDIF
	LPRMFL=LNBLNK(PRMFIL)

C
C	GET OPTIONS
C
	CHECK=.FALSE.
	GN1FILE=' '
	LGN1FL=0
	MDCFIL=' '
	LMDCFL=0
	INTFIL=.FALSE.
	OPTCHR=' TMP'
	LOPTCH=4
	DEBUG=.FALSE.
	RATE=.FALSE.
	RATE2=.FALSE.
	NOINP=.FALSE.
C
	IARG=3
C
C	GET OPTION FILE, IF APPLICABLE.
C
    3	CALL GETARG(IARG,INLIN)
	IF (INLIN(1:1).EQ.' ') THEN
		GOTO 4
	ELSEIF (INLIN(1:2).EQ.'X ') THEN
	ELSEIF (INLIN(1:6).EQ.'CHECK ') THEN
		CHECK=.TRUE.
	ELSEIF (INLIN(1:8).EQ.'INTRATE ') THEN
		OPTCHR=OPTCHR(1:LOPTCH)//' /INTRATE'
		LOPTCH=LOPTCH+9
		RATE=.TRUE.
	ELSEIF (INLIN(1:5).EQ.'RATE ') THEN
		OPTCHR=OPTCHR(1:LOPTCH)//' /RATE'
		LOPTCH=LOPTCH+6
		RATE=.TRUE.
	ELSEIF (INLIN(1:9).EQ.'INTRATE2 ') THEN
		OPTCHR=OPTCHR(1:LOPTCH)//' /INTRATE'
		LOPTCH=LOPTCH+9
		RATE=.TRUE.
		RATE2=.TRUE.
	ELSEIF (INLIN(1:6).EQ.'RATE2 ') THEN
		OPTCHR=OPTCHR(1:LOPTCH)//' /RATE'
		LOPTCH=LOPTCH+6
		RATE=.TRUE.
		RATE2=.TRUE.
	ELSEIF (INLIN(1:8).EQ.'INTFILE ') THEN
		INTFIL=.TRUE.
	ELSEIF (INLIN(1:6).EQ.'DEBUG ') THEN
		DEBUG=.TRUE.
	ELSEIF (INLIN(1:8).EQ.'LOCALINP') THEN
		NOINP=.TRUE.
	ELSEIF (IARG.EQ.3) THEN
		IF (INLIN(1:4).EQ.'GN1=') THEN
			LGN1FL=LNBLNK(INLIN)
			GN1FILE=INLIN(5:LGN1FL-4)//'.GN1'
		ELSE
			MDCFIL=INLIN(1:8)
			LMDCFL=LNBLNK(MDCFIL)
		ENDIF
	ELSE
		WRITE (6,*) 'Unrecognized option: '//
     &		 INLIN(1:LNBLNK(INLIN))
		GOTO 999
	ENDIF
	IARG=IARG+1
	GOTO 3
    4	CONTINUE
	IF (INTFIL) DEBUG=.TRUE.
C
C	READ MODELING.PRM AND PARM FILE FOR RUN PARMS.
C
	ANS=.TRUE.
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
	OPEN (UNIT=2,FILE='TMP.PRM',STATUS='UNKNOWN')
C
C
	LCALUC=0
	CALUIC=' '
	LMODUC=0
	MODUIC=' '
	LMODDC=0
	MODDOC=' '
	LDFLMD=0
	DFLMOD=' '
	LINPUC=0
	INPUIC=' '
	LLMPPG=0
	LMPPGM=' '
	TRY2=' '
	LTRY2=0
	TRY3=' '
	LTRY3=0
	PGMUIC=' '
	LPGMUC=1
C
	CDTSAV=.FALSE.
C
  10	READ (1,1,END=12) INLIN
   1	FORMAT (A)
	L=LNBLNK(INLIN)
	IF (L.EQ.0) GOTO 10
	WRITE (2,1) INLIN(1:LNBLNK(INLIN))
   11	IF (L.LT.5) GOTO 10
C
	IF (INLIN(1:4).EQ.'CAL=') THEN
		LCALUC=L-4
		CALUIC=INLIN(5:L)
	ELSEIF (INLIN(1:4).EQ.'MOD=') THEN
		LMODUC=L-4
		MODUIC=INLIN(5:L)
	ELSEIF (INLIN(1:4).EQ.'MDC=') THEN
		LMODDC=L-4
		MODDOC=INLIN(5:L)
	ELSEIF (INLIN(1:4).EQ.'INP=') THEN
		LINPUC=L-4
		INPUIC=INLIN(5:L)
	ELSEIF (INLIN(1:7).EQ.'DFLMOD=') THEN
		LDFLMD=L-7
		IF (LDFLMD.GT.0) DFLMOD=INLIN(8:L)
	ELSEIF (INLIN(1:7).EQ.'LMPPGM=') THEN
		LLMPPG=L-7
		IF (LLMPPG.GT.0) LMPPGM=INLIN(8:L)
	ELSEIF (INLIN(1:8).EQ.'CDTSAVE=') THEN
		CDTSAV=L.GT.8
	ELSEIF (INLIN(1:8).EQ.'MDCFILE=') THEN
		LEXTFL=L-8
		IF (LEXTFL.GT.0) MDCFIL=INLIN(9:L)
	ELSEIF (INLIN(1:5).EQ.'TRY2=') THEN
		LTRY2=L-5
		IF (LTRY2.GT.0) TRY2=INLIN(6:L)
	ELSEIF (INLIN(1:5).EQ.'TRY3=') THEN
		LTRY3=L-5
		IF (LTRY3.GT.0) TRY3=INLIN(6:L)
	ELSEIF (INLIN(1:5).EQ.'PGMS=') THEN
		LPGMUC=MAX0(1,L-5)
		PGMUIC=INLIN(6:L)
	ELSEIF (ANS) THEN
		GOTO 10
C
C	FOLLOWING FOR PRM FILE ONLY
	ELSEIF (INLIN(1:4).EQ.'PRM=') THEN
		PRMFIL=INLIN(5:)
		LPRMFL=LNBLNK(PRMFIL)
	ENDIF
	GOTO 10
C
   12	CLOSE (UNIT=1)
	IF (ANS) THEN
		INLIN=PRMFIL(1:LPRMFL)
		INLIN(LPRMFL+1:LPRMFL+4)='.PRM'
		OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ERR=13)
		ANS=.FALSE.
		GOTO 10
   13		IF (PRMFIL(1:LPRMFL).NE.'MODEL') GOTO 810
	ENDIF
C
C	GET SAVE FILE AND SAVE IN PRM FILE
	IF (MDCFIL(1:1).NE.' ') THEN
		SAVLOC=MDCFIL
		LSAVLC=LMDCFL
	ELSEIF (PRMFIL(1:1).EQ.' ') THEN
		SAVLOC='CALCS'
		LSAVLC=5
	ELSE
		SAVLOC=PRMFIL
		LSAVLC=LPRMFL
	ENDIF
C
	WRITE (2,1) 'SAVELOC='//SAVLOC(1:LSAVLC)
	CLOSE (UNIT=2)
C
C	MUST HAVE DFLMOD= INPUT.
C
	IF (LDFLMD.EQ.0) THEN
		WRITE (6,*) 'NO DEFALUT MODEL (DFLMOD= OR LMPPRM1=)',
     &		 ' SPECIFIED IN PARM FILE.'
		GOTO 820
	ENDIF
C
C	MAKE SURE INP FILE EXISTS
C
	IF (NOINP.OR.LINPUC.EQ.0) THEN
		INPFIL=RUNID(1:LRUNID)
		LP=LRUNID
	ELSE
		INPFIL=INPUIC(1:LINPUC)
		LP=LINPUC+LRUNID
		INPFIL(LINPUC+1:LP)=RUNID(1:LRUNID)
	ENDIF
	INPFIL(LP+1:LP+4)='.INP'
	LP=LP+4
	INQUIRE (FILE=INPFIL,EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'FILE = ',INPFIL(1:LP),' DOES NOT EXIST.'
		GOTO 822
	ENDIF
C
C	IF "CHK" OPTION SPECIFIED, MAKE SURE CALC NOT DONE BEFORE.
C	OTHERWISE, DELETE OUTPUT FILE SO NONE WILL EXIST IF INT FAILS
C
	OUTFIL=CALUIC(1:LCALUC)//SAVLOC(1:LSAVLC)//'\'//RUNID(1:LRUNID)
     &	 //'.CDA'
	LOUTFL=LCALUC+LSAVUC+LRUNID+5
	INQUIRE (FILE=OUTFIL,EXIST=ANS)
	IF (CHECK) THEN
		IF (ANS) THEN
			WRITE (6,*) 'Calc for ',SAVLOC(1:LSAVLC)//
     &			 '\'//RUNID(1:LRUNID)//' already done.'
			GOTO 822
		ENDIF
	ELSEIF (ANS) THEN
		OPEN (UNIT=2,FILE=OUTFIL,STATUS='OLD')
		CLOSE (UNIT=2,STATUS='DELETE')
	ENDIF
C
C	IF MODEL .IN FILE DEFINED, COPY IT TO MODDOC.IN,
C	OTHERWISE, USE 'MDC=' INPUT IN MODELING.PRM.  (USE 'NODOC')
C	IF NO MDC= INPUT')
C
	OPEN (UNIT=2,FILE='MODDOC.IN',STATUS='UNKNOWN')
	IF (LMDCFL.EQ.0) THEN
		IF (LMODDC.EQ.0) THEN
			WRITE (2,1) '.LBL6 '//PRMFIL(1:LPRMFL)
		ELSE
			WRITE (2,1) '.LBL6 '//MODDOC(1:LMODDC)
		ENDIF
	ELSE
		INLIN=MDCFIL(1:LMDCFL)//'.IN'
		OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ERR=830)
   22		READ (1,1,END=24) INLIN
		WRITE (2,1) INLIN(1:LNBLNK(INLIN))
		GOTO 22
   24		CLOSE (UNIT=1)
	ENDIF
	CLOSE (UNIT=2)
C
C	READY TO START PROCESSING.  RUN LUMPING PGM.  IF NONE SPECIFIED,
C	DEFAULT IS "LUMPGEN".
C
C	DELETE .INT FILE FIRST.
C
	INTNAM=RUNID(1:LRUNID)//'.INT'
	OPEN (UNIT=1,FILE=INTNAM,STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
C
C	MAKE COMMAND FILE TO DO LUMPING:
C		1. COMMAND INVOKING LUMPING PROGRAM.
C		2. INPUT FILE
C		3. OUTPUT FILE
C		4. PARAMETER FILE (TMP.PRM)
C
	IF (LLMPPG.EQ.0) THEN
		LMPPGM=PGMUIC(1:LPGMUC)//'LUMPGEN'
		LLMPPG=7+LPGMUC
	ELSE
		LMPPGM=PGMUIC(1:LPGMUC)//LMPPGM(1:LLMPPG)
		LLMPPG=LPGMUC+LLMPPG
	ENDIF
C
C	MAKE SURE LUMPING .EXE FILE EXISTS
C
	INLIN=LMPPGM(1:LLMPPG)
	INLIN(LLMPPG+1:LLMPPG+4)='.EXE'
	INQUIRE (FILE=INLIN,EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'FILE = ',INLIN(1:LLMPPG+4),' DOES NOT '
     &		 ,'EXIST.'
		GOTO 900
	ENDIF
C
C	MAKE REST OF COMMAND LINE
C
	INLIN(LLMPPG+1:)=' '//INPFIL(1:LP)//' '//INTNAM(1:LRUNID+4)
     &	 //' TMP'
	LC=LLMPPG+LP+LRUNID+10
C
C	@@ (NOT SURE IF THIS WORKS)
	IF (GN1FILE(1:1).NE.' ') THEN
		INLIN=INLIN(1:LC)//' '//GN1FILE(1:LGN1FL)
		LC=LC+LGN1FL+1
	ENDIF
C
C	DELETE "STATUS.TMP" FILE IF IT EXISTS.  IT IS USED TO CHECK
C	FOR SUCESSFUL CALCULATION.
C
	INQUIRE (FILE='STATUS.TMP',EXIST=ANS)
	IF (ANS) THEN
		OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='OLD')
		CLOSE (UNIT=1,STATUS='DELETE')
	ENDIF
C
C*	WRITE (6,*) 'CMD = ',INLIN(1:LC)
	CALL SYSTEM (INLIN(1:LC))
C
C	GET MODEL TO USE FOR CALC FROM STATUS.TMP FILE.  IF LUMPGEN
C	OR LUMPINT FAILED, THIS FILE WOULDN'T EXIST.
C
	OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='OLD',ERR=860)
	READ (1,1,END=860) MODUSD
	IF (MODUSD(1:1).EQ.' ') GOTO 860
	L=LNBLNK(MODUSD)
	LMODUS=L
	CLOSE (UNIT=1,STATUS='DELETE')
C
C	MAKE SURE MODEL .EXE FILE EXISTS
C
	IF (LMODUC.NE.0) THEN
		INLIN=MODUIC(1:LMODUC)
		INLIN(LMODUC+1:LMODUC+L)=MODUSD(1:L)
		L=LMODUC+L
	ELSE
		INLIN=MODUSD(1:L)
	ENDIF
	INLIN(L+1:L+4)='.EXE'
	INQUIRE (FILE=INLIN,EXIST=ANS)
	IF (.NOT.ANS) THEN
C
C	IF THIS ONE DOESN'T EXIST, SEE IF DEFAULT MODEL DOES.
C
		IF (MODUSD(1:L).EQ.DFLMOD(1:LDFLMD)) THEN
			IF (INTFIL) THEN
				GOTO 3001
			ELSE
				GOTO 870
			ENDIF
		ENDIF
		IF (LMODUC.NE.0) THEN
			INLIN=MODUIC(1:LMODUC)
			L=LMODUC+LDFLMD
			INLIN(LMODUC+1:L)=DFLMOD(1:LDFLMD)
		ELSE
			INLIN=DFLMOD(1:LDFLMD)
			L=LDFLMD
		ENDIF
		INLIN(L+1:L+4)='.EXE'
		INQUIRE (FILE=INLIN,EXIST=ANS)
		IF (.NOT.(ANS.OR.INTFIL)) GOTO 870
	ENDIF
C
C	DELETE .OUT FILE AND STATUS.TMP TO PREPARE FOR RUNNING INT
C
 3001	INTNAM(LRUNID+2:LRUNID+4)='OUT'
	IF (.NOT.INTFIL) THEN
		OPEN (UNIT=1,FILE=INTNAM,STATUS='UNKNOWN')
		CLOSE (UNIT=1,STATUS='DELETE')
		INQUIRE (FILE='STATUS.TMP',EXIST=ANS)
		IF (ANS) CALL SYSTEM ('DEL STATUS.TMP')
	ENDIF
C
C	MAKE REST OF COMMAND LINE, AND RUN INT. (UNLESS INTFILE OPTION USED)
C
	INLIN(L+1:)=' '//RUNID(1:LRUNID)//OPTCHR(1:LOPTCH)
	LC=L+1+LRUNID+LOPTCH
C
C	DEBUG OR INTFILE OUTPUT
C
	IF (DEBUG) THEN
	        WRITE (6,*) 'File = ',INTNAM(1:LRUNID),'.INT created.'
	        WRITE (6,*) 'File = MODDOC.IN created.'
	        WRITE (6,*) 'File = TMP.PRM created.'
	        WRITE (6,*) 'INT command line = "',INLIN(1:LC),'"'
	ENDIF
C
C	DONE IF INTFILE OPTION USED.
C
	IF (INTFIL) GOTO 999
C
C	RUN INT.
C
C*	WRITE (6,*) 'CMD = ',INLIN(1:LC)
	CALL SYSTEM (INLIN(1:LC))
C
C	CHECK STATUS.TMP FOR SUCCESS OR FAILURE.'
C
	OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='OLD',ERR=30)
	READ (1,1,END=30) INLIN
	IF (INLIN(1:6).EQ.'INT OK') GOTO 33
   30	WRITE (6,*) 'INT failed using model = ',MODUSD(1:LMODUS)
C
C	INT FAILED.  IF NOT DEFAULT MODEL, TRY AGAIN WITH DEFAULT
C	MODEL. OTHERWISE, IF TRY2 SELECTED, TRY AGAIN WITH THAT MODEL
C
	IF (MODUSD(1:LMODUS).NE.DFLMOD(1:LDFLMD)) THEN
		MODUSD=DFLMOD
		LMODUS=LDFLMD
	ELSEIF (LTRY2.NE.0) THEN
		MODUSD=TRY2
		LMODUS=LTRY2
		DFLMOD=TRY2
		LDFLMD=LTRY2
		LTRY2=LTRY3
		TRY2=TRY3
		LTRY3=0
	ELSE
		WRITE (INLIN,'(A,'':  '',A)') RUNID(1:LRUNID),"INT FAILED"
		LOGERR=.TRUE.
		GOTO 900
	ENDIF
C
C	Control reaches this point if trying again
C
	WRITE (6,*) 'Trying with model = ',MODUSD(1:LMODUS)
	WRITE (6,*)
	IF (LMODUC.NE.0) THEN
		INLIN=MODUIC(1:LMODUC)
		L=LMODUC+LMODUS
		INLIN(LMODUC+1:L)=MODUSD(1:LMODUS)
	ELSE
		INLIN=MODUSD(1:LMODUS)
		L=LMODUS
	ENDIF
	INLIN(L+1:L+4)='.EXE'
	INQUIRE (FILE=INLIN,EXIST=ANS)
	IF (.NOT.ANS) GOTO 870
	INLIN(L+1:L+4)='    '
	LC=L+1+LRUNID
	INLIN(L+2:LC)=RUNID(1:LRUNID)
	LC=LC+4
	INLIN(LC-3:LC)=' TMP'
	GOTO 3001
C
C	INT SUCCESSFUL.  DELETE TEMPORARY FILES UNLESS DEBUG
C
   33	IF (DEBUG) THEN
		CLOSE (UNIT=1)
	ELSE
		CLOSE (UNIT=1,STATUS='DELETE')
		INTNAM(LRUNID+2:LRUNID+4)='INT'
		OPEN (UNIT=1,FILE=INTNAM,STATUS='OLD')
		CLOSE (UNIT=1,STATUS='DELETE')
	ENDIF
C
C	SUCESSFUL CONCLUSION
C
	GOTO 900
C
C	ERRORS
C
  810	WRITE (6,*) 'FILE = ',PRMFIL(1:LPRMFL),'.PRM DOES NOT EXIST.'
	GOTO 999
  820	WRITE (6,*) 'BAD INPUT IN ',PRMFIL(1:LPRMFL),'.PRM.'
  822	CLOSE (UNIT=2,STATUS='DELETE')
	GOTO 990
  830	WRITE (6,*) 'FILE = ',MDCFIL(1:LMDCFL),'.IN DOES NOT EXIST.'
	CLOSE (UNIT=2,STATUS='DELETE')
	GOTO 990
  860	WRITE (6,*) 'LUMPGEN OR LUMPINT FAILED.  COMMAND LINE IS:'
	WRITE (6,*) '"',INLIN(1:LC),'"'
	WRITE (INLIN,'(A,'':  '',A)') RUNID(1:LRUNID),'LUMPING FAILED'
	LOGERR=.TRUE.
	GOTO 900
  870	WRITE (6,*) 'FILE = ',INLIN(1:L+4),' DOES NOT EXIST.'
	WRITE (INLIN,'(A,1X,A)') RUNID(1:LRUNID),'NO MECH FILE(S)'
	LOGERR=.TRUE.
C
C	DONE.  DELETE TEMPORARY  FILES.
C
  900	IF (DEBUG) THEN
		CLOSE (UNIT=1)
	ELSE
		OPEN (UNIT=1,FILE='MODDOC.IN',STATUS='OLD')
		CLOSE (UNIT=1,STATUS='DELETE')
	ENDIF
  990	IF (.NOT.DEBUG) THEN
		OPEN (UNIT=1,FILE='TMP.PRM',STATUS='OLD')
		CLOSE (UNIT=1,STATUS='DELETE')
	ENDIF
	CLOSE (UNIT=2)
C
C	LOG ERROR IF FAILURE NOT DUE TO BAD .PRM FILE OR COMMAND LINE
C
	IF (LOGERR) THEN
		OPEN (UNIT=1,FILE='INTRUN.ERR',STATUS='UNKNOWN',
     &		 ACCESS='APPEND')
		CALL TMARK (CALUIC)
		WRITE (1,1) INLIN(1:LNBLNK(INLIN))//' '//CALUIC(1:16)
		CLOSE (UNIT=1)
		WRITE (6,*) 'ERROR LOGGED IN FILE = INTRUN.ERR'
	ENDIF
C
  999	CALL EXIT
	END
