	PROGRAM KZSFIT
C
C	OPTIMIZE PHOTOLYSIS RATES.  USE OPTIMIZATION METHOD USED
C	TO FIT J'S.  SEE COMMENTS IN SUBROUTINE OPTSOL, BELOW.
C
C	P1 = FILE NAMES (.KZS --> [MODUIC].FZS )
C	P2 = METHOD  ("AB" , "ABE" "ABEFnn")
C	P3 = OPT OUTPUT FILE (OPTIONAL)
C
	CHARACTER VERS*6
	DATA VERS/'8/7/91'/
C
	PARAMETER (MAXNPT=30)
	REAL ZANG(MAXNPT),PHOT(MAXNPT),PFIT(MAXNPT),CHISQR,PARMS(4),
     &	 SIGMA(4)
C
	LOGICAL FAILED,USEOUT,ERRIND
	CHARACTER INLIN*80,FILNAM*40,SETLBL*8,OUTFIL*40,METH*6
	CHARACTER MODUIC*60
C
C
C	GET FILE NAMES
C
	CALL GETARG (1,FILNAM)
	IF (FILNAM(1:1).EQ.' ') THEN
		WRITE (6,*) 'Use:  KZSFIT optfile [AB|ABE|ABEFnn] ',
     &           '[optoutfile]'
		WRITE (6,*) 'Input file:   optfile.KZS'
		WRITE (6,*) 'Output file:  [MOD]optfile.FZS'
		WRITE (6,*) 'Optoutfile has optimization details.'
		GOTO 899
	ENDIF
	LFIL=LNBLNK(FILNAM)
	CALL GETARG (2,METH)
	IF (METH.EQ.'    ') THEN
		METH='ABEF78'
		IMETH=78
	ELSEIF (METH.EQ.'AB    ') THEN
		IMETH=-2
	ELSEIF (METH.EQ.'ABE   ') THEN
		IMETH=-3
	ELSEIF (METH(1:4).EQ.'ABEF') THEN
		READ (METH(5:6),'(I2)',ERR=801) IMETH
		IF (IMETH.LE.0) GOTO 801
	ELSE
		GOTO 801
	ENDIF
	CALL GETARG (3,OUTFIL)
	LOUT=LNBLNK(OUTFIL)
C
C	GET MODUIC FROM MODELING.PRM
C
	MODUIC=' '
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
 1111	READ(1,1,END=1112) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'MOD=') THEN
		MODUIC=INLIN(5:)
	ENDIF
	GOTO 1111
 1112	CLOSE (UNIT=1)
C
C	OPEN INPUT AND OUTPUT FILES
C
	INLIN=FILNAM(1:LFIL)//'.KZS'
	OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ERR=800)
C
	INLIN=MODUIC(1:LNBLNK(MODUIC))//FILNAM(1:LFIL)//'.FZS'
	OPEN (UNIT=2,FILE=INLIN,STATUS='UNKNOWN')
C
C	HEADER FOR OUTPUT FILE
C
	WRITE (2,1) '! File = '//FILNAM(1:LFIL)//'.FZS.  Created by '
     &   //'KZSFIT version '//VERS
C
C	HEADER FOR LISTING FILE (IF APPLICABLE)
C
	IF (OUTFIL(1:1).NE.' ') THEN
		USEOUT=.TRUE.
		OPEN (UNIT=3,FILE=OUTFIL,STATUS='UNKNOWN')
		WRITE (3,2) FILNAM(1:LFIL)
    2		FORMAT (A/79('*')/10X,'N O N L I N E A R   O P T I M I',
     &           ' Z A T I O N   P R O G R A M'/30X,'FILE = ',A/
     &           79('*')//)
		WRITE (3,1) 'Method = '//METH
	ELSE
		USEOUT=.FALSE.
	ENDIF
C
C	READ HEADER COMMENTS (UNTIL ".")
C
    3	READ (1,1,END=810,ERR=820) INLIN
	IF (INLIN(1:1).NE.'.') THEN
		WRITE (2,1) '! '//INLIN(1:LNBLNK(INLIN))
		IF (USEOUT) WRITE (3,1) INLIN(1:LNBLNK(INLIN))
		GOTO 3
	ENDIF
C
C	READ ZENITH ANGLES
C
	READ (1,*) NPT,(ZANG(I),I=1,NPT)
C
	IF (NPT.GT.MAXNPT+1) STOP 'INCREASE MAXNPT IN OPTSPEC.FOR'
C
	DO 4 I=2,NPT
	IF (ZANG(I).LE.ZANG(I-1)) THEN
		WRITE (6,*) 'Bad Z angle order,  I = ',I
		GOTO 899
	ENDIF
    4	CONTINUE
C
	WRITE (2,11) METH(1:LNBLNK(METH)),(ZANG(I),I=1,NPT)
   11	FORMAT ('!'/'OPT METHOD = ',A/'!-------------------------------',
     &   '------------------------------------------------'
     &   /'!PhfFile    A          B          E          F         CZLOW',
     &   '    METH    CHISQR'/'!'/'!      ',15F7.0)
	WRITE (2,12)
   12	FORMAT ('!---------------------------------------------------',
     &   '----------------------------')
C
C	NEXT SET OF VALUES (PHOTK OR WL RANGE)
C
	FAILED=.FALSE.
C
  100	READ (1,1,END=200) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 100
	CALL PARSE0 (NPT+1,INLIN,80)
	CALL PARSE1 (1,SETLBL,I,8,INLIN)
	J=1
	J0=1
  104	DO 102 I=J,NPT
	CALL PARSR2 (I+J0,PHOT(I),-1.,ERRIND,INLIN)
	IF (ERRIND) GOTO 830
	IF (PHOT(I).EQ.-1.) THEN
  103		READ (1,1,END=200) INLIN
		IF (INLIN(1:1).EQ.'!') GOTO 103
		CALL PARSE0 (NPT+1-I,INLIN,80)
		J=I
		J0=1-I
		GOTO 104
		ENDIF
  102	CONTINUE
	IF (PHOT(1).EQ.0.0) THEN
		WRITE (6,*) 'Phot(',SETLBL(1:LNBLNK(SETLBL)),',0) = 0.  Set sk',
     &           'ipped.'
		GOTO 100
	ENDIF
C
	CHILST=0.0
	INDO=0
	IMTRY=IMETH
 1000	CALL OPTSOL (NPT,ZANG,PHOT,PFIT,CHISQR,PARMS,SIGMA,IND,IMTRY,
     &	 USEOUT)
	IF (IND.LE.0) THEN
		FAILED=.TRUE.
		IF (IND.LT.0) THEN
			WRITE (6,*) 'OPT ABORTED FOR ',SETLBL
			GOTO 200
		ELSE
			IF (INDO.EQ.1) THEN
				IMTRY=IMTRY+1
				INDO=2
				GOTO 1000
			ELSEIF (IMTRY.GT.0) THEN
				IMTRY=-3
				GOTO 1000
			ENDIF
			WRITE (2,1) '!'
			WRITE (2,1) '! *** OPT FAILED FOR '//
     &                   SETLBL(1:LNBLNK(SETLBL))//' ***'
			WRITE (6,*) 'OPT FAILED FOR ',SETLBL
			GOTO 100
		ENDIF
	ENDIF
C
C	IF METH>0, DECREASE BY ONE UNTIL BEST FIT OBTAINED.
C
	IF (IMTRY.GT.0.AND.SIGMA(4).GT.0.0.AND.INDO.NE.2) THEN
		IF (INDO.EQ.0.OR.CHISQR.LT.CHILST) THEN
			INDO=1
			CHILST=CHISQR
			IMTRY=IMTRY-1
			GOTO 1000
		ELSE
			IMTRY=IMTRY+1
			INDO=2
			GOTO 1000
		ENDIF
	ENDIF
C			
	WRITE (6,*) 'OPT done for ',SETLBL
	IF (PHOT(1).LT.1.0) THEN
		II=IFIX(ALOG10(PHOT(1)))-1
		F=10.0**II
	ELSEIF (PHOT(1).GT.10.0) THEN
		II=IFIX(ALOG10(PHOT(1)))
		F=10.0**II
	ELSE
		II=0
		F=1.0
	ENDIF
	IF (IMTRY.GT.0) THEN
		P5=COS(1.745329E-2*FLOAT(IMTRY))
	ELSE
		P5=0.0
	ENDIF
C
	WRITE (2,21) SETLBL,PARMS,P5,IMTRY,CHISQR/(PHOT(1)*PHOT(1)),II,
     &	 (PHOT(I)/F,I=1,NPT)
   21	FORMAT ('!'/A8,1PE10.3,4E11.3,I5,E11.1/'!'/'! OBS(',I3,')',
     &   0PF6.3,14F7.3)
	WRITE (2,211) (PFIT(I)/F,I=1,NPT)
  211	FORMAT ('! CALC',3X,15F7.3)
	WRITE (2,22) ((PFIT(I)-PHOT(I))/F,I=1,NPT)
   22	FORMAT ('! ERR',4X,15F7.3)
	DO 23 I=1,NPT
	IF (PHOT(I).EQ.0.0) THEN
		IF (PFIT(I).NE.0.0) PFIT(I)=1.E+10
	ELSE
		PFIT(I)=100.0*(PHOT(I)-PFIT(I))/PHOT(I)
	ENDIF
   23	CONTINUE
	WRITE (2,24) (PFIT(I),I=1,NPT)
   24	FORMAT ('! (%)',4X,15(1X,F6.1))
	GOTO 100
C
C	DONE
C
  200	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	WRITE (6,*) 'File = ',MODUIC(1:LNBLNK(MODUIC)),FILNAM(1:LFIL),
     &	 '.FZS created.'
	IF (USEOUT) THEN
		CLOSE (UNIT=3)
		WRITE (6,*) 'File = ',OUTFIL(1:LOUT),' created.'
	ENDIF
	IF (FAILED) GOTO 899
	CALL EXIT (0)
C
C
C	ERRORS
C
  800	WRITE (6,*) 'File = ',INLIN(1:LNBLNK(INLIN)),' does not exist.'
	GOTO 899
  801	WRITE (6,*) 'Unrecognized optimization method = ',METH
	GOTO 899
  810	WRITE (6,*) 'Unexpected <EOF> reading file = ',FILNAM(1:LFIL),
     &	 '.KZS.'
	GOTO 899
  820	WRITE (6,*) 'Error reading zenith angles in file = ',
     &	 FILNAM(1:LFIL),'.KZS.'
	GOTO 899
  830	WRITE (6,*) 'Error reading photolysis data from file = ',
     &	 FILNAM(1:LFIL),'.KZS for set = ',SETLBL
C
  899	CALL EXIT (2)
	END
C 
C ------------------------------------------------------------------------------
C
	SUBROUTINE OPTSOL (NPT,ZANG,PHOT,PFIT,CHIARG,PRMARG,SIGARG,IND,
     &	 IMETH,USEOUT)
C
C	SUBROUTINE TO OPTIMIZE FITS TO WAVALENGTH-DEPENDENT DATA
C	AS FUNCTION OF ZENITH ANGLE.  PARMS ARE A, B, E.  SDIST FOR A 
C	GIVEN Z ANGLE IS CALCULATED BY: 
C
C		Z <= 78 DEG:
C		SDIST(Z) = A * EXP ( -B * SQRT ((1.0 + E)/(COSZ**2 + E)))
C
C		Z > 78 DEG; LE 90:
C		SDIST(Z) = SDIST(78) * (COS(Z)/COS(78))**F
C
C	WHERE OPT DONE SEPERATELY FOR EACH WAVELENGTH INTERVAL, INDEPENDENT
C	OF THE OTHERS.   11/11/84
C
C	ARGUMENTS:  INPUT
C
	INTEGER NPT		! NO. POINTS 
	REAL ZANG(*)		! ZENITH ANGLES
	REAL PHOT(*)		! DATA TO FIT AS F(Z)
	LOGICAL USEOUT		! OUTPUT DETAILS TO UNIT 3
	INTEGER IMETH		! METHOD:
C					-2:  OPT A, B ONLY
C					-3:  OPT A, B, E ONLY
C					+z:  OPT F FOR CALCS FOR Z>z
C
C	ARGUMENTS:  OUTPUT
C
	REAL PFIT(*)		! FIT VALUES OF PHOT
	REAL CHIARG		! CHISQR STATISTIC FOR FIT
	REAL PRMARG(4)		! FIT PARAMETERS
	REAL SIGARG(4)		! "SIGMA" VALUES FOR PARMS
	INTEGER IND		! NO PARMS OPTIMIZED.  SET TO ZERO IF
C				  OPT FAILED.
C
	INCLUDE 'OPTSPC.FOR'
	REAL BUFF(NMAX,NMAX)
C
	COMMON /PHKDAT/ X8
C
C
	OUTF=USEOUT
C		
C	INITIALIZE DATA.  X VALUES ARE COSZ.  ALL POINTS WEIGED EQUALLY
C	IF ZERO OR NEGATIVE, GIVEN WEIGHT OF ZERO.
C
	IF (NPT.GT.MAXDAT+1) THEN
		WRITE (6,*) 'INCREASE MAXDAT IN OPTSC.FOR'
		IND=-4
	ELSEIF (NPT.LT.4) THEN
		WRITE (6,*) 'KZSFIT:  Too few Z''s to optimize.',
     &           '  NPT = ',NPT
		IND=-3
		RETURN
	ENDIF
C
C	MUST BE SUFFICINET RANGE IN Z'S TO OPT.  CAN'T FIGURE P(4)
C	UNLESS VALUES GIVEN FOR Z>80.
C
	IF (ZANG(1).GE.15.0) THEN
		WRITE (6,*) 'Can''t opt.  Z(1) =',ZANG(1)
		IND=-2
		RETURN
	ELSEIF (ZANG(NPT).LE.45.0) THEN
		WRITE (6,*) 'Can''t opt.  Z(NPT) =',ZANG(NPT)
		IND=-2
		RETURN
	ENDIF
C
C	FIGURE ORDER AND HIGHEST ANGLE BELOW IMETH+delta.  IF NONE, DON'T
C	FIGURE P(4)
C
	IF (IMETH.GT.0) THEN
		Z8=FLOAT(IMETH)
		NPT8=1
		DO 4 I=2,NPT
		IF (ZANG(I).LE.ZANG(I-1)) THEN
			WRITE (6,*) 'Bad Z angle order,  I = ',I
			IND=-2
			RETURN
		ENDIF
		IF (ZANG(I).LE.Z8) NPT8=I
    4		CONTINUE
C
		IF (NPT8.EQ.NPT) THEN
			N=3
		ELSE
			N=4
		ENDIF
		NTOT=4
	ELSEIF (IMETH.EQ.-3) THEN
		N=3
	ELSEIF (IMETH.EQ.-2) THEN
		N=2
	ELSE
		WRITE (6,*) 'Unrecognized IMETH code = ',IMETH
		IND=-5
		RETURN
	ENDIF
C
C
C	INITILAIZE
C
	FRUNC=0.0	! USE WEIGHT ARRAY
	SENS=0.0
C
	DO 12 I=1,NPT
	IF (PHOT(I).GT.0.0) THEN
		WEIGHT(I)=1.0
	ELSE
		WEIGHT(I)=0.0
	ENDIF
	X(I)=COS(1.745329E-2*ZANG(I))
  12	Y(I)=PHOT(I)
	IF (N.GE.4) X8=COS(1.745329E-2*Z8)
C
	NPTS=NPT+1
	X(NPTS)=0.0
	Y(NPTS)=0.0
	WEIGHT(NPTS)=1.0
C
C
C	FIGURE INITIAL PARMS.
C	USE ZERO AND 45 DEG TO ESTIMATE PARMS
C
	DO 20 I=1,NPT
	IF (ZANG(I).GT.35.0) THEN
		I35=I
		GOTO 21
	ENDIF
   20	CONTINUE
   21	CONTINUE
C
	NPTM=NPT-1
C
	ZCHK15=(1.0/X(I35))-(1.0/X(1))
C
	PARMS(2)=ALOG(Y(1)/Y(I35))/ZCHK15
	PARMS(1)=Y(1)*EXP(PARMS(2))
	PARMS(3)=0.0
	IF (IMETH.GT.0) THEN
		PARMS(4)=2.0
	ELSE
		PARMS(4)=0.0
	ENDIF
	IF (N.EQ.4.AND.Y(NPTM).GT.0.0) THEN
		IF (Y(NPT)/Y(NPTM).GT.1.E-3) THEN
			PARMS(4)=ALOG(Y(NPT)/Y(NPTM))/
     &                   ALOG(X(NPT)/X(NPTM))
			IF (PARMS(4).LT.0.0) PARMS(4)=0.0
		ELSE
			N=3
		ENDIF
	ENDIF
C
	DPARMS(1)=0.001		!CHANGE IN A TO CALC DERIV'S
	DPARMS(2)=0.001		!CHANGE IN B
	DPARMS(3)=0.007		!CHANGE IN E**2
	DPARMS(4)=0.001         !CHANGE IN F
C
C
C	WRITE PARMS, ETC
C
   30	IF (OUTF) WRITE (3,102) (I,PARMS(I),DPARMS(I),I=1,N)
  102	FORMAT ('     INITIAL PARM    INCREMENT'/(I4,1P2G14.4))
	IF (NTOT.GT.N) THEN
		N1=N+1
		IF (OUTF) WRITE (3,103) (I,PARMS(I),I=N1,NTOT)
  103		FORMAT (/'     PARMS HELD FIXED'/(I4,1PG14.4))
		DO 105 I=N1,NTOT
  105		B(I)=PARMS(I)
	ENDIF
C
C	DO WEIGHING, DEPENDING ON FRUNC AND SENS
C	THIS VERSION: ALL POINTS HAVE EQUAL WEIGHT.  FRUNC AND SENS
C	IGNORED.
C
	IF (OUTF) WRITE (3,112)
  112	FORMAT (/'ALL POINTS WEIGHED EQUALLY')
C
C
C	END INITIALIZIATION.  GET CALCULATED VALUES AND CHISQR FOR
C	INITIAL PARM SET.
C
	CALL EVALF (YFIT,PARMS)
C
	CHISQR=0.0
	DO 310 I=1,NPTS
  310	CHISQR=CHISQR+WEIGHT(I)*(Y(I)-YFIT(I))**2
C	WRITE (6,312) CHISQR
C  312	FORMAT (' INITIAL CHISQR =',1PG12.3)
C
	NITER=0
	CHILST=0.0
	FLALST=0.0
	MAXITR=50
C
C	*NEXT ITERATION:  DISPLAY CURRENT FIT.
C
  400	IF (OUTF) WRITE (3,402)
  402	FORMAT (/7X,'X',11X,'Y',11X,'Y(CALC)',4X,'DIFF',8X,'WEIGHT')
	DO 410 I=1,NPTS
	DIFF=Y(I)-YFIT(I)
  410	IF (OUTF) WRITE (3,412) I,X(I),Y(I),YFIT(I),DIFF,WEIGHT(I)
  412	FORMAT (I3,1P5G12.4)
	IF (NITER.EQ.0) GOTO 500
C
C	AUTOMATIC ITERATION.  ABORT IF MAX ITERATIONS EXCEEDED.
C
C	WRITE (6,422) NITER,CHISQR,FLAMDA
C  422	FORMAT (' NITER=',I3,', CHISQR=',1PG12.3,', FLAMDA=',
C     &	 G12.3,'.')
	IF (NITER.GE.MAXITR) THEN
		IND=0
		RETURN
	ENDIF
	IF (CHISQR.EQ.0.0) GOTO 900
	IF (CHILST.NE.0.0.AND.(CHISQR/CHILST.GT.0.999999
     &	 .AND.(FLAMDA.EQ.FLALST.OR.FLAMDA.LT.1.0E-20))) THEN
		CHILST=0.0
		FLALST=0.0
		GOTO 900
	ELSE
		CHILST=CHISQR
		FLALST=FLAMDA
	ENDIF
C
C	CALCULATE NEXT ITERATION
C
  500	NITER=NITER+1
	CALL CRVFIT (BUFF)
	IF (ABORT) THEN
		WRITE (6,*) 'OPT FAILED IN CRVFIT.'
		IND=0
		RETURN
	ENDIF
C
	IF (OUTF) WRITE (3,502) NITER,CHISQR,FLAMDA,
     &	 (I,PARMS(I),SIGMA(I),I=1,N)
  502	FORMAT (///'ITERATION',I4,':  CHISQR =',1PG13.4,
     &   ', FLAMDA =',G13.4//7X,'PARM',8X,'SIGMA'/(I3,1P2G12.4))
C
	GOTO 400
C
C	DONE
C
  900	IF (OUTF) WRITE (3,902)
  902	FORMAT (//37('*'),' DONE ',36('*'))
C
C
	DO 910 I=1,NPT
  910	PFIT(I)=YFIT(I)
C
	IF (PARMS(3).LT.0.0) PARMS(3)=0.0
	DO 920 I=1,N
	PRMARG(I)=PARMS(I)
  920	SIGARG(I)=SIGMA(I)
	IF (N.LT.NTOT) THEN
		DO 922 I=N+1,NTOT
		PRMARG(I)=PARMS(I)
  922		SIGARG(I)=-1.0
	ENDIF
	CHIARG=CHISQR
	IND=N
	RETURN
	END	
C 
C ------------------------------------------------------------------------------
	SUBROUTINE EVALF (YCALC,P)
C
C	THIS SUBROUTINE EVALUATES THE CALCULATED DEPENDENT VARIABLE
C	BASED ON THE PARMS GIVEN IN THE ARGUMENT
C
C
C		Z <= 78 DEG:
C		SDIST(Z) = A * EXP ( -B * SQRT ((1.0 + E)/(COSZ**2 + E)))
C
C		Z > 78 DEG; LE 90:
C		SDIST(Z) = SDIST(78) * (COS(Z)/COS(78))**F
C
	COMMON /PHKDAT/ X8
C
C	YCALC	= ARRAY OF NPTS CALCULATED VALUES (OUTPUT)
C	P	= ARRAY OF PARMS TO USE (INPUT)
C
	INCLUDE 'OPTSPC.FOR'
	REAL*4 YCALC(MAXDAT),P(NMAX)
C
C
	LOGICAL NOHI
C
C
C	IF P3 IS OPTIMIZED AND GOES NEGATIVE, FORCE IT TO -1,
C	AND REMOVE IT.
C
	IF (N.EQ.-2) THEN
		ABSP3=0.0
	ELSEIF (P(3).GE.0.0) THEN
		ABSP3=P(3)
		YCALC(NPTS)=1.0E-6
	ELSE
		ABSP3=0.0
		YCALC(NPTS)=(1.+P(3))*1.0E-6
	ENDIF
C
	IF (N.GE.4) THEN
		Y8=P(1)*EXP(-P(2)*SQRT((1.0+ABSP3)/(X8**2+ABSP3)))
		NOHI=.FALSE.
	ELSE
		NOHI=.TRUE.
	ENDIF
C
	DO 20 I=1,NPTS-1
	IF (NOHI.OR.(X(I).GE.X8)) THEN
		YCALC(I)=P(1)*EXP(-P(2)*SQRT((1.0+ABSP3)/
     &           (X(I)**2+ABSP3)))
	ELSE
		YCALC(I)=Y8*(X(I)/X8)**P(4)
	ENDIF
  20	CONTINUE
C
	END
C 
C ------------------------------------------------------------------------------
	SUBROUTINE CRVFIT (ARRAY)
C
C	SUBROUTINE TO DO NON-LINEAR OPTIMIZATION
C
C	MODIFIED VERSION BASED ON SUBROUTINE OF SAME NAME IN 
C	"DATA REDUCTION AND ERROR ANALYSIS FOR THE PHYSICAL
C	SCIENCES", P. R. BEVINGTON, MC GRAW-HILL, 1969, P.216
C
C	WEIGHTS ALREADY ASSUMED CALCULATED.
C
C	UPON CALLING, YFIT ASSUMED TO HAVE CALCULATED
C	VALUES FOR THIS SET OF PARMS AND CHISQR.
C	ALSO, PARMS, CHANGE, ASSUMED TO BE DEFINED.
C
C	"EVALF" USED TO CALCULATE ALL Y VALUES AT ONCE.
C
	INCLUDE 'OPTSPC.FOR'
C
	REAL*4 ALPHA(NMAX,NMAX),BETA(NMAX),ARRAY(N,N),
     &	 DERIV(MAXDAT,NMAX)
C
C
	ABORT=.FALSE.
C
C
C	CALCULATE DERIVITIVES.  DERIV USED TO SAVE DERIVITIVES OF CALC Y'S
C	WRT PARMS.
C
	IF (FLAMDA.EQ.0.0) FLAMDA=10.
	CHISQ1=CHISQR
C**
	IF (OUTF) WRITE (3,10) CHISQR
   10	FORMAT (/'CRVFIT:  INITIAL CHISQR =',1PG12.3)
C*
	DO 100 J=1,N
	AJ=PARMS(J)
	PARMS(J)=AJ+DPARMS(J)
	CALL EVALF (DERIV(1,J),PARMS)
	PARMS(J)=AJ
	DO 100 I=1,NPTS
  100	DERIV(I,J)=(DERIV(I,J)-YFIT(I))/DPARMS(J)
C
C	CALCULATE ALPHA AND BETA MATRICIES
C
	DO 200 J=1,N
	AJ=0.0
	DO 202 K=1,J
  202	ALPHA(J,K)=0.0
	DO 210 I=1,NPTS
	WTI=WEIGHT(I)*DERIV(I,J)
	AJ=AJ+WTI*(Y(I)-YFIT(I))
	DO 210 K=1,J
  210	ALPHA(J,K)=ALPHA(J,K)+WTI*DERIV(I,K)
	BETA(J)=AJ
	IF (J.EQ.1) GOTO 200
	JM=J-1
	DO 220 K=1,JM
  220	ALPHA(K,J)=ALPHA(J,K)
  200	CONTINUE
C**
	IF (OUTF) THEN
		WRITE (3,13) (I,I=1,N)
   13		FORMAT (/5X,'BETA',17X,'ALPHA'/5X,'----',3X,5I12,:/
     &           (12X,5I12,:))
		DO 14 I=1,N
   14		WRITE (3,16) I,BETA(I),(ALPHA(I,J),J=1,I)
   16		FORMAT (I2,1PG12.3,4X,5G12.3,:/(18X,5G12.3))
	ENDIF
C*
C
C	INVERT MODIFIED CURVATURE MATRIX TO FIND NEW PARMS
C
  400	FL1=1.0+FLAMDA
	IF (N.EQ.1) GOTO 416
	ARRAY(1,1)=FL1
	IF (ALPHA(1,1).LE.0.0) THEN
		J=1
		GOTO 412
	ENDIF
	DO 410 J=2,N
	IF (ALPHA(J,J).LE.0.0) GOTO 412
	JM=J-1
	DO 402 K=1,JM
	ARRAY(J,K)=ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
  402	ARRAY(K,J)=ARRAY(J,K)
  410	ARRAY(J,J)=FL1
C
	CALL VERTX (N,ARRAY)
	GOTO 417
C
C	BAD ALPHA
C
  412	IF (OUTF) WRITE (3,*) 'BAD ALPHA FOR PARM ',J
	WRITE (6,*) 'BAD ALPHA FOR PARM ',J
	ABORT=.TRUE.
	RETURN
C
C	ONLY ONE PARM
C
  416	ARRAY(1,1)=1.0/FL1
C
C	DONE WITH INVERT
C
  417	DO 420 J=1,N
	AJ=PARMS(J)
	DO 418 K=1,N
	SQAA=SQRT(ALPHA(J,J)*ALPHA(K,K))
	IF (SQAA.EQ.0.0) THEN
		IF (OUTF) WRITE (3,*) 'BAD ALPHA.  K, J =',K,J
		WRITE (6,*) 'BAD ALPHA.  K, J = ',K,J
		ABORT=.TRUE.
		RETURN
	ENDIF
  418	AJ=AJ+BETA(K)*ARRAY(J,K)/SQAA
  420	B(J)=AJ
C
C	FIND WHAT NEW CHISQR IS FOR  NEW PARMS
C
	CALL EVALF (YFIT,B)
C
	CHISQR=0.0
	DO 430 I=1,NPTS
  430	CHISQR=CHISQR+WEIGHT(I)*(Y(I)-YFIT(I))**2
C
C	IF THIS IS NOT AN IMPROVMENT, TRY AGAIN WITH LARGER FLAMDA
C
	IF (CHISQR.LE.CHISQ1) GOTO 500
C**
	IF (OUTF) WRITE (3,20) CHISQR
   20	FORMAT (/'NEW CHISQR =',1PG12.3,' WORSE.  TRY AGAIN.')
C
	FLAMDA=FLAMDA*10.0
	IF (FLAMDA+0.01.EQ.FLAMDA) THEN
		ABORT=.TRUE.
		RETURN
	ENDIF
	GOTO 400
C
C	DONE WITH STEP.  SAVE NEW PARMS IN A AND EVALUATE THEIR UNC'S.
C
  500	FLAMDA=FLAMDA/10.0
	DO 502 J=1,N
	PARMS(J)=B(J)
  502	SIGMA(J)=SQRT(ARRAY(J,J)/ALPHA(J,J))
	RETURN
	END
