	SUBROUTINE VSDSUB (IUNIT,LVSDNM,VSDNAM,LMODNM,MODNAM)
C
C	LIKE VSDSUB EXCEPT READS ASCII (.VSA) FILES RATHER THAN .VSD FILES
C
C	PRODUCES .INT FILES WITH CALCULATES TIME-VARYING PHOTOLYSIS
C	RATES GIVEN .INS FILES WITH TIME VARYING SPECTRAL DISTRIBUTIONS.
C	GETS ABSQY'S FROM ABSQY'S FROM .MOD FILE REFERENCED BY MODEL=Model
C	INPUT LINE.
C
C	USES UNITS = 7 AND 8 TO READ FILES.
C
C	ARGUMENTS:
C
C	IUNIT = OUTPUT UNIT.  MUST BE OPEN.  IF ERROR OCCURS, SETS THIS
C		TO ZERO, AND CLOSES AND DELETES FILE ON UNIT.
C	LVSDNM,VSDNAM = NAME LENGTH AND NAME OF .VSA FILE (W/O EXTENSION)
C	LMODNM,MODNAM = NAME LENGTH NAME OF .MOD FILE (W/O EXTENSION)
C		(ABOVE CAN GIVE FULL PATH NAME, EXCEPT EXTENSION)
C
C	CALLS:	PFALIN, IOFILE
C
C
	INTEGER IUNIT,LVSDNM,LMODNM
	CHARACTER*40 VSDNAM,MODNAM
C
	CHARACTER*80 INLIN
C
C	SPECTRAL DISTRIBUTION DATA
C
	PARAMETER (MAXWL=250,MAXWL1=MAXWL+1)
	INTEGER NWL
	REAL*4 WL(MAXWL1),SDIST(MAXWL),SDFAC
C
C	ABSQY DATA (FROM .MOD FILE)
C
	PARAMETER (MAXAQ=1000,MAXAQS=8000)
	INTEGER NPWL
	REAL*4 PWL(MAXAQ),AQ(MAXAQ)
C
C	PHOTOLYSIS RATE CONSTANTS
C
	PARAMETER (MAXTIM=200,MAXPHK=40)
	INTEGER NPHOTK
	CHARACTER*8 PHOTNM(MAXPHK)
C-P
C.	REAL*4 PHOTKS,ABSQY(MAXWL,MAXPHK),TIME(MAXTIM)
C.	VIRTUAL PHOTKS(MAXTIM,MAXPHK)
C-I
	REAL*4 ABSQY(MAXWL,MAXPHK),TIME(MAXTIM),PHOTKS(MAXTIM,MAXPHK)
C
C	FOLLOWING USED IF HEIGHT METHOD IMPLEMENTED
C
C	REAL*4 PWLS(MAXAQS),ABSQYS(MAXAQS)
C	INTEGER NPWLS(MAXPHK),IPWLS(MAXPHK)
C-
	CHARACTER*8 FORM
C	FOLLOWING COMMON ADDED JUST TO GET RID OF WARNING MESSAGES
C	FOR UNUSED MECHANISM VARIABLES.
	COMMON /DUMMOD/TEMPR,TREF,FORM,NS,NNDY,NSC,NSB,NDUM,NRK,
     &	 NCOEFV,NCOC1,NCOC2,NPHOTK,LOCKBF,NC,LOCIBF,NVTEMP,NVTCO
C
C	------------------------------------------------------------
C	INPUT/OUTPUT BUFFERS (USED TO COMMUNICATE WITH INBUF)
C	------------------------------------------------------------
C
	LOGICAL*1    SHOW, NOKEY
	INTEGER    IN, IOLEN, IORET
	CHARACTER    IOB160*160, IOBF16*16
C 
	COMMON /IOBUF/ IN,IOLEN,IORET,MAXUNT,NOKEY,SHOW
	COMMON /IOBFCH/ IOBF16,IOB160
C	------------------------------------------------------------
C	STANDARD FILE UNIT SPECIFICATIONS
C	------------------------------------------------------------
C
	INTEGER ICRT,IKEY,UNIT1,UNIT2
	PARAMETER (ICRT=6,IKEY=5)
	PARAMETER (UNIT1=7,UNIT2=8)
C
C	------------------------------------------------------------
C	LOCAL VARIABLES
C	------------------------------------------------------------
C
	LOGICAL EX
C
C	FUNCTION TO SEE HOW MANY RECORDS IT TAKES TO READ I1 DATA
C	VALUES AT I2 VALUES PER RECORD
C
	NSKPRC(I1,I2)=1+((I1-1)/I2)
C
C
C	OPEN VSD FILE AND READ INITIAL RECORDS.
C
	INLIN=VSDNAM(1:LVSDNM)
	INLIN(LVSDNM+1:LVSDNM+4)='.VSA'
C
	INQUIRE (FILE=INLIN,EXIST=EX)
	IF (.NOT.EX) GOTO 850
	OPEN (UNIT=UNIT1,FILE=INLIN,STATUS='OLD')
C
	READ (UNIT1,'(8X,I4,E12.4)',ERR=810) NWL,SDFAC
	IF (NWL.GT.MAXWL) THEN
		WRITE (ICRT,*) 'INCREASE MAXWL IN VSDSUB',NWL
		GOTO 880
	ENDIF
	READ (UNIT1,'(10X,10F12.4)',END=810,ERR=810) (WL(I),I=1,NWL+1)
C
C	OPEN .MOD FILE FOR INPUT.  (FOR PDP SUPPRESS ERROR MESSAGE IF
C	FILE CAN'T BE OPENED.)
C
	INLIN=MODNAM(1:LMODNM)
	INLIN(LMODNM+1:LMODNM+4)='.MOD'
C
	OPEN (UNIT=UNIT2,FILE=INLIN,STATUS='OLD',ERR=830)
C
	READ (UNIT2,'(A8/A20/12I6/2F10.3,3I6)') FORM,IOB160(1:80),NS,NNDY,
     &	 NSC,NSB,NDUM,NRK,NCOEFV,NCOC1,NCOC2,NPHOTK,LOCKBF,LOCIBF,
     &	 TEMPR,TREF,NC,NVTEMP,NVTCO
C
	IF (NPHOTK.EQ.0) THEN
		WRITE (ICRT,*) 'NO PHOTOLYSES IN .MOD FILE'
		GOTO 880
	ELSEIF (NPHOTK.GT.MAXPHK) THEN
		WRITE (ICRT,*) 'INCREASE MAXPHK IN VSDSUB'
		GOTO 880
	ENDIF
C
C	SKIP FOLLOWING:
C
C	READ (TMP1,303) INDLIL,INDHV,INDDIL,INDTPR,INDHT,INDARA,
C     &                  INDVOL,INDEF,INDER,INDVA,INDATM
C  303	FORMAT (11I6)
	NSKP=1
C
C	IF (NSC.GT.0) READ (TMP1,304) (NAME(I),CINIT(I),I=1,NSC)
C  304	FORMAT (A16,1PE14.6,2X,A16,E14.6)
	IF (NSC.GT.0) NSKP=NSKP+NSKPRC(NSC,2)
C
C	READ (TMP1,305) (NAME(I),I=NB1,NS);  NB1=NSC+1
C  305	FORMAT (5A16)
	NSKP=NSKP+NSKPRC(NS-NSC,5)
C
C	IF (NCOEFV.GT.0) READ (TMP1,306) (COEFNM(I),OLDCOE(I),I=1,NCOEFV)
C  306	FORMAT (3(A8,1PE14.6,4X))
	IF (NCOEFV.GT.0) NSKP=NSKP+NSKPRC(NCOEFV,3)
C
C	IF (NCOC2.GE.NCOC1) READ (TMP1,307) (COEF(I),I=NCOC1,NCOC2)
C  307	FORMAT (1P6E13.6)
	IF (NCOC2.GE.NCOC1) NSKP=NSKP+NSKPRC(NCOC2-NCOC1+1,6)
C
	IF (NVTCO.GT.0) THEN
C		READ (TMP1,307) (VTEMP(I),I=1,NVTEMP)
C		READ (TMP1,309) (IVTCO(I),I=1,NVTCO)
C  309		FORMAT (16I5)
		NSKP=NSKP+NSKPRC(NVTEMP,6)+NSKPRC(NVTCO,16)
		DO 3 I=1,NVTCO
C  3		READ (TMP1,307) (VTCO(I,IT),IT=1,NVTEMP)
   3		NSKP=NSKP+NSKPRC(NVTEMP,6)
	ENDIF
C
	READ (UNIT2,'(A)') (IOBF16,I=1,NSKP)
C
C	READ AND ALLIGN ABSQY DATA
C
	IF (SDFAC.GT.0.0) THEN
		DO 1030 IPHOT=1,NPHOTK
		READ (UNIT2,'(I5,2X,A8)') I,PHOTNM(IPHOT)
		READ (UNIT2,'(I5/(6E13.3))') NPWL,(PWL(I),AQ(I),I=1,
     &		 NPWL)
		IF (NPWL.GT.MAXAQ) THEN
			WRITE (ICRT,*) 'INCREASE MAXAQ IN VSDSUB'
			GOTO 880
		ENDIF
C
 1030		CALL PFALIN (ABSQY(1,IPHOT),NPWL,PWL,AQ,NWL,WL)
	ELSE
		WRITE (ICRT,*) 'NEGATIVE SDFAC IN .VSA ',
     &		 'FILE NOT SUPPORTED'
		GOTO 880
C
C		LPWLS=0
C		DO 1032 IPHOT=1,NPHOTK
C		READ (UNIT2,'(I5,2X,A8)') I,PHOTNM(IPHOT)
C		READ (UNIT2,'(I5/(6E13.3))') NPWL,(PWL(I),AQ(I),I=1,
C     &		 NPWL)
C		IF (NPWL.GT.MAXAQ) THEN
C			WRITE (ICRT,*) 'INCREASE MAXAQ IN VSDSUB'
C			GOTO 880
C		ENDIF
C		IF (NPWL+LPWLS.GT.MAXAQS) THEN
C			WRITE (ICRT,*) 'INCREASE MAXAQS IN VSDSUB'
C			GOTO 880
C		ENDIF
C		NPWLS(IPHOT)=NPWL
C		IPWLS(I)=LPWLS+1
C		DO 1033 I=1,NPWL
C		LPWLS=LPWLS+1
C		ABSQYS(LPWLS)=AQ(I)*PWL(I)
C 1033		PWLS(LPWLS)=PWL(I)
C 1032		CONTINUE
	ENDIF
C
	CLOSE (UNIT=UNIT2)
C
	NTIM=0
C
C	READ TIME DATA UNTIL NEGATIVE TIME INPUT.
C
 1100	NTIM=NTIM+1
	IF (NTIM.GT.MAXTIM) THEN
		WRITE (ICRT,*) 'INCREASE MAXTIM IN VSDSUB'
		GOTO 880
	ENDIF
C
	READ (UNIT1,'(F8.1,2X,10F12.6/(10X,10F12.6))',END=1200)
     &	 TIME(NTIM),(SDIST(I),I=1,NWL)
C
C
C	CALCULATE PHOTOLYSIS RATES
C
	IF (SDFAC.GT.0.0) THEN
C
C		POSITIVE SDFAC -- AREA METHOD
C
		DO 1110 IPHOT=1,NPHOTK
		X=0.0
		DO 1112 I=1,NWL
 1112		X=X+SDIST(I)*ABSQY(I,IPHOT)
 1110		PHOTKS(NTIM,IPHOT)=X*SDFAC
	ELSE
C
C		NONPOSITIVE SDFAC -- "HEIGHT" METHOD
C
C		IF (SDFAC.EQ.0.0) THEN
C			SDFAC=1.0
C		ELSE
C			SDFAC=-SDFAC
C		ENDIF
C		DO 1113 IPHOT=1,NPHOTK
C		L=IPWLS(IPHOT)
C 1113		PHOTKS (NTIM,IPHOT)=SDFAC*HAREA(NPWLS(IPHOT),
C     &		 PWLS(L),ABSQYS(L),NWL,WL,SDIST)
	ENDIF
C
	GOTO 1100
C
C	ALL DATA INPUT.  PROCESS OUTPUT
C
 1200	NTIM=NTIM-1
	CLOSE (UNIT=UNIT1)
	IF (NTIM.EQ.0) GOTO 900
C
	DO 1210 IPHOT=1,NPHOTK
	WRITE (IUNIT,'(''L#'',A)') PHOTNM(IPHOT)
 1210	WRITE (IUNIT,'(0PF8.2,1PE12.3)') (TIME(I),PHOTKS(I,IPHOT),
     &	 I=1,NTIM)
	GOTO 900
C
C	ERRORS
C
  810	WRITE (ICRT,*) 'ERROR READING #VARYSD INPUT DATA'
	GOTO 880
  830	WRITE (ICRT,*) 'CAN''T OPEN ',INLIN(1:LMODNM+4)
	GOTO 880
  850	WRITE (ICRT,*) 'ERROR OPENING ',INLIN(1:LVSDNM+4)
C
  880	CLOSE (UNIT=IUNIT,STATUS='DELETE')
	IUNIT=0
	RETURN
C
C	DONE
C
  900	RETURN
	END
