	FUNCTION PHOTK (PHTNAM,IND)
C
C	READ ABS, QY DATA FROM DATA SET = [100,50](PHTNAM).PHF
C	AND CALCULATE PHOT K IF SDIST DEFINED.
C
C	IF (PHTNAM) IS BLANK, THEN CALCULATE PHOT K USING
C	ABS, QY DATA ALREADY READ IN.
C
C	IND IS ERROR INDICATOR.  0 = NO ERROR
C
C	NOTE:  MODE = INDICATOR AS TO WHETHER ABSQY DATA HAS BEEN
C	PROCESSED FOR PHOTK CALC.
C	MODE = 0 ... NOT PROCESSED
C	       1 ... PROCESSED FOR 'HEIGHT' CALC
C	       2 ... PROCESSED FOR 'AREA' CALC.
C
	INTEGER MODE
	REAL*8 QW1,QW2,QI1,QI2,QS1,QS2,QPHK
C
	LOGICAL ERRIND
	CHARACTER PHTNAM*8,INLIN*80,BUF*8
C
	INCLUDE 'PHOTSPCS.FOR'
C
C	INITIALIZE
C
	PHOTK=0.0
	AVGWL=0.0
	IF (PHTNAM(1:1).EQ.' ') GOTO 30
	NWL=0
C----------------------------------------------------------------------
C	IF PHOTK DATA NEED TO BE READ IN:
C	OPEN PHOTK DATA SET ON UNIT=UNIT1
C
	INLIN=PHFUIC
	INLIN(LPHFUC+1:80)=PHTNAM
	L=LNBLNK(INLIN)
	INLIN(L+1:L+4)='.PHF'
	OPEN (UNIT=UNIT1,FILE=INLIN,STATUS='OLD',ERR=69)
C
	READ (UNIT1,1,END=70,ERR=70) INLIN
    1	FORMAT (A)
C
	NWL=0
	F=1.0
   52	READ (UNIT1,1,ERR=73,END=75) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 52
	IF (INLIN(1:8).EQ.'        ') GOTO 75
	IF (INLIN(1:3).EQ.'FAC') THEN
		IF (INLIN(4:4).EQ.'=') INLIN(4:4)=' '
		CALL PARSE0 (2,INLIN,80)
		CALL PARSER (2,F,ERRIND,INLIN)
		IF (ERRIND) GOTO 73
		IF (F.LE.0.0) GOTO 73
	ELSE
		NWL=NWL+1
		IF (NWL.GT.MAXNWL) GOTO 74
		CALL PARSE0 (3,INLIN,80)
		CALL PARSER (1,PWL(NWL),ERRIND,INLIN)
		IF (ERRIND) GOTO 73
		CALL PARSER (2,AP(NWL,1),ERRIND,INLIN)
		IF (ERRIND) GOTO 73
		IF (NOQY) THEN
			AP(NWL,1)=AP(NWL,1)*F
		ELSE
			CALL PARSE1 (3,BUF,L,8,INLIN)
			IF (BUF(1:1).EQ.' ') THEN
				AP(NWL,1)=AP(NWL,1)*F
			ELSE
				CALL PARSER (3,X,ERRIND,INLIN)
				IF (ERRIND) GOTO 73
				AP(NWL,1)=AP(NWL,1)*F*X
			ENDIF
		ENDIF
C-D
C.		WRITE (ICRT,*) 'READ=',NWL,PWL(NWL),AP(NWL,1)
C-
		IF (NWL.GT.1) THEN
			IF (PWL(NWL).LT.PWL(NWL-1)) GOTO 7402
		ENDIF
	ENDIF
	GOTO 52
C
C
   69	WRITE (ICRT,*) 'PHOTOLYSIS FILE COULD NOT BE OPENED.'
	GOTO 72
C
   70	WRITE (ICRT,*) 'PHOTOLYSIS FILE HAS NO DATA'
	GOTO 72
C
   73	WRITE (ICRT,702) INLIN(1:LNBLNK(INLIN))
  702	FORMAT (' ',5X,'ERROR IN DECODING FILE INPUT. INPUT = ''',A,
     &   '''')
	GOTO 72
C
   74	WRITE (ICRT,*) 'TOO MANY WAVELENGTHS IN PHOTOLYSIS FILE'
	GOTO 72
C
 7402	WRITE (ICRT,*) 'WAVELENGTHS OUT OF ORDER IN PHOTOLYSIS FILE',
     &	 ' AT WL NO. ',NWL
C
   72	IND=2
	CLOSE (UNIT=UNIT1)
	RETURN
C
C	DATA SUCCESSFULLY READ IN.
C
   75	CLOSE (UNIT=UNIT1)
	IF (NOQY) WRITE (ICRT,*) 'Quantum yields (if any) ignored'
	MODE=0
C
C----------------------------------------------------------------------
C	CALCULATE PHOTK (IF SDIST DEFINED)
C
   30 	IF (NSWL.LE.1) GOTO 900
	IF (NWL.LE.1) GOTO 900
C
	IF (SDAREA.AND.MODE.NE.2) THEN
C
C		FOR 'AREA' METHOD, CALCULATE AREAS FOR EACH INTERVAL
C		SWL(I) TO SWL(I+1), AND SAVE IN AP(*,2).
C
		MODE=2
C-D
C.		WRITE (ICRT,*) 'PHOTK AREA METHOD'
C-
		CALL PFALIN (AP(1,2),NWL,PWL,AP,NSWL,SWL)
C
	ELSEIF ((.NOT.SDAREA).AND.MODE.NE.1) THEN
C
C		FOR 'HEIGHT' METHOD, CALCULATE SLOPE, INTERCEPT FOR
C		ABS*QY FOR EACH WAVELENGTH INTERVAL.
C-D
C.		WRITE (ICRT,*) 'PHOTK HEIGHT METHOD'
C-
		MODE=1
		KK=NWL-1
		DO 202 I=1,KK 
		IP=I+1
		ABSQYI=AP(I,1)
		FF=PWL(IP)-PWL(I)
		IF (FF.EQ.0.0) THEN
			AP(I,2)=0.0
		ELSE
			AP(I,2)=(AP(IP,1)-ABSQYI)/FF
		ENDIF
 202		AP(I,1)=ABSQYI-AP(I,2)*PWL(I)
C-D
C.		WRITE (ICRT,*) 'AP='
C.		DO 8202 I=1,KK
C.8202		WRITE (ICRT,*) AP(I,1),AP(I,2)
C-
	ENDIF
C----------------------------------------------------------------------
C
C	INITIALIZED FOR PHOTK CALC.  CALC PHOTK.
C
	IF (SDAREA) THEN
C
C		CALCULATE PHOTK FOR SDIST IN UNITS OF PHOTONS/CM2/MIN,
C		WHERE SDIST(I) GIVES SDIST FOR THE INTERVAL SWL(I) - SWL(I+1)
C		('AREA' METHOD).
C
		DO 80 I=1,NSWL
		PKI=SDISTR(I)*AP(I,2)
		AVGWL=AVGWL+PKI*SWL(I)
   80		PHOTK=PHOTK+PKI
C
C----------------------------------------------------------------------
	ELSE
C
C		CALCULATE PHOTK FOR SDIST IN UNITS OF PHOTONS/CM2/MIN/MICRON
C		('HEIGHT' METHOD)
C
C  -	  FIND LOWEST WAVELENGTH WHERE BOTH SDIST AND ABS,QY DEFINED. 
C
      DO 211 I=1,NSWL
  211 ACTBUF(I)=0.0
C
      IP=1
      IS=1
      IF (PWL(1)-SWL(1)) 220,230,210
C  -    PWL(1) > SWL(1)
  210 ACTBUF(IS)=0.0
      IS=IS+1
      IF (IS.GT.NSWL) GOTO 900
      IF (PWL(1)-SWL(IS)) 215,230,210
  215 IPM=1
      IP=2
      IF (IP.GT.NWL) GOTO 900
      ISM=IS-1
      WL1=PWL(1)
      GOTO 310
C  -    SWL(1) > PWL(1)
  220 IP=IP+1 
      IF (IP.GT.NWL) GOTO 900
      IF (PWL(IP)-SWL(1)) 220,230,225
  225 ISM=1
      ACTBUF(1)=0.0
      IS=2
      IF (IS.GT.NSWL) GOTO 900
      IPM=IP-1
      WL1=SWL(1)
      GOTO 310
C  -    SWL(IS) = PWL(IP),  IS OR IP = 1
  230 IPM=IP
      ISM=IS
      IP=IP+1
      ACTBUF(IS)=0.0
      IS=IS+1
      WL1=PWL(IPM)
C  -	  MAIN LOOP.  QUIT WHEN SDIST OR ABS,QY NOT DEFINED.
C
  300 IF (IS.GT.NSWL) GOTO 900
      IF (IP.GT.NWL) GOTO 900
C
  310 IF (PWL(IP)-SWL(IS)) 330,340,320
C  -    PWL > SWL
  320 WL2=SWL(IS)
      ISM2=IS
      IPM2=IPM
C **BAD**      ACTBUF(IS)=SDISTR(IS)*(AP(IP,1)+(AP(IP,2)*WL2))
      IS=IS+1
      GOTO 350
C  -    SWL > PWL
  330 WL2=PWL(IP)
      IPM2=IP
      ISM2=ISM
      IP=IP+1
      GOTO 350
C  -    SWL = PWL
  340 WL2=SWL(IS)
      ISM2=IS
      IPM2=IP
C **BAD**      ACTBUF(IS)=SDISTR(IS)*(AP(IP,1)+(AP(IP,2)*WL2))
      IP=IP+1
      IS=IS+1
C  -	  CALCULATE AREA OF PRODUCT AND ADD TO PHOTK
C
  350 IF (WL1.EQ.WL2) GOTO 352
C-D
C.	WRITE (ICRT,*) 'ISM,SWL,A,BSD=',ISM,SWL(ISM),ASDIST(ISM),BSDIST(ISM)
C.	WRITE (ICRT,*) 'IPM,PWL,AP1,1=',IPM,PWL(IPM),AP(IPM,1),AP(IPM,2)
C.	WRITE (ICRT,*) 'WL1,WL2,OLD-PHOTK=',WL1,WL2,PHOTK
C-
C      WL1SQ=WL1*WL1
C      WL2SQ=WL2*WL2
C      PHOTK=PHOTK+AP(IPM,1)*ASDIST(ISM)*(WL2-WL1) +
C     1 0.5*(AP(IPM,1)*BSDIST(ISM)+ASDIST(ISM)*AP(IPM,2))*(WL2SQ-WL1SQ)
C     2 + AP(IPM,2)*BSDIST(ISM)*(WL2SQ*WL2-WL1SQ*WL1)/3.0
	QW1=WL1
	QW2=WL2
	QI1=ASDIST(ISM)
	QI2=AP(IPM,1)
	QS1=BSDIST(ISM)
	QS2=AP(IPM,2)
	QPHK=(QI1*QI2*(QW2-QW1))+(0.5*((QI1*QS2)+(QI2*QS1))*((QW2*QW2)
     &	 -(QW1*QW1)))+((QS1*QS2*((QW2**3)-(QW1**3)))/3.0)
	AVGWL=AVGWL+(0.5*QPHK*(WL1+WL2))
	ACTBUF(IS-1)=QPHK
	PHOTK=PHOTK+QPHK
C-D
C.	WRITE (ICRT,*) 'NEW TERM=',QPHK
C.	WRITE (ICRT,*) 'NEW PHOTK=',PHOTK
C-
      WL1=WL2
  352 ISM=ISM2
      IPM=IPM2
      GOTO 300
C
	ENDIF
C
C----------------------------------------------------------------------
C	PHOTK CALCULATED.
C
  900	IND=0
	IF (PHOTK.NE.0.0) THEN
		AVGWL=AVGWL/PHOTK
	ELSE
		AVGWL=0.
	ENDIF
	RETURN
	END
