	SUBROUTINE SOLAR (COSZ)
C
C	VERSION OF 5/86.  DIRECT EXTRAPOLATION OF PETERSON (1976)'S
C			  TABULATED ACTINIC FLUXES FOR 'BEST ESTIMATE'
C			  SURFACE ALBITOS.
C
C	DEFINES SDIST FOR SOLAR PHOTOLYSIS RATE CONSTANT CALCS.
C	ARGUMENT = SOLAR ZENITH ANGLE, IN DEGREES.
C
C	SDIST DEFINED AS TOTAL PHOTONS IN RANGE SPECIFIED BY SOLWL.
C
	INCLUDE 'PHOTSPCS.FOR'
C
	PARAMETER (HR24=1440.0,HR12=720.0,PI=3.1415927,
     &	 PID180=1.745329E-2,RADDEG=4.363323E-3)
C
C     ACTINIC FLUXES AS FUNCTION OF
C     ZENITH ANGLE FROM PETERSON (EPA-600/4-76-025) USING
C     'BEST ESTIMATE' SURFACE ALBEDOS (SEE TABLE 4, P. 21 AND APPENDIX B
C     ,P.51).   CALCULATED FLUXES WERE FOR O3STRT=0.295  CM-ATM, AND FLU
C     XES FOR DIFFERENT O3STRT CAN'T BE CALCULATED IN THIS VERSION.  FLUXES
C     FOR WL=290-700 CALCULATED EXPLICITLY.  SDIST DEFINED FOR 290-1000,
C     WITH 700-1000 ASSUMED TO BE CONSTANT.
C
C	THESE DATA ARE SPECIFIED IN PETERSON.FTN
C
	PARAMETER (NSOLWL=48,NSOLW1=49,NZS=10,NZSM=NZS-1)
	REAL*4 SOLWL(NSOLW1),SOLAF(NSOLWL,NZS),COSZS(NZS)
	COMMON /PETRSN/ SOLWL,COSZS,SOLAF
C
C
C-D
C.	WRITE (ICRT,*) 'COSZ=',COSZ
C-
	DO 1012 J=2,NZS
	IF (COSZ.GT.COSZS(J)) THEN
		I2=J-1
		I1=J
		F2=COSZS(I2)-COSZS(I1)
		F1=(COSZS(I2)-COSZ)/F2
		F2=(COSZ-COSZS(I1))/F2
		GOTO 1016
	ENDIF
 1012	CONTINUE
C
C	Z < MAX DEFINED
C
	F1=COSZ/COSZS(NZS)
	DO 1014 I=1,NSOLWL
	SWL(I)=SOLWL(I)
	ASDIST(I)=0.0
	BSDIST(I)=0.0
 1014	SDISTR(I)=F1*SOLAF(I,NZS)
	SWL(NSOLW1)=SOLWL(NSOLW1)
	GOTO 1018
C
C	0 < Z < MAX
C
 1016	DO 1010 I=1,NSOLWL
	SWL(I)=SOLWL(I)
	ASDIST(I)=0.0
	BSDIST(I)=0.0
 1010	SDISTR(I)=F1*SOLAF(I,I1)+F2*SOLAF(I,I2)
	SWL(NSOLW1)=SOLWL(NSOLW1)
C
 1018	NSWL=NSOLWL
C
C	INDICATE THAT 'AREA' METHOD TO BE USED.
C
	SDAREA=.TRUE.
	RETURN
	END
