       SUBROUTINE DIFFUN
C
C  --	CONDITIONAL COMPILATION: V = VAX, S OR B = RSX, I = PC
C
C      PRODUCES CODE FOR 'DIFFUN' SUBROUTINE
C      WHICH IS USED BY INTEGRATION PGM TO CALCULATE
C      DERIVITIVES FROM CONC'S
C
       EXTERNAL LOAD,STORE,ADD,MULT
C
	INCLUDE 'PSPECS.FOR'
C-
	PARAMETER (MAXIRP=MAXRXN*5,MAXSS1=MAXSS+1)
	INTEGER LRXBUF(MAXSS1),RXBUF(MAXIRP),RXBUF2(MAXIRP)
C
        LOGICAL CHANGE,SSSET(MAXSS),REACTS,FIRSTR
	INTEGER DFRATE(MAXRXN)
C
       INTEGER CBASE,KBASE,RBASE,COBASE,FBASE,YBASE,SBASE,LBASE
       PARAMETER (CBASE=0,KBASE=1,RBASE=2,COBASE=3,FBASE=4,YBASE=5,
     1 SBASE=6,LBASE=7)
C
C	BEGIN PRODUCING "DIFFUN" CODE!
C
C	DEFINE SPECIES GROUP CONCENTRATIONS
C
	IF (NSGRP.NE.0) THEN
		DO 80 ISGRP=1,NSGRP
		ID=SGRPID(ISGRP)
		FIRSTR=.TRUE.
		DO 82 I=1,NSGB
		IF (SGRP(I,2).EQ.ID) THEN
			IF (FIRSTR) THEN
				CALL LOAD (0,SGRP(I,1)-N0,YBASE)
				FIRSTR=.FALSE.
			ELSE
				CALL ADD (0,SGRP(I,1)-N0,YBASE)
			ENDIF
		ENDIF
   82		CONTINUE
   80		CALL STORE (0,ID,CBASE)
	ENDIF
C
C	DEFINE RATES OF REACTIONS NOT INVOLVING STEADY STATE SPECIES,
C	AND INDICATE THESE BY DFRATE=1.
C
C	NOTE THAT REACTIONS WHOSE RATE IS USED AS THE RATE CONSTANT
C	FOR ANOTHER MUST NOT HAVE STEADY STATE REACTANTS.
C
C	FOR REACTIONS WITH STEADY STATE REACTANTS, DEFINE PARTIAL RATE
C	IF IT HAS OTHER REACTANTS, AND INDICATE THESE BY DFRATE=0.  IF
C	THE STEADY STATE SPECIE IS THE ONLY REACTANT, DO NOTHING YET,
C	EXCEPT INDICATE THIS BY DFRATE=-1.
C
	DO 110 IRXN = 1,NRXN
	NR = NRTOSR (IRXN)
        IF (NR.LT.0) THEN		! DUMMY REACTION. NO RATE TO DEFINE.
                DFRATE(IRXN)=1
		GOTO 110
	ELSEIF (NR.EQ.1) THEN		! SEE IF ONLY REACTANT SS
		IF (IRTOSR(1,IRXN).GE.NS1.AND.IRTOSR(1,IRXN).LE.NS2)
     &		 THEN
			DFRATE(IRXN)=-1
			GOTO 110
		ENDIF
	ENDIF
	LKB=LKBUF(IRXN)
C	               					! MULT K BY CONC'S
	IF (RXTYP(IRXN).EQ.0) THEN
		IF (RXTYP(LKB).EQ.7) THEN
			CALL LOAD (0,IPHOTR(LKBUF(LKB)),COBASE)
		ELSEIF (RXTYP(LKB).EQ.8) THEN
			CALL LOAD (0,LKBUF(LKB),COBASE)
		ELSE
			CALL LOAD (0,LKB,KBASE)
		ENDIF
	ELSEIF (RXTYP(IRXN).EQ.1) THEN
		IF (LKB.GT.IRXN.OR.DFRATE(LKB).NE.1) THEN
			WRITE (OUT,*) 'ERROR.  RATE OF RXN'
     &			 ,LKB,' UNDEFINED.  CAN''T DEFINE '
     &			 ,'K FOR RXN',IRXN
			NERR=NERR+1
		ENDIF
		CALL LOAD (0,LKB,RBASE)
	ELSEIF (RXTYP(IRXN).EQ.7) THEN
		CALL LOAD (0,IPHOTR(LKB),COBASE)
	ELSEIF (RXTYP(IRXN).EQ.8) THEN
		CALL LOAD (0,LKB,COBASE)
	ELSE
		CALL LOAD (0,IRXN,KBASE)
	ENDIF
	DFRATE(IRXN)=1		! DFRATE=1 IF NO SS REACTANT FOUND
C
C	IF THERE ARE 2 REACTANTS AND ONE (RCT2) IS DUMMY AND A SUM GROUP
C	AND THE OTHER (RCT1) IS ACTIVE AND A MEMBER OF THAT GROUP, THEN
C	RATE IS K*[RCT1]+([RCT2+[RCT1])
C
	IF (NSUM.GT.0.AND.NR.EQ.2) THEN
		I1=IRTOSR(1,IRXN)	! I1 IS FOR THE ACTIVE REACTANT
		I2=IRTOSR(2,IRXN)	! I2 IS FOR THE SUM GROUP (DUMMY)
		IF (I1.GE.NA1.AND.I1.LE.NA2.
     &		 AND.I2.GE.ND1.AND.I2.LE.ND2) THEN
		    INDSUM=1
		ELSEIF (I2.GE.NA1.AND.I2.LE.NA2.
     &		 AND.I1.GE.ND1.AND.I1.LE.ND2) THEN
		    I3=I2
		    I2=I1
		    I1=I3
		    INDSUM=1
		ELSE
		    INDSUM=0
		ENDIF
		IF (INDSUM.EQ.1) THEN
		    IOBF16=NAME(I2)
		    DO 1071 ISUM=1,NSUM
			IF (IOBF16(1:8).EQ.SUMCOE(ISUM)) THEN
			    IOBF16=NAME(I1)
			    DO 1072 I=1,NSUMSP(ISUM)
				IF (IOBF16(1:8).EQ.SUMSPE(ISUM,I)) THEN
				    CALL LOAD(1,I2,CBASE)
				    CALL ADD(1,I1-N0,YBASE)
				    CALL MULTR (0,1)
				    CALL MULT(0,I1-N0,YBASE)
				    GOTO 1073
				ENDIF
 1072			    CONTINUE
			ENDIF
 1071		    CONTINUE
		   INDSUM=0
		ENDIF
 1073		CONTINUE
	ELSE
		INDSUM=0
	ENDIF
C
C	PROCESSING OTHER CASES
C
	IF (INDSUM.EQ.0) THEN
C
	DO 104 I=1,NR
	J=IRTOSR(I,IRXN)
	IF (J.GE.NS1.AND.J.LE.NS2) THEN
		IF (DFRATE(IRXN).EQ.0) THEN	! SS FOUND.
			WRITE (OUT,*) 'ERROR.  SS + SS REACTION',IRXN
			NERR=NERR+1
		ELSE
			DFRATE(IRXN)=0
		ENDIF
	ELSE
		IF (J.GE.NSC1.AND.J.LE.NSC2) THEN	! MULT BY CONST CONC
			CALL MULT (0,J,CBASE)
C
		ELSEIF (J.GE.NB1.AND.J.LE.NB2) THEN	! MULT BY "BO" CONC.
			CALL MULT (0,J,CBASE)
C
		ELSEIF (J.GE.ND1.AND.J.LE.ND2) THEN	! DUMMY.
C			CHECK FOR MEMBER OF SUM GROUP
C				CHECK FOR MEMBER + GROUP RXN CASE.
C				IN THIS CASE, MULT BY (GROUP + MEMBER) CONC.
			IF (NSGRP.EQ.0) GOTO 1048
			DO 1041 IX=1,NSGRP
			IF (J.EQ.SGRPID(IX)) THEN
				IND=IX
				GOTO 1042
			ENDIF
 1041			CONTINUE
			GOTO 1048
 1042			DO 1044 IX=1,NR
			JX=IRTOSR(IX,IRXN)
			IF (JX.GE.NA1.AND.JX.LE.NA2) THEN
				DO 1043 KX=1,NSGB
				IF (SGRP(KX,1).EQ.JX.AND.
     &				 SGRP(KX,2).EQ.J) THEN
					CALL LOAD (1,J,CBASE)
					CALL ADD (1,JX-N0,YBASE)
					CALL MULTR (0,1)
					GOTO 1049
				ENDIF
 1043				CONTINUE
			ENDIF
 1044			CONTINUE
 1048			CONTINUE

			CALL MULT (0,J,CBASE)		! SIMPLE MULT BY DUM
 1049			CONTINUE
		ELSEIF (J.GE.NA1.AND.J.LE.NA2) THEN	! OR MULT BY ACTIVE
			CALL MULT (0,J-N0,YBASE)	! CONC
		ELSEIF (J.GE.0) THEN
			WRITE (OUT,*) 'PGM ER AT RATEDEF.  IRXN,J='
     &			 ,IRXN,J
			WRITE (ICRT,*) 'PGM ERR.  CONTINUING.'
		ELSEIF (-J.LE.MAXMAX) THEN		! OR MULT BY COEF
			CALL MULT (0,-J,COBASE)		! CONC
		ELSE					! OR BY RATE CONSTANT
			JRXN=-J-MAXMAX
			IF (RXTYP(JRXN).EQ.7) THEN
				CALL MULT (0,IPHOTR(LKBUF(JRXN)),COBASE)
			ELSEIF (RXTYP(JRXN).EQ.8) THEN
				CALL MULT (0,LKBUF(JRXN),COBASE)
			ELSE
				CALL MULT (0,JRXN,KBASE)
			ENDIF
		ENDIF
	ENDIF
  104	CONTINUE
C
	ENDIF	! INDSUM.EQ.0
C
	CALL STORE (0,IRXN,RBASE)	! STORE RATE OR PARTIAL RATE
  110	CONTINUE
C
C	NO NEED FOR FURTHER REFERENCE TO CONSTANT SPECIE CONC'S
C-BS
C.	CALL FREREG (CBASE)
C-
C	PRODUCE CODE TO OBTAIN STEADY STATE CONCENTRATIONS.
C	LOOP THRU SS SPECIES.  PRODUCE CODE FOR SPECIE I IF
C	IT IS FORMED ONLY BY REACTION OF NON-SS SPECIES, OR OF
C	SS SPECIES FOR WHICH CODE HAVE ALREADY BEEN PRODUCED.
C	REACTIONS WHICH FORM SS SPECIES HAVE RATE DEFINED, DFRATE=1
C	MARKS THIS AS HAVING BEEN DEFINED.
C
	IF (NSS.EQ.0) GOTO 1050
C
C	DEFINE LRXBUF AND RXBUF, WHICH TELL WHICH REACTIONS
C	FORM A GIVEN STEADY STATE SPECIE
C
C	IN THIS VERSION, REACTIONS WHERE A SS SPECIES BOTH REACTS
C	AND IS FORMED IS ALLOWED, PROVIDED THAT THE STEADY STATE SPECIE IS
C	BOTH THE FIRST REACTANT AND THE FIRST PRODUCT.  IN THIS CASE, THE
C	CONCENTRATION OF THE SS SPECIE IS NOT DEPENDENT ON THE RATE OF
C	THE REACTION, SO IT IS NOT INCLUDED IN THE RXBUF ARRAY.
C
	NSP=1
	DO 1100 IX=1,NSS
	SSSET(IX)=.FALSE.
C	                 	! INITIALIZE SS AS NOT 'SET'
	IR=IX+NA2
	LRXBUF(IX)=NSP
	DO 1110 J=1,NRXN
	IP1=NPRODS(J)
	IP2=NPRODS(J+1)-1
	IF (IP2.LT.IP1) GOTO 1110
	REACTS=.FALSE.
	DO 1115 I=IP1,IP2
	IF (IPRODS(I).EQ.IR) THEN
		IF (I.EQ.IP1) THEN
			IF (NRTOSR(J).GE.1.AND.IRTOSR(1,J).EQ.IR) THEN
				REACTS=.TRUE.
				GOTO 1115
			ELSE
				RXBUF(NSP)=J
			ENDIF
		ELSEIF (REACTS) THEN
			WRITE (OUT,*) 'ERROR.  ILLEGAL REACTION WHERE'
     &			 ,'SS SPECIE BOTH REACTS AND IS FORMED WITH '
     &			 ,'NON-UNIT YIELD.'
			NERR=NERR+1
			GOTO 1110
		ELSEIF (IPRODS(I-1).GE.0) THEN
			RXBUF(NSP)=J
		ELSE
			RXBUF(NSP)=-J
			RXBUF2(NSP)=I-IP1
		ENDIF
		NSP=NSP+1
	ENDIF
 1115	CONTINUE	! END LOOP OVER PRODUCTS
 1110	CONTINUE	! END LOOP OVER REACTIONS
 1100	CONTINUE	! END LOOP OVER SS SPECIES
	LRXBUF(NSS+1)=NSP	! NSP USED LATER
	NSP1=NSP+1
C
C	NSLOOP=0		! NO SS ITERATIONS
	NSSET=0			! NO SS SPECIES SET
C
C	START OF ITERATIVE LOOP
C
 1002	NSLOOP=NSLOOP+1
	CHANGE=.FALSE.
C	              		! T IF SOME SS DEFINED DURING LOOP
C
	DO 1020 IX=1,NSS
	IF (SSSET(IX)) GOTO 1020
	I=IX+NA2
C
C	FIND OUT IF A REACTION FORMING I INVOLVES AN UN SSSET SS REACTANT
C
	I1=LRXBUF(IX)
	I2=LRXBUF(IX+1)-1
C
	DO 1004 IP=I1,I2
	IRXN=RXBUF(IP)
	IF (IRXN.LT.0) IRXN=-IRXN
	IF (DFRATE(IRXN).NE.1) GOTO 1020
C	                                		! REACTION FORMING I
 1004	CONTINUE
C    	        					! NOT DEFINED.  QUIT
C
C	OK TO DEFINE SS SPECIE I, BECAUSE ALL REACTIONS FORMING IT
C	HAVE DFRATE=1.
C	PLACE TOTAL FORMATION RATE IN FPR1.
C
	M=1
C	   		! M=1 WHEN NOTHING LOADED IN R1; M=0 WHEN SUM
C			  ALREADY STARTED.
	DO 1061 IP=I1,I2
	IRXN=RXBUF(IP)
	IF (IRXN.GT.0) THEN
		IF (M.EQ.0) THEN
			CALL ADD (1,IRXN,RBASE)
		ELSE
			CALL LOAD (1,IRXN,RBASE)
			M=0
		ENDIF
	ELSE
		IRXN=-IRXN
		ICOEF=RXBUF2(IP)
C		                    		! MULTIPLY RATE BY COEF, IF
		CALL LOAD (M,IRXN,RBASE)
C		                        	! APPLICABLE
		DO 1066 J=ICOEF,1,-1
		KCOEF=IPRODS(NPRODS(IRXN)+J-1)
C		                              		! NONZERO ICOEF IS
		IF (KCOEF.GT.0) GOTO 1067
C		                         		! PREVIOUS REACTANT.
		CALL MULT (M,-KCOEF,COBASE)
C		                           		! IF <0, IT IS COEF
 1066		CONTINUE
C    		        				! TO MULT CONC.
 1067		IF (M.EQ.0) THEN
			CALL ADDR (1,0)
		ELSE
			M=0
		ENDIF
	ENDIF
 1061	CONTINUE
C
C	ADD EMISSIONS RATE TO FORMATION RATE IF THIS "STEADY STATE"
C	SPECIES IS EMITTED.
C
C	EMISSION (IF APPLICABLE)
	IF (AIRSHD.AND.IEMIT(I).NE.0) THEN
		CALL LOAD (0,IEMIT(I),COBASE)
C		                             		! EMISSION RATE
		CALL MULT (0,INDEF,COBASE)
C		                          		! * CONVERSION FACTOR
		CALL DIV (0,INDHT,COBASE)
C		                         		! /HEIGHT
		CALL ADDR (1,0)
C		               				! ADD TO DY
	ENDIF
C
C       GROUP EMISSION (IF APPLICABLE)
        IF (AIRSHD.AND.NGRPS.GT.0) THEN
                DO 1062 IG=1,NGRPS
                IF (IGROUP(I,IG).NE.0) THEN
                    CALL LOAD (0,ITOT(IG),COBASE)
C                                                       ! TOTAL EMITTED OR
C                                                         INITIALLY PRESENT
                    CALL MULT (0,IEMR(IG),COBASE)
C                                                       ! * EMISSION RATE
C                                                         (FRACTION OF TOTAL
C                                                         PER UNIT TIME)
            	    CALL MULT (0,IGROUP(I,IG),COBASE)
C           	                                        ! * REL AMT OF I IN GRP
                    CALL MULT (0,INDEF,COBASE)
C                                                       ! * CONVERSION FACTOR
                    CALL DIV (0,INDHT,COBASE)
C                                                       ! / HEIGHT
                    CALL ADDR (1,0)
C                                  			! ADD TO DY
                ENDIF
 1062           CONTINUE
	ENDIF
C
C	NOW, FOR EACH REACTION DESTROYING I, FORM PSEUDO-UNIMOLECULAR
C	DESTRUCTION RATE, AND PLACE SUM OF THESE IN FPR0
C	NOTE THAT DILUTION ASSUMED NEGLIGABLE FOR STEADY STATE SPECIES.
C	BUT EACH HAS A MINIMUM DECAY RATE OF 'LITTLE' (COEF #INDLIL), TO
C	AVOID DIVIDE-BY-0 ERRORS WHICH MAY OCCUR IF IT IS NOT
C	INVOLVED IN ANY REACTIONS WITH NON-ZERO RATES.
C
C	NOTE THAT ANY REACTION DESTROYING I HAS DFRATE=0 OR -1
C
	CALL LOAD (0,INDLIL,COBASE)
C
C	LOOP OVER REACTIONS TO FIND REACTIONS OF I
C
	NSSRXN=NSP	! COUNTS HOW MANY REACTIONS OF I, STORED IN RXBUF
	DO 1120 IRXN=1,NRXN
	IR=NRTOSR(IRXN)
	REACTS=.FALSE.
	IF (IR.EQ.0) GOTO 1120
	DO 1125 J=1,IR
	IF (IRTOSR(J,IRXN).NE.I) GOTO 1125
	IF (J.EQ.1) THEN
		IF (IPRODS(NPRODS(IRXN)).EQ.I) THEN	! SKIP OVER REACTIONS
			REACTS=.TRUE.			! WHERE I IS BOTH FORMED
			NSSRXN=NSSRXN+1			! AND CONSUMED.
			RXBUF(NSSRXN)=IRXN		! BUT KEEP TRACK OF IT
			GOTO 1125			! SO RATE WILL BE DEF'D.
		ENDIF
	ELSEIF (REACTS) THEN
		WRITE (OUT,*) 'SS+SS REACTION NO.',IRXN
		NERR=NERR+1
		GOTO 1120
	ENDIF
	REACTS=.TRUE.
	NSSRXN=NSSRXN+1
	RXBUF(NSSRXN)=IRXN
C						! REACTION IRXN IS A REACTION
	IF (DFRATE(IRXN).EQ.-1) THEN
C	                            		! OF SS SPECIE I.  ADD ITS
		IF (RXTYP(IRXN).EQ.0) THEN
C		                          	! PARTIAL RATE TO FPR0
			JRXN=LKBUF(IRXN)
			IF (RXTYP(JRXN).EQ.7) THEN
				CALL ADD (0,IPHOTR(LKBUF(JRXN)),COBASE)
			ELSEIF (RXTYP(JRXN).EQ.8) THEN
				CALL ADD (0,LKBUF(JRXN),COBASE)
			ELSE
				CALL ADD (0,JRXN,KBASE)
			ENDIF
		ELSEIF (RXTYP(IRXN).EQ.1) THEN
			CALL ADD (0,LKBUF(IRXN),RBASE)
		ELSEIF (RXTYP(IRXN).EQ.7) THEN
			CALL ADD (0,IPHOTR(LKBUF(IRXN)),COBASE)
		ELSEIF (RXTYP(IRXN).EQ.8) THEN
			CALL ADD (0,LKBUF(IRXN),COBASE)
		ELSE
			CALL ADD (0,IRXN,KBASE)
		ENDIF
	ELSE
		CALL ADD (0,IRXN,RBASE)
	ENDIF
 1125	CONTINUE
C    	        	! END LOOP OVER REACTANTS
 1120	CONTINUE
C    	        	! END LOOP OVER REACTIONS
C
C	SEE IF RXBUF ARRAY BOUNDS EXCEEDED, AND ABORT IF SO
C
	IF (NSSRXN.GT.MAXIRP) THEN
		I=MAXIRP
		WRITE (OUT,*) 'MAXIMUM DIMENSTION FOR RXBUF (',I,
     &		 ') EXCEEDED IN DIFFUN.'
		STOP 'MODEL TOO BIG FOR RXBUF'
	ENDIF
C
C	NOW, CALCULATE SS CONC = C(FPR1)/C(FPR0), STORE IN SS ARRAY
C	AND INDICATE SPECIE AS 'SSSET', AND THAT A NEW ONE WAS PROCESSED.
C
	CHANGE=.TRUE.
	NSSET=NSSET+1
	SSSET(I-NA2)=.TRUE.
	CALL DIVR (1,0)
	CALL STORE (1,I-NA2,SBASE)
C	                          	! NOTE THAT THIS STORE IS NOT NECESSARY
C					! UNLESS A RECORD OF SS VALUES DESIRED.
C	SS CONC NOW DEFINED AND IN FPR1.
C	DEFINE AND STORE RATES OF ALL ITS REACTIONS.
C
	DO 1035 IP=NSP1,NSSRXN
	IRXN=RXBUF(IP)
	IF (DFRATE(IRXN).EQ.-1) THEN
		IF (RXTYP(IRXN).EQ.0) THEN
			JRXN=LKBUF(IRXN)
			IF (RXTYP(JRXN).EQ.7) THEN
				CALL LOAD (0,IPHOTR(LKBUF(JRXN)),COBASE)
			ELSEIF (RXTYP(JRXN).EQ.8) THEN
				CALL LOAD (0,LKBUF(JRXN),COBASE)
			ELSE
				CALL LOAD (0,JRXN,KBASE)
			ENDIF
		ELSEIF (RXTYP(IRXN).EQ.1) THEN
			CALL LOAD (0,LKBUF(IRXN),RBASE)
		ELSEIF (RXTYP(IRXN).EQ.7) THEN
			CALL LOAD (0,IPHOTR(LKBUF(IRXN)),COBASE)
		ELSEIF (RXTYP(IRXN).EQ.8) THEN
			CALL LOAD (0,LKBUF(IRXN),COBASE)
		ELSE
			CALL LOAD (0,IRXN,KBASE)
		ENDIF
	ELSE
		CALL LOAD (0,IRXN,RBASE)
	ENDIF
	CALL MULTR (0,1)
	CALL STORE (0,IRXN,RBASE)
	DFRATE(IRXN)=1
 1035	CONTINUE
 1020	CONTINUE
C
C	END LOOP OVER SS SPECIES.  SEE IF ANOTHER LOOP NEEDED, OR IF
C	A LOOP WENT THRU W/O CHANGE, WHICH MEANS THAT THE SS SPECIES
C	CAN'T BE ORDERED.
C
	IF (NSSET.LT.NSS) THEN
		IF (CHANGE) THEN
			GOTO 1002
		ELSE
			WRITE (OUT,*) 'ERROR.  SOME SS SPECIES CAN''T  '
     &			 ,'BE ORDERED.  NO. ORDERED =',NSSET,'.  TOTAL'
     &			 ,' NO SS SPECIES =',NSS
			NERR=NERR+1
		ENDIF
	ENDIF
C	FOLLOWING BAD -- COMMENTED OUT
C	WRITE (OUT,*) NSLOOP,' ITERATIONS REQUIRED TO ORDER '
C     &	 ,'STEADY STATE SPECIES.'
C
 1050  CONTINUE
C
C     END SS SECTION.  ALL SS CONC'S AND RATES OF REACTIONS FORMING
C     SS SPECIES DEFINED.  RATES OF ALL REACTIONS SHOULD BE DEFINED.
C	CHECK AND MAKE SURE THIS IS SO.
C
	DO 1900 IRXN = 1,NRXN
	IF (DFRATE(IRXN).NE.1) THEN
		WRITE (OUT,*) 'ERROR.  RATE OF REACTION',IRXN
     &		 ,' UNDEFINED AFTER END OF SS LOOP.'
		NERR=NERR+1
	ENDIF
 1900	CONTINUE
C
C-BS
C	DONE WITH SS AND RATE CONSTANT REFS.
C.	CALL FREREG (SBASE)
C.	CALL FREREG (KBASE)
C-
C     ALL RATES DEFINED-- NOW DEFINE DY'S AND QUIT
C
	DO 2300 I=NA1,NA2
C
	WRITE (CODEU,1) 'C '//NAME(I)
   1	FORMAT (A)
C
C	DILUTION AND ENTRAINMENT - IGNORE IF "NO DILUTION" SPECIES, OR
C	"AIRSHED MODEL" FORMAT (FORM2=T)
C
	IF (FORM2.OR.FORM3.NE.0) THEN
		FIRSTR=.TRUE.
	ELSEIF (SPETYP(I).EQ.1) THEN
		CALL ZERR (0)
		FIRSTR=.FALSE.
	ELSEIF (AIRSHD) THEN
		IF (IALOFT(I).EQ.0) THEN
			CALL LOADN (0,INDDIL,COBASE)	! SIMPLE DIL
			CALL SUBT (0,INDER,COBASE)	! AND DIL DUE TO DH/DT
			CALL MULT (0,I-N0,YBASE)	! TIMES CONC
		ELSE
			CALL LOAD (0,IALOFT(I),COBASE)	! CONC. ALOFT
			CALL SUBT (0,I-N0,YBASE)	! LESS CONC. BELOW
			CALL MULT (0,INDER,COBASE)	! TIMES 1/H * DH/DT
			CALL LOAD (1,INDDIL,COBASE)	! ALSO, LOSS DUE
			CALL MULT (1,I-N0,YBASE)	! TO 'SIMPLE' DILUTION
			CALL SUBTR (0,1)
		ENDIF
		FIRSTR=.FALSE.
	ELSE
		CALL LOADN (0,INDDIL,COBASE)		! DILUTION ONLY
		CALL MULT (0,I-N0,YBASE)
		FIRSTR=.FALSE.
	ENDIF
C
C	DEPOSITION (IF APPLICABLE) 
C
	IF (AIRSHD.AND.IDEPV(I).NE.0) THEN
		CALL LOAD (1,IDEPV(I),COBASE)		! DEP. VELOCITY
		CALL MULT (1,INDDF,COBASE)		! * DEP.FAC
		CALL DIV (1,INDHT,COBASE)		! / HEIGHT
		CALL MULT (1,I-N0,YBASE)		! * CONC
		CALL SUBTR (0,1)			! SUBT. FROM DY
	ENDIF
C
C	EMISSION (IF APPLICABLE)
	IF (AIRSHD.AND.IEMIT(I).NE.0) THEN
		CALL LOAD (1,IEMIT(I),COBASE)		! EMISSION RATE
		CALL MULT (1,INDEF,COBASE)		! * CONVERSION FACTOR
		CALL DIV (1,INDHT,COBASE)		! /HEIGHT
		CALL ADDR (0,1)				! ADD TO DY
	ENDIF
C
C       GROUP EMISSION (IF APPLICABLE)
        IF (AIRSHD.AND.NGRPS.GT.0) THEN
                DO 2210 IG=1,NGRPS
                IF (IGROUP(I,IG).NE.0) THEN
                    CALL LOAD (1,ITOT(IG),COBASE)       ! TOTAL EMITTED OR
C                                                         INITIALLY PRESENT
                    CALL MULT (1,IEMR(IG),COBASE)       ! * EMISSION RATE
C                                                         (FRACTION OF TOTAL
C                                                         PER UNIT TIME)
            	    CALL MULT (1,IGROUP(I,IG),COBASE)   ! * REL AMT OF I IN GRP
                    CALL MULT (1,INDEF,COBASE)          ! * CONVERSION FACTOR
                    CALL DIV (1,INDHT,COBASE)           ! / HEIGHT
                    CALL ADDR (0,1)			! ADD TO DY
                ENDIF
 2210           CONTINUE
        ENDIF
C
C
C	LOOP OVER ALL REACTIONS.  SUBTRACT RATE IF I IS A REACTANT,
C	AND ADD RATE IF IT IS A PRODUCT.
C	FOR FORMAT=3, DON'T SUBTRACT LOSS RATES.  THIS IS DONE SEPARATELY
C
 2211	DO 2380 IRXN=1,NRXN
	IF (FORM3.EQ.0) THEN
		IR=NRTOSR(IRXN)
		IF (IR.GT.0) THEN
			DO 2310 IX=1,IR
			IF (IRTOSR(IX,IRXN).EQ.I) THEN  ! FORMS I, SUBTRACT
				IF (FIRSTR) THEN
					CALL LOADN (0,IRXN,RBASE)
					FIRSTR=.FALSE.
				ELSE
					CALL SUBT (0,IRXN,RBASE)
				ENDIF
			ENDIF
 2310			CONTINUE
		ENDIF
	ENDIF
	IP1=NPRODS(IRXN)
	IP2=NPRODS(IRXN+1)-1
	IP1=NPRODS(IRXN)
	IP2=NPRODS(IRXN+1)-1
	IF (IP2.GE.IP1) THEN
		DO 2320 IX=IP1,IP2
		IF (IPRODS(IX).EQ.I) THEN	! THIS REACTION FORMS IR
			JX=IX-1
			IF (IX.GT.IP1.AND.IPRODS(JX).LT.0) THEN
				IF (FIRSTR) THEN
					J=0
				ELSE
					J=1
				ENDIF
				CALL LOAD (J,IRXN,RBASE)	  ! MULT RATE
 2321				CALL MULT (J,-IPRODS(JX),COBASE)  ! BY COEF
				JX=JX-1
				IF (JX.GE.IP1.AND.IPRODS(JX).LT.0) GOTO
     &				 2321
				IF (FIRSTR) THEN
					FIRSTR=.FALSE.
				ELSE
					CALL ADDR (0,1)
				ENDIF
			ELSE					! NO COEFS
				IF (FIRSTR) THEN
					CALL LOAD (0,IRXN,RBASE)
					FIRSTR=.FALSE.
				ELSE
					CALL ADD (0,IRXN,RBASE)
				ENDIF
			ENDIF
		ENDIF
 2320		CONTINUE
	ENDIF
 2380	CONTINUE			! END LOOP OVER REACTIONS
	IF (FIRSTR) THEN
		CALL ZER (I-N0,FBASE)
	ELSE
		CALL STORE(0,I-N0,FBASE)
	ENDIF
C
	IF (FORM3.EQ.0) GOTO 2300
C
C	PROCESSING FOR FORMAT 3:  SEPARATE LOSS RATES.
C
	KK=0				! FIRST TO REG 0, SUBTOTS TO REG 1
	DO 4110 IRXN = 1,NRXN
	FIRSTR=.TRUE.			! SET TO F IF AT LEAST ONE RXN OF I
	NR = NRTOSR (IRXN)
        IF (NR.LT.0) GOTO 4110
C
C	SEE IF THIS SPECIES CONSUMED IN THIS REACTION
C
	NN=0
	DO 4112 IX=1,NR
	IF (IRTOSR(IX,IRXN).EQ.I) NN=NN+1
 4112	CONTINUE
	IF (NN.EQ.0) GOTO 4110
C
C	SPECIES IN THIS REACTION.  LOAD RATE CONSTANT
C
	LKB=LKBUF(IRXN)
	IF (RXTYP(IRXN).EQ.0) THEN
		IF (RXTYP(LKB).EQ.7) THEN
			CALL LOAD (KK,IPHOTR(LKBUF(LKB)),COBASE)
		ELSEIF (RXTYP(LKB).EQ.8) THEN
			CALL LOAD (KK,LKBUF(LKB),COBASE)
		ELSE
			CALL LOAD (KK,LKB,KBASE)
		ENDIF
	ELSEIF (RXTYP(IRXN).EQ.1) THEN
C		IF (LKB.GT.IRXN.OR.DFRATE(LKB).NE.1) ! already checked
		CALL LOAD (KK,LKB,RBASE)
	ELSEIF (RXTYP(IRXN).EQ.7) THEN
		CALL LOAD (KK,IPHOTR(LKB),COBASE)
	ELSEIF (RXTYP(IRXN).EQ.8) THEN
		CALL LOAD (KK,LKB,COBASE)
	ELSE
		CALL LOAD (KK,IRXN,KBASE)
	ENDIF
C
C	MULT BY ALL REACTANT'S EXCEPT FOR FIRST INSTANCE OF I
C
	DO 4104 IX=1,NR
	J=IRTOSR(IX,IRXN)
	IF (I.EQ.J.AND.FIRSTR) THEN
		FIRSTR=.FALSE.
		GOTO 4104
	ELSE
		IF (J.GE.NSC1.AND.J.LE.NSC2) THEN
			CALL MULT (KK,J,CBASE)    	! MULT BY CONST CONC
		ELSEIF (J.GE.NA1.AND.J.LE.NA2) THEN
			CALL MULT (KK,J-N0,YBASE)   	! OR MULT BY ACTIVE
		ELSEIF (J.GE.NS1.AND.J.LE.NS2) THEN
			CALL MULT (KK,J-NA2,SBASE)	! ST. STATE
		ELSEIF (J.GE.0) THEN
			WRITE (OUT,*) 'PGM ER AT RATEDEF.  IRXN,J='
     &			 ,IRXN,J
			WRITE (ICRT,*) 'PGM ERR.  CONTINUING.'
		ELSEIF (-J.LE.MAXMAX) THEN
			CALL MULT (KK,-J,COBASE)	! OR MULT BY COEF
		ELSE
			JRXN=-J-MAXMAX			! OR BY RATE CONSTANT
			IF (RXTYP(JRXN).EQ.7) THEN
				CALL MULT (KK,IPHOTR(LKBUF(JRXN)),COBASE)
			ELSEIF (RXTYP(JRXN).EQ.8) THEN
				CALL MULT (KK,LKBUF(JRXN),COBASE)
			ELSE
				CALL MULT (KK,JRXN,KBASE)
			ENDIF
		ENDIF
	ENDIF
 4104	CONTINUE
	IF (.NOT.FIRSTR) THEN
		IF (KK.EQ.0) THEN
			IF (NN.GT.1) THEN
				CALL LOADR (1,0)
				DO 4107 J=2,NN
 4107				CALL ADDR (0,1)
			ENDIF
			KK=1
		ELSE
			DO 4108 J=1,NN
 4108			CALL ADDR (0,1)
		ENDIF
	ENDIF
 4110	CONTINUE
C
C	(FOLLOWING IS VERSION WHICH CALC'S TOTAL RATE ONLY)
C	FIRSTR=.TRUE.
C	DO 4110 IRXN = 1,NRXN
C	IR=NRTOSR(IRXN)
C	IF (IR.GT.0) THEN
C		DO 4310 IX=1,IR
C		IF (IRTOSR(IX,IRXN).EQ.I) THEN
C			IF (FIRSTR) THEN
C				CALL LOAD (2,IRXN,RBASE)
C				FIRSTR=.FALSE.
C			ELSE
C				CALL ADD (2,IRXN,RBASE)
C			ENDIF
C		ENDIF
C 4310		CONTINUE
C	ENDIF
C 4110	CONTINUE
C
C	END LOOP OVER REACTIONS OF I.  FIRSTR KK IS 1 IF AT LEAST ONE
C	REACTION FOUND.
C
	IF (FORM2) THEN
		IF (KK.EQ.0) THEN
			CALL ZER (I-N0,LBASE)
		ELSE
			CALL STORE(0,I-N0,LBASE)
		ENDIF
	ELSE
		IF (KK.EQ.0) THEN
			CALL LOAD (0,INDDIL,COBASE)
		ELSE
			CALL ADD (0,INDDIL,COBASE)		! DILUTION
		ENDIF
		CALL STORE(0,I-N0,LBASE)
	ENDIF

C
 2300	CONTINUE			! END LOOP OVER ACTIVE SPECIES
	RETURN
	END
