       SUBROUTINE LISTSC
C
C      LIST REACTANTS AND COEFFICIENTS
C
	INCLUDE 'PSPECS.FOR'
C-
	LOGICAL FIRST
	INTEGER DSPC(MAXNS),ESPC(MAXNS),GSPC(MAXNS)
C
      WRITE (OUT,600) TITLE
  600 FORMAT ('1',10X,A80/' ')
      IP=NSC+NB+NDUM+1
      IR=IP+NDY-1
	IF (FORM2) THEN
		WRITE (OUT,1602) NDY,NSC,NB,NSS,NDUM,NDEL
 1602		FORMAT (' '/' LIST OF REACTANTS:  (',I2,' ACTIVE,',I3,
     &		 ' CONSTANT,',I3,' BUILDUP,',I3,' STEADY STATE,',I3,
     &		 ' DUMMY, AND',I3,' DELETED'/' '/' TYPE           NO. '
     &		  ,'NAME                 MWT    C''S   N''S    CONC(0)'
     &		 /' ------------   --- ----------------  -------  ----',
     &		 '-  ---  -----------')
		WRITE (OUT,1603) ' ACTIVE        ',(I,NAME(I),MWT(I),
     & 		 CNO(I),NNO(I),CONC0(I),I=NA1,NA2)
		IF (NSC.GT.0) WRITE (OUT,1603) ' CONSTANT      ',
     &		 (I,NAME(I),MWT(I),CNO(I),NNO(I),CONC0(I),I=NSC1,NSC2)
		IF (NB.GT.0) WRITE (OUT,1603) ' BUILDUP-ONLY  ',
     &		 (I,NAME(I),MWT(I),CNO(I),NNO(I),CONC0(I),I=NB1,NB2)
		IF (NDUM.GT.0) WRITE (OUT,1603) ' DUMMY         ',
     &		 (I,NAME(I),MWT(I),CNO(I),NNO(I),CONC0(I),I=ND1,ND2)
 1603		FORMAT (' '/A15,I3,2X,A16,F9.2,F7.2,I4,1PG13.3/
     &		 (15X,I3,2X,A16,0PF9.2,F7.2,I4,1PG13.3))
		IF (NSS.GT.0) WRITE (OUT,1611) ' STEADY STATE  ',
     &		 (I,NAME(I),I=NS1,NS2)
		IF (NDEL.GT.0) WRITE (OUT,1611) ' DELETED      ',
     &		 (I,NAME(I),I=NS2+1,NS2+NDEL)
 1611		FORMAT (' '/A15,I3,2X,A16/(15X,I3,2X,A16))
C
	ELSE
		WRITE (OUT,603) NDY,(I,NAME(I),I=IP,IR)
  603		FORMAT (/' LIST OF REACTANTS'//I5,' ACTIVE '/(' ',
     &		 3(I7,') ',A16)))
		IF (NSC.GT.0) THEN
			WRITE (OUT,604) NSC,(I,NAME(I),CONC0(I),I=1,NSC)
  604 			FORMAT (/1X,I4,' CONSTANT' /(' ',2(I7,') ',A16,
     &			 1PG12.3,13X)))
	      ENDIF
	      IF (NB.GT.0) THEN
		      IR=NSC+1
		      IP=NSC+NB
		      WRITE (OUT,605) NB,(I,NAME(I),I=IR,IP)
  605		      FORMAT (/1X,I4,' BUILDUP-ONLY' /(' ',3(I7,') ',A16)))
	      ENDIF
	      IF (NDUM.GT.0) THEN
		      IR=IP
		      IP=IP+NDUM
		      IR=IR+1
		      WRITE (OUT,607) NDUM,(I,NAME(I),I=IR,IP)
  607  		      FORMAT (/1X,I4,' DUMMY (SAVED)'/(' ',3(I7,') ',A16)))
	      ENDIF
	      IF (NSS.GT.0) THEN
		      IR=NSC+NB+NDY+NDUM
		      IP=IR+NSS
		      IR=IR+1
		      WRITE (OUT,606) NSS,(I,NAME(I),I=IR,IP)
  606 		      FORMAT (/1X,I4,' STEADY STATE' /(' ',3(I7,') ',A16)))
	       ENDIF
	       IF (NDEL.GT.0) THEN
		       IR=NSC+NB+NDY+NDUM+NSS
		       IP=IR+NDEL
		       IR=IR+1
		       WRITE (OUT,608) NDEL,(I,NAME(I),I=IR,IP)
  608  		       FORMAT (/1X,I4,' DUMMY SPECIES DELETED'/
     &			(' ',3(I7,') ',A16)))
	       ENDIF
	ENDIF
C
C	SUM COEFFICIENTS
C
	IF (NSUM.GT.0) THEN
	    DO 630 ISUM=1,NSUM
		WRITE (OUT,631) SUMCOE(ISUM),
     &		 (SUMSPE(ISUM,I),I=1,NSUMSP(ISUM))
  631		FORMAT(/' SUM ',A8," =",8(1X,A8)/(15X,8(1X,A8)))
  630	    CONTINUE
	ENDIF

C
       IF (AIRSHD) THEN
               J=0
               K=0
               DO 609 I=1,NS
               IF (IDEPV(I).NE.0) THEN
                      J=J+1
                      DSPC(J)=I
               ENDIF
               IF (IEMIT(I).NE.0) THEN
                      K=K+1
                      ESPC(K)=I
               ENDIF
 609           CONTINUE
               IF (J.GT.0) THEN
	              WRITE (OUT,610) J,(DSPC(I),NAME(DSPC(I)),I=1,J)
  610  	              FORMAT (/1X,I4,' DEPOSITED SPECIES'/(' ',3(I7,
     &		       ') ',A16)))
               ENDIF
               IF (K.GT.0) THEN
	              WRITE (OUT,612) K,(ESPC(I),NAME(ESPC(I)),I=1,K)
  612  	              FORMAT (/1X,I4,' EMITTED SPECIES'/(' ',3(I7,
     &		       ') ',A16)))
               ENDIF
       ENDIF
       IF (NGRPS.NE.0) THEN
               DO 611 IG=1,NGRPS
               J=0
               DO 613 IS=1,NS
               IF (IGROUP(IS,IG).NE.0) THEN
                      J=J+1
                      GSPC(J)=IS
               ENDIF
  613          CONTINUE
               WRITE (OUT,614) J,IG,GRNAM(IG),(GSPC(I),NAME(GSPC(I))
     &          ,I=1,J)
  614          FORMAT (/1X,I4,' SPECIES IN GROUP #',I2,':  ',A4/
     &          (' ',3(I7,') ',A16)))
  611          CONTINUE
       ENDIF
C
C	SPECIAL SPECIES
C
	FIRST=.TRUE.
	IP=NSC+NB+NDUM+1
	IR=IP+NDY-1
	DO 6111 I=IP,IR
	IF (SPETYP(I).NE.0) THEN
		IF (FIRST) THEN
			WRITE (OUT,'(/'' SPECIAL SPECIES'')')
			FIRST=.FALSE.
		ENDIF
		IF (SPETYP(I).EQ.1) THEN
			WRITE (OUT,'(3X,''NO DILUTION = '',A16)')
     &			 NAME(I)
		ELSE
			WRITE (OUT,'(3X,''TYPE'',I4,4X,''= '',A16)')
     &			 SPETYP(I),NAME(I)
		ENDIF
	ENDIF
 6111	CONTINUE
C
C	SPECIES GROUPS
C
	IF (NSGRP.NE.0) THEN
		DO 6210 ISGRP=1,NSGRP
		WRITE (OUT,'(/'' SPECIES GROUP '',A8)')
     &		 NAME(SGRPID(ISGRP))(1:8)
		ID=SGRPID(ISGRP)
		DO 6210 I=1,NSGB
		IF (SGRP(I,2).EQ.ID) WRITE (OUT,*) '          ',
     &		 NAME(SGRP(I,1))
 6210		CONTINUE
	ENDIF
C
       IF (NCOEFV.GT.0) THEN
	      WRITE (OUT,616) NCOEFV,(I,COEFNM(I),COEF(I),I=1,NCOEFV)
  616 	      FORMAT (/1X,I4,' VARIABLE COEFFICIENTS:'/('   ',3(I5,') '
     & 	       ,A8,1PG10.3)))
       ENDIF
       IF (NVTCO.GT.0) THEN
	      WRITE (OUT,618) NVTCO,(VTEMP(I),I=1,NVTEMP)
  618         FORMAT (/1X,I4,' TEMPERATURE VARYING COEFFICIENTS:'/
     &          '    TEMPERATURES: ',8(1PG12.3))
 	      DO 615 I=1,NVTCO
		WRITE (OUT,620) IVTCO(I),COEFNM(IVTCO(I)),(VTCO(I,J),
     &            J=1,NVTEMP)
  620  	        FORMAT (3X,I5,') ',A8,8(1PG12.3))
  615         CONTINUE
       ENDIF
       IF (NCOC2.GE.NCOC1) THEN
	      NCOCF=NCOC2-NCOC1+1
	      WRITE (OUT,622) NCOCF,(I,COEF(I),I=NCOC1,NCOC2)
  622 	      FORMAT (/1X,I4,' CONSTANT COEFFICIENTS:'/('   ',4(I5,') '
     & 	       ,1PG10.3)))
      ENDIF
C
      RETURN
      END
