      SUBROUTINE VCOEF(LEN,ISUB)
C
C      TAKES INPUT FROM IOB160.  ONLY PROCESSES ONE LINE.  LEN IS LENGTH OF
C      STRING IN IOB160.
C
C     INPUT FORMAT:  LIST OF MACHINE INSTRUCTIONS SEPARATED BY SPACE
C     OR IGNORED CHARACTER.
C     INSTRUCTION FORMAT:  INSTRUCTION CHARACTER | 1ST OPERAND CHAR |
C     2ND OPERAND CHAR(S)
C     INSTRUCTION (OR FORMAT) CHAR.....MEANING
C	   *	    SET REGISTERS.  IGNORED IN VAX VERSION
C          C        CLEAR REG  (NO 2ND OPERAND)
C          N        NEGATE REG   (NO 2ND OPERAND)
C          L        LOAD REG
C          A        ADD TO REG
C          S        SUBTRACT FROM REG
C          M        MULTIPLY
C          D        DIVIDE
C          E        STORE  CONTENTS OF REG
C          &   (FMT CHAR)   LIST CONTINUES ON NEXT CARD
C        BLANK  (FMT CHAR)  END OF THIS INSTRUCTION LIST
C
C     1ST OPERAND:  LEGAL CHARS=0,1,2...REFER TO FP REGS 9,10,11.
C     2ND OPERAND:  0,1,2...FP REGS (FOR R-R INST).   FOR R-M INST:
C        TYPE           BASE ASSUMED
C     C'specie name'        0          ANY SPECIES
C     K'reaction no.'       1          RATE CONSTANT (ADJ. FOR CONST.)
C     R'reaction no.'       2          REACTION RATE
C     #'coef name'          3          VARIABLE COEF.
C     D'specie name'        4          ACTIVE OR B.O. DERIVATIVE
C     K(RXN LABEL), #(COEF NAME)...REFER TO SPECIES CONC (ACTIVE ONLY),
C     RATE CONSTANT (INCL CONST REACTANTS), AND PRESENT VAR COEF VALUE.
C     BLANK IN COL.1 MEANS END OF INPUT FOR VCOEF.
C
C     ISUB=1 for inserted Initial code (CONSTR routine)
C     Legal operand types: C, #
C
C     ISUB=2 for inserted DIFFUN code
C     Legal operand types: C (active or constant species only), #, K
C
C     ISUB=3 for inserted Print/Save code (SXTRA routine)
C     Legal operand types: C, #, K, R, D
C
	INCLUDE 'PSPECS.FOR'
C-
	CHARACTER IC1,INC(8),INUMC(8)
C
	INTEGER BASENO(5)
C
	DATA INC/'C','N','L','A','S','M','D','E'/,
     1	 INUMC/'0','1','2','C','#','K','R','D'/
C
C	            CBASE COBASE KBASE RBASE DYBASE
	DATA BASENO / 0,    3,     1,    2,    4 /
C
C
C      IGNORE  LEADING BLANKS AND TAB CHARACTERS
C
       IC=0
  100  IC=IC+1
       IF (IC.GT.LEN) RETURN
       IC1=BYT160(IC)
       ICH1=ICHAR(IC1)
       IF (IC1.EQ.' ') GOTO 100
       IF (ICH1.EQ.9) GOTO 100
C                                     !TAB
       GOTO 201
C
C      LOOK AT 1ST CHAR OF NEW INSTRUCTION
C
  200 IC=IC+1
      IF (IC.GT.LEN) RETURN
      IC1=BYT160(IC)
      ICH1=ICHAR(IC1)
      IF (ICH1.EQ.9) GOTO 200
C                                     !TAB
      IF (IC1.EQ.' ') GOTO 200
C
C     DETERMINE INSTRUCTION CHAR
C
  201 IF (IC1.EQ.'*') GOTO 400
      DO 203 INST=1,8
      IF (IC1.EQ.INC(INST)) GOTO 204
  203 CONTINUE
      GOTO 800
C
C     DETERMINE 1ST OPERAND
C
  204 IC=IC+1
      IC1=BYT160(IC)
      DO 205 INUM=1,3
      IF (INUMC(INUM).EQ.IC1) GOTO 206
  205 CONTINUE
      GOTO 800
  206 IC=IC+1
      INUM=INUM-1
      IF (INST-2) 210,211,220
C
C      ONE REGISTER INSTRUCTION
C
  210 CALL SUBTR(INUM,INUM)
      GO TO 200
  211 CALL NEGR (INUM)
      GO TO 200
C
C     DETERMINE 2ND OPERAND TYPE
C
  220 IC1=BYT160(IC)
      INST=INST-2
      DO 221 INUM2=1,10
      IF (INUMC(INUM2).EQ.IC1) GO TO 222
  221 CONTINUE
      GO TO 800
  222 IC=IC+1
      IF (INUM2.GT.3) THEN
              IF (ISUB.EQ.1.AND.INUM2.GT.5) GOTO 850
C                                                       !ERROR
              IF (ISUB.EQ.2.AND.INUM2.GT.6) GOTO 860
C                                                       !ERROR
              GO TO 230
      ENDIF
C
C     REGISTER-REGISTER INST.
C
      INUM2=INUM2-1
      GO TO (223,224,225,226,227,228),INST
      GO TO 820
  223 CALL LOADR (INUM,INUM2)
      GO TO 200
  224 CALL ADDR (INUM,INUM2)
      GO TO 200
  225 CALL SUBTR (INUM,INUM2)
      GO TO 200
  226 CALL MULTR (INUM,INUM2)
      GO TO 200
  227 CALL DIVR (INUM,INUM2)
      GO TO 200
  228 CALL LOADR (INUM2,INUM)
      GO TO 200
C
C     REGISTER-MEMORY INST...DETERMINE ADDRESS
C
  230 INUM2=INUM2-3
      IC1=BYT160(IC)
      IF (IC1.NE.'''') GO TO 800
      IOBF16=' '
      IC=IC+1
      DO 231 I=1,16
      IC1=BYT160(IC)
      IC=IC+1
      IF (IC1.EQ.'''') GO TO 232
  231 BYT16(I)=IC1
      IC1=BYT160(IC)
      IF (IC1.NE.'''') GO TO 800
      IC=IC+1
C
C      FIND ARRAY INDEX NO.
C
C             C   #   K   R   D
  232 GO TO (320,246,243,243,360),INUM2
C
  320 ASSIGN 250 TO IGO
      GO TO 240
  360 ASSIGN 361 TO IGO
      GO TO 240
  361 IF (I.GE.NA1) GO TO 362
      I=I-NSC
      GO TO 250
  362 I=I-N0
      GO TO 250
C  -     WHICH SPECIES NO.?
  240 DO 241 I=1,NS
      IF (NAME(I).EQ.IOBF16) GOTO 242
  241 CONTINUE
      GO TO 810
  242 IF (ISUB.EQ.2) THEN
C            ONLY CONSTANT OR ACTIVE SPECIES ALLOWED FOR DIFFUN CODE
             IF (I.GT.NSC2) THEN
                    IF (I.LT.NA1 .OR. I.GT.NA2) GOTO 870
C                                                            ! ERROR
             ENDIF
      ENDIF
      GO TO IGO,(250,361)
C
C  -     WHICH REACTION LBL.?
  243	CALL ALIN16(1,IOBF16)
	CALL MOVLFT(IOBF16(1:8))
	DO 245 IX=1,NRXN
	IF (IOBF16(1:4).EQ.RXNLBL(IX)) THEN
		I=IX
		IF (INUM2.EQ.2) THEN
C		                    	! INUM2=2 FOR K REFERENCE
			IF (RXTYP(IX).EQ.2.OR.RXTYP(IX).EQ.3) GOTO 840
		ENDIF
		GOTO 250
	ENDIF
  245	CONTINUE
	GOTO 830
C  -     WHICH COEF. NO.?
  246  CALL MOVRIT(16,IOBF16)
CD      WRITE (OUT,*) 'AFTER MOVRIT, IOBF16= ',IOBF16
       READ (IOBF16,248,ERR=249) X
  248  FORMAT (F16.0)
C  -     DECODED, SO THIS IS A CONSTANT COEF
       IF (NCOC2.GE.NCOC1) THEN
		DO 321 I=NCOC1,NCOC2
		IF (X.EQ.COEF(I)) GOTO 250
  321		CONTINUE
       ENDIF
C  -     ADD NEW CONSTANT COEF
       NCOC2=NCOC2+1
       IF (NCOC2.GT.MAXCO) THEN
		J=1+MAXCO-NCOC1
		WRITE (OUT,*) 'TOO MANY CONSTANT COEFFICIENTS.  MAX =',J
		STOP 'TOO MANY CONSTANT COEFFICIENTS (VCOEF)'
       ENDIF
       COEF(NCOC2)=X
CD      WRITE (OUT,322) NCOC2,COEF(NCOC2)
CD 322  FORMAT (' IN VCOEF: NCOC2=',I4,'  COEF= ',F16.0)
       I=NCOC2
       GOTO 250
C
C  -     DIDN'T DECODE TO A NUMBER, SO THIS IS A VARIABLE COEF
  249  CALL MOVLFT (IOBF16)
       IF (NCOEFV.GT.0) THEN
	        DO 323 I=1,NCOEFV
 	        IF (IOBF16(1:8).EQ.COEFNM(I)) GO TO 250
  323  		CONTINUE
       ENDIF
C  -     ADD NEW VARIABLE COEF
       NCOEFV=NCOEFV+1
       IF (NCOEFV.EQ.NCOC1) THEN
		J=NCOC1-1
		WRITE (ICRT,*) 'INCREASE MAXVCD (VCOEF). NCOC1, NCOEFV=',
     &		 NCOEFV,NCOC1
		WRITE (OUT,*) 'TOO MANY VARIABLE COEFFICIENTS.  MAX =',J
		STOP 'TOO MANY VARIABLE COEFFICIENTS'
       ENDIF
       COEFNM(NCOEFV)=IOBF16(1:8)
       COEF(NCOEFV)=0.0
CD      WRITE (OUT,324) NCOEFV,COEFNM(NCOEFV),COEF(NCOEFV)
CD 324  FORMAT (' IN VCOEF: NCOEFV=',I4,' COEFNM=',A8,'COEF= ',F16.0)
       I = NCOEFV
C
C      MEMORY REFERENCE DEFINED.  PRODUCE INSTRUCTION
C
  250 INUM2=BASENO(INUM2)
      IF (I.LE.0) GO TO 800
      GO TO (253,254,255,256,257,258),INST
      GO TO 820
  253 CALL LOAD (INUM,I,INUM2)
      GO TO 200
  254 CALL ADD (INUM,I,INUM2)
      GO TO 200
  255 CALL SUBT (INUM,I,INUM2)
      GO TO 200
  256 CALL MULT (INUM,I,INUM2)
      GO TO 200
  257 CALL DIV (INUM,I,INUM2)
      GO TO 200
  258 CALL STORE (INUM,I,INUM2)
      GO TO 200
C
C	IGNORE CHARACTERS AFTER '*' UNTIL BLANK OR ',' ENCOUNTERED.
C
  400	IC=IC+1
        IF (IC.GT.LEN) RETURN
	IC1=BYT160(IC)
	IF (IC1.EQ.' ') GOTO 200
	IF (IC1.EQ.',') GOTO 200
	GOTO 400
C
C      ERRORS
C
  800  WRITE (OUT,801) IC,IC1
  801  FORMAT ('$ INPUT ERROR AT CHARACTER #',I3,' (CHAR = ''',
     &  A1,''')')
       GOTO 890
  810  WRITE (OUT,811) INUMC(INUM2),IOBF16
  811  FORMAT ('$ INPUT ERROR: ',A1,'''',A16,'''',' NOT FOUND')
       GOTO 890
  820  WRITE (OUT,821)
  821  FORMAT ('$ VCOEF PGM ERR')
       GOTO 890
  830  WRITE (OUT,831) IOBF16(1:4)
  831  FORMAT ('$ INPUT ERROR.  REACTION NO. ',A4,' NOT FOUND')
       GOTO 890
  840  WRITE (OUT,841) IOBF16(1:4)
  841  FORMAT ('$ INPUT ERROR.  REACTION NO. ',A4,' HAS NO K')
       GOTO 890
  850  WRITE (OUT,851) INUMC(INUM2)
  851  FORMAT ('$ INPUT ERROR.  ILLEGAL OPERAND FOR INSERTED ',
     &   'CONSTR CODE. OPERAND TYPE=',A1)
       GOTO 890
  860  WRITE (OUT,861) INUMC(INUM2)
  861  FORMAT ('$ INPUT ERROR.  ILLEGAL OPERAND FOR INSERTED ',
     &   'DIFFUN CODE. OPERAND TYPE=',A1)
       GOTO 890
  870  WRITE (OUT,871) IOBF16
  871  FORMAT ('$ INPUT ERROR.  SPECIES FOR INSERTED DIFFUN ',
     &   'CODE MUST BE ACTIVE OR CONSTANT.  ILLEGAL SPECIES =',A16)
  890  WRITE (OUT,891)
  891  FORMAT (' +.   REMAINING INSTRUCTIONS IGNORED.')
       NERR=NERR+1
       WRITE (ICRT,892) IOB160(1:LEN)
  892  FORMAT (' VCOEF ERROR.  INPUT LINE GIVEN BELOW:'
     &  /' ',A)
C
       RETURN
       END
