	SUBROUTINE LDDMS (IND)
C
C	LOADS DMS DATA INTO MEMORY.  READS FILE GIVEN BY
C	DMS= INPUT IN MODELING.PRM
C
C	IND = RETURN CODE:  	0  = OK,
C				-1 = ERROR OPENING FILE
C				-2 = ERROR READING FILE
C				-3 = NO DATA IN FILE
C
C	USES UNIT=4
C
C	DMS ASSIGNMENT DATA
C
	INCLUDE 'DMSSPC.FOR'
	CHARACTER DMSFIL*60
C
	CHARACTER INLIN*80
C
	OPEN (UNIT=4,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	DMSFIL='DMS.PRM'
   9	MAXUNC=0
C
  10	READ (4,1,END=12) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'DMS=') THEN
		DMSFIL=INLIN(5:)
	ELSEIF (INLIN(1:4).EQ.'VOC=') THEN
		DMSFIL=INLIN(5:)
	ELSEIF (INLIN(1:7).EQ.'MAXUNC=') THEN
		READ (INLIN,'(7X,I1)',ERR=9) MAXUNC
	ENDIF
	GOTO 10
C
   12	CLOSE (UNIT=4)
C
C	GET DMS DATA FROM DMSFIL FILE
C
	OPEN (UNIT=4,FILE=DMSFIL,STATUS='OLD',ERR=940)
  200	READ (4,1) INLIN
	IF (INLIN(1:1).NE.'.') GOTO 200
C
	NDMS=0
  210	READ (4,1,END=220) INLIN
	IF ((INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'	')
     &	 .OR.INLIN(1:1).EQ.'!') GOTO 210
	IF (NDMS.EQ.MAXDMS) THEN
		WRITE (6,*) 'Too many DMS IN file = ',
     &		 DMSFIL(1:LNBLNK(DMSFIL)),'.  Last ones ignored.'
		GOTO 220
	ENDIF
	NDMS=NDMS+1
C
	READ (INLIN,'(A8,2X,F4.0,1X,F8.2,22X,I2)',ERR=942) DMSNAM(NDMS),
     &	 DMSNC(NDMS),DMSMW(NDMS),I
C
C	IF MAXUNC SPECIFIED, IGNORE DMS UNDEFINED CODE OR WITH CODE 
C	GREATER THAN MAXUNC
C
	IF (MAXUNC.EQ.0) GOTO 210
	IF (I.EQ.0.OR.I.GT.MAXUNC) NDMS=NDMS-1
	GOTO 210
C
  220	CLOSE (UNIT=4)
	IF (NDMS.EQ.0) THEN 
		WRITE (6,*) 'No VOCs in file = ',
     &		 DMSFIL(1:LNBLNK(DMSFIL))
		IF (MAXUNC.GT.0) WRITE (6,*) 'with uncertainty code',
     &		 ' less than or equal to ',MAXUNC
		IND=-3
	ELSE
		IND=0
	ENDIF
	RETURN
C
C	ERRORS
C
  940	WRITE (6,*) 'Error opening file = ',DMSFIL(1:LNBLNK(DMSFIL)),
     *	 ' for DMS parameters.'
	IND=-1
	RETURN
C
  942	WRITE (6,*) 'Error reading DMS parameter data from file = ',
     &	 DMSFIL(1:LNBLNK(DMSFIL)),'.'
	WRITE (6,*) 'Bad record = "',INLIN(1:LNBLNK(INLIN)),'"'
	IND=-2
	RETURN
	END
