	SUBROUTINE LDRCT (SCENID,DMSRCT,KODE,IND)
C
C	LOADS REACTIVITY DATA INTO MEMORY.  READS FILE GIVEN BY
C	RCT= INPUT IN MODELING.PRM
C
C	NOTE:  USES UNIT=4
C
C	ARGUMENTS:
C
C		SCENID = SCENARIO ID.  NAME OF .RCT FILE.
C
C		DMSRCT = ARRAY OF DMS REACTIVITIES.  DMS DATQ MUST ALREADY
C			 BE READ IN.
C
C		KODE   = REQUEST CODE:   0 = INCREMENTAL REACTIVITIES
C					 1 = KINETIC REACTIVITES
C					 2 = MECHANISTIC REACTIVITIES
C					 3 = O3M REACTIVITIES -- USE
C					     CORR FAC FROM .BAS FILE.
C					 4 = LIKE 0, BUT .CLC FILES READ
C					     FROM "DOSCLC=" DIR.
C
C		IND    = RETURN CODE:  	 0 = OK, STANDARD REACTIVITY
C					 1 = OK, ABSOLUTE UNCERTAINTY
C					 2 = OK, RELATIVE UNCERTAINTY
C					-1 = ERROR OPENING FILE
C					-2 = ERROR READING FILE
C					-3 = NO DATA IN FILE
C					-4 = NDMS=0.
C
C	IF SCENID HAS "/AR", "/LF", "/MS" OR "/AV" AT END, IT IS ASSUMED .RCT
C	FILE IS AGGREGATED REACTIVITY FILE OUTPUT BY RCTAGG.  READS AVG. RATIO
C	LINE FIT, MIN SUB ERR, OR AVERAGE REACTIVITIES.
C
C	IF SCENID HAS "uAR", "uLF" or "uMS" AT END, IT IS ASSUMED .RCT
C	FILE IS AGGREGATED REACTIVITY FILE OUTPUT BY RCTAGG.  READS STANDARD
C	DEVIATIONS OF ABOVE.
C
C	DMS ASSIGNMENT DATA
C
	INCLUDE 'DMSSPC.FOR'
C
C	SCENARIO DATA
C
	REAL DMSRCT(MAXDMS)
C
	LOGICAL USEKR,USEMR,USEO3M,RELUNC,ABSUNC
	CHARACTER SCENID*8,INLIN*80,FILNAM*80,RCTFIL*8,FMT*20,
     &	 FMT2*20,RCTCHK*8
C
	REAL NODATA
	PARAMETER (NODATA=-9.99E+9)
C
	DATA LRCTUC/-1/,LCLCUC/-1/
C
	RELUNC=.FALSE.
	ABSUNC=.FALSE.
C
	IF (KODE.EQ.4) THEN
		RCTCHK='DOSRCT='
		LRCTCK=7
		KODE=0
	ELSE
		RCTCHK='RCT='
		LRCTCK=4
	ENDIF
	USEKR=KODE.EQ.1
	USEMR=KODE.EQ.2
	USEO3M=KODE.EQ.3
C
C
C	ABORT IF NO DMS DATA READ IN.
C
	IF (NDMS.EQ.0) THEN
		WRITE (6,*) 'Cannot read reactivities.  No model',
     &		 ' species parameters defined.'
		IND=-4
		RETURN
	ENDIF
C
C	INITIALIZE ALL REACTIVITIES AS "UNDEFINED"
C
	DO 318 I=1,NDMS
  318	DMSRCT(I)=NODATA
C
C	GET RCT UIC FROM MODELING.PRM, IF NOT DONE BEFORE
C
	IF (LRCTUC.LT.0) THEN
		OPEN (UNIT=4,FILE='MODELING.PRM',STATUS='UNKNOWN')
		RCTUIC=' '
		LRCTUC=0
		CLCUIC=' '
		LCLCUC=0
  10		READ (4,1,END=12) INLIN
   1		FORMAT (A)
		IF (INLIN(1:4).EQ.'CLC=') THEN
			CLCUIC=INLIN(5:)
			LCLCUC=LNBLNK(CLCUIC)
		ELSEIF (INLIN(1:LRCTCK).EQ.RCTCHK) THEN
			RCTUIC=INLIN(LRCTCK+1:)
			LRCTUC=LNBLNK(RCTUIC)
		ENDIF
		GOTO 10
   12		CLOSE (UNIT=4)
	ENDIF
C
C	OPEN .RCT FILE.  GET DATA FROM .BAS FILE FIRST, IF
C	NEEDED.
C
	ITYP=0
	L=LNBLNK(SCENID)
	IF (L.EQ.0) THEN
		GOTO 952
	ELSEIF (L.LE.3) THEN
		RCTFIL=SCENID
		LRF=L
	ELSEIF (SCENID(L-2:L-2).EQ.'/') THEN
		RELUNC=.FALSE.
		ABSUNC=.FALSE.
	ELSEIF (SCENID(L-2:L-2).EQ.'%') THEN
		RELUNC=.TRUE.
		ABSUNC=.FALSE.
	ELSEIF (SCENID(L-2:L-2).EQ.'u') THEN
		RELUNC=.FALSE.
		ABSUNC=.TRUE.
	ELSE
		RCTFIL=SCENID
		LRF=L
		GOTO 14
	ENDIF
C
C	PROCESSING RCTAGG SCENARIOS
C
	IF (USEKR.OR.USEMR) GOTO 960
	IF (SCENID(L-1:L).EQ.'AR') THEN
		ITYP=1
	ELSEIF (SCENID(L-1:L).EQ.'LF') THEN
		ITYP=2
	ELSEIF (SCENID(L-1:L).EQ.'MS') THEN
		ITYP=3
	ELSEIF (SCENID(L-1:L).EQ.'AV') THEN
		ITYP=4
	ELSE
		WRITE (6,*) 'Can''t process ScenID = ',
     &		 SCENID(1:L)
		WRITE (6,*) 'Aggregrated scenario options ',
     &		 'must be: "/AR", "/LF", "/MS" or "/AV".'
		WRITE (6,*) 'or "%AR", "uAR", etc for uncertainties.'
		IND=-1
		RETURN
	ENDIF
	RCTFIL=SCENID(1:L-3)
	LRF=L-3
   14	CONTINUE
C
C
C	GET CORR FAC FROM .BAS FILE, IF NEEDED.
C
	IF (USEO3M) THEN
		IF (LCLCUC.EQ.0) THEN
			FILNAM=RCTFIL(1:LRF)
		ELSE
			FILNAM=CLCUIC(1:LCLCUC)
			FILNAM(LCLCUC+1:LCLCUC+LRF)=RCTFIL(1:LRF)
			L=LCLCUC+LRF
		ENDIF
		FILNAM(L+1:L+4)='.BAS'
		OPEN (UNIT=4,FILE=FILNAM,STATUS='OLD',ERR=950)
  301		READ (4,1,END=304) INLIN
		IF (INLIN(1:5).NE.'CORR ') GOTO 301
		READ (INLIN,'(5X,E11.4)',ERR=303) CORFAC
		IF (CORFAC.EQ.0.0) GOTO 303
		CORFAC=CORFAC*1000.
		GOTO 305
  303		WRITE (6,*) 'Error reading corr fac from file = ',
     &		 FILNAM(1:LNBLNK(FILNAM)),'.  Bad record:'
		WRITE (6,*) INLIN(1:LNBLNK(INLIN))
 		GOTO 309
  304		WRITE (6,*) 'No "CORR" record found in file = ',
     &		 FILNAM(1:LNBLNK(FILNAM))
  309		IND=-1
		CLOSE (UNIT=4)
		RETURN
C
  305		CLOSE (UNIT=4)
	ENDIF
C
C	OPEN .RCT FILE
C
	IF (LRCTUC.EQ.0) THEN
		FILNAM=RCTFIL(1:LRF)
		L=LRF
	ELSE
		FILNAM=RCTUIC(1:LRCTUC)
		FILNAM(LRCTUC+1:LRCTUC+LRF)=RCTFIL(1:LRF)
		L=LRCTUC+LRF
	ENDIF
C
	FILNAM(L+1:L+4)='.RCT'
	OPEN (UNIT=4,FILE=FILNAM,STATUS='OLD',ERR=950)
C
C
C	VARIOUS FILE FORMATS, AS INDICATED BELOW.
C
  300	READ (4,1,END=970) INLIN
C
	IF (INLIN(1:2).EQ.', ') THEN
C
C		"," ... "DMSRCT" FORMAT
C
  322		READ (4,1,END=390) INLIN
		DO 324 I=1,NDMS
		IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
		    IF (USEKR) THEN
			READ (INLIN,'(8X,F10.4)',ERR=980) DMSRCT(I)
		    ELSEIF (USEMR) THEN
			READ (INLIN,'(18X,F9.3)',ERR=980) DMSRCT(I)
		    ELSE
			READ (INLIN,'(27X,F10.4)',ERR=980) DMSRCT(I)
		    ENDIF
		    GOTO 322
		ENDIF
  324		CONTINUE
		GOTO 322
C
	ELSEIF (INLIN(1:3).EQ.'.KM'.OR.INLIN(1:3).EQ.',KM') THEN
C
C		".KM" ... "DMSRCT" FORMAT W/O IR.
C
  326		READ (4,1,END=390) INLIN
		DO 328 I=1,NDMS
		IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
		    IF (USEKR) THEN
			READ (INLIN,'(8X,F10.4)',ERR=980) DMSRCT(I)
		    ELSEIF (USEMR) THEN
			READ (INLIN,'(18X,F9.3)',ERR=980) DMSRCT(I)
		    ELSE
			READ (INLIN,'(8X,F10.4,F9.3)',ERR=980) X,Y
			DMSRCT(I)=X*Y
		    ENDIF
		    GOTO 326
		ENDIF
  328		CONTINUE
		GOTO 326
C
	ELSEIF (INLIN(1:2).EQ.'.C'.OR.INLIN(1:1).EQ.'-') THEN
C
C		".C" ... "SIMPLE PER CARBON" FORMAT
C		"-"  ... OUTPUT OF MRAVG ASSUMED TO PER-CARBON IR'S.
C
		IF (USEKR.OR.USEMR) GOTO 960
  330		READ (4,1,END=390) INLIN
		DO 332 I=1,NDMS
		IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
			READ (INLIN,'(8X,F10.4)',ERR=980) DMSRCT(I)
			GOTO 330
		ENDIF
  332		CONTINUE
		GOTO 330
C
	ELSEIF (INLIN(1:2).EQ.'.M') THEN
C
C		".M" ... "SIMPLE PER GRAM" FORMAT
C
		IF (USEKR.OR.USEMR) GOTO 960
  334		READ (4,1,END=390) INLIN
		DO 336 I=1,NDMS
		IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
			READ (INLIN,'(8X,F10.4)',ERR=980) X
			DMSRCT(I)=X*DMSMW(I)/(48.0*DMSNC(I))
			GOTO 334
		ENDIF
  336		CONTINUE
		GOTO 334
C
	ELSEIF (INLIN(1:2).EQ.'. ') THEN
C
C		"." ... EXPECTED ONLY IF /LF OR /AR OPTIONS USED.
C
		IF (ITYP.EQ.1) THEN
			FMT='(12X,F8.4,F5.0)'
			FMT2='(12X,2F8.4)'
			LP=26
		ELSEIF (ITYP.EQ.2) THEN
			FMT='(30X,F8.4,F5.0)'
			FMT2='(30X,2F8.4)'
			LP=44
		ELSEIF (ITYP.EQ.3) THEN
			FMT='(48X,F8.4,F5.0)'
			FMT2='(48X,2F8.4)'
			LP=62
		ELSEIF (ITYP.EQ.4) THEN
			FMT='(66X,F8.4,F5.0)'
			FMT='(66X,F8.4,F6.2)'
			LP=80
		ELSE
			GOTO 970
		ENDIF

  340		READ (4,1,END=390) INLIN
		IF (ABSUNC) THEN
			DO 3421 I=1,NDMS
			IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
				IF (INLIN(LP:LP).EQ.'%') THEN
				    READ (INLIN,FMT,ERR=980) DMSRCT(I),F
				    DMSRCT(I)=DMSRCT(I)*F/100.
				ELSE
				    READ(INLIN,FMT2,ERR=980) F,DMSRCT(I)
				ENDIF
				GOTO 340
			ENDIF
 3421			CONTINUE
		ELSEIF (RELUNC) THEN
			DO 3422 I=1,NDMS
			IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
				IF (INLIN(LP:LP).EQ.'%') THEN
				    READ (INLIN,FMT,ERR=980) F,DMSRCT(I)
				ELSE
				    READ(INLIN,FMT2,ERR=980) F,F
				    DMSRCT(I)=-F
				ENDIF
				GOTO 340
			ENDIF
 3422			CONTINUE
		ELSE
			DO 342 I=1,NDMS
			IF (INLIN(1:8).EQ.DMSNAM(I)) THEN
				READ (INLIN,FMT,ERR=980) DMSRCT(I)
				GOTO 340
			ENDIF
  342			CONTINUE
		ENDIF
C
C		GOTO 330	PROGRAM ERROR - SHOULD BE GOTO 340?
C				NEED TO CHECK LOGIC - THIS OPTION PROBABLY
C				ISN'T USED
		WRITE (6,*) 
     &		 'PROGRAM ERROR IN LDRCT.FOR - SEE LINES 334-337'
		STOP 1
C
	ENDIF
C
	GOTO 300
C
C	DONE READING REACTIVITY DATA FROM THIS FILE.  SUCCESSFUL
C	CONCLUSION
C
  390	CLOSE (UNIT=4)
C
C	APPLY CORRECTION IF APPLICABLE
C
	IF (USEO3M.AND.CORFAC.NE.1.0) THEN
		DO 392 I=1,NDMS
  392		DMSRCT(I)=DMSRCT(I)*CORFAC
	ENDIF
	IF (RELUNC) THEN
		IND=2
	ELSEIF (ABSUNC) THEN
		IND=1
	ELSE
		IND=0
	ENDIF
	RETURN
C
C
C	ERRORS
C
  950	WRITE (6,*) 'Error opening reactivity data file = ',
     &	 FILNAM(1:L+4),'.'
	IND=-1
	RETURN
C
  952	WRITE (6,*) 'PGM ERROR.  LDRCT CALLED WITH BLANK SCENID.'
	IND=-1
	RETURN
C
  960	WRITE (6,*) 'Kinetic and mechanistic reactivities ',
     &	 'not given in file = ',FILNAM(1:LNBLNK(FILNAM))
	IND=-3
	GOTO 990
C
  970	WRITE (6,*) 'No reactivity data in file = ',
     &	 FILNAM(1:LNBLNK(FILNAM))
	IND=-3
	GOTO 990
C
  980	WRITE (6,*) 'Error reading reactivity data from file = ',
     &	 FILNAM(1:LNBLNK(FILNAM))
	WRITE (6,*) 'Bad record = "',INLIN(1:LNBLNK(INLIN)),'"'
	IND=-2
C
  990	CLOSE (UNIT=4)
	RETURN
C
	END
