	SUBROUTINE GETXAR (AFAC,EA,BFAC,RK1,RK2,RK3)
C
C	GETS EXTENDED ARRHENIUS PARAMETERS GIVEN RATE CONSTANTS AT THE
C	THREE STANDARD TEMPERATURES (270, 300, 330K).
C
	REAL AFAC,EA,BFAC	! K = AFAC * EXP(-EA/RT) * (T/300)**BFAC
	REAL RK1,RK2,RK3	! RATE CONSTANTS AT 270, 300, 330 k
C
C	FOLLOWING IS INVERTED MATRIX WITH {1, 1/RT AND LN(T/300)}
C	FOR T= 270, 300, AND 330K
C
	REAL A(9)/-94.19943076, -56.15793332, 89.84963086, 
     &	 199.3320684, 118.2376473, -199.6658464, -104.1326376, 
     &	 -62.07971398, 109.8162155/
C
	REAL LNK1,LNK2,LNK3
C
	IF (RK1.EQ.0.0.OR.RK2.EQ.0.0.OR.RK3.EQ.0.0) THEN
		AFAC=0.0
		EA=0.0
		BFAC=0.0
	ELSEIF (RK1.EQ.RK2.AND.RK2.EQ.RK3) THEN
		AFAC=RK1
		EA=0.0
		BFAC=0.0
	ELSE
		LNK1=ALOG(RK1)
		LNK2=ALOG(RK2)
		LNK3=ALOG(RK3)
C
		AFAC=EXP((A(1)*LNK1)+(A(4)*LNK2)+(A(7)*LNK3))
		EA=(A(2)*LNK1)+(A(5)*LNK2)+(A(8)*LNK3)
		BFAC=(A(3)*LNK1)+(A(6)*LNK2)+(A(9)*LNK3)
	ENDIF
C
	RETURN
	END
