       SUBROUTINE INBUF (PROMPT,L)
C
C      READS IN IOBUF FROM INPUT FILE UNIT.
C      INPUT FILE UNIT IS INITIALLY IN=5 (KEYBOARD),
C      BUT WHEN @(filename) IS INPUT, TAKES INPUT
C      FROM SPECIFIED FILE.  UP TO 4 LEVELS ALLOWED,
C      PROVIDED TASK CAN HAVE AT LEAST THAT MANY
C      ACTIVE FILES.
C
C      CAN READ UP TO 160 CHARACTERS.  READS INTO BYT160.  NO. CHARACTERS
C      INPUT STORED AS IOLEN.  IF LESS THAN 80 CHARS INPUT, CHARACTERS
C      IOLEN+1 THRU 80 ARE BLANK.
C
C      IORET=2 MEANS END-OF-FILE
C      IORET=1 MEANS ERROR
C
	INCLUDE 'NEWIOBUF.FOR'
C
C	INCLUDE FILE PREFIXES
C
	PARAMETER (MAXPRE=16)
	INTEGER NPRE,LPREID(MAXPRE),LPRESB(MAXPRE)
	CHARACTER PREID(MAXPRE)*8,PRESUB(MAXPRE)*40
	DATA NPRE/0/
	save npre,lpreid,lpresb,preid,presub	! needed for G77
C
	CHARACTER*80 PROMPT,INLIN
	IORET=0
C
C       WRITE PROMPT IF NECESSARY
C
    1   IF (L.GT.0.AND.IN.EQ.IKEY) WRITE (ICRT,2) PROMPT(1:L)
    2   FORMAT (A,$)
C
C       INITIALIZE BUFFER
C
        IOB160=' '
C
C       READ STRING FROM INPUT UNIT
C
        READ (IN,'(A)',END=10) IOB160
C	IOLEN=MIN(LNBLNK(IOB160),MAXIBF)
	IOLEN=LNBLNK(IOB160)
C
        IF (SHOW.AND.IN.NE.IKEY) WRITE (ICRT,7) PROMPT(1:L),
     &	 IOB160(1:IOLEN)
    7   FORMAT (' ',A,1X,A)
C
C	STRINGS STARTING WITH ! IGNORED
C	STARTS WITH "!/":  SKIP UNTIL "!"
C
        IF (BYT160(1).EQ.'!') THEN
		IF (IOB160(1:2).EQ.'!/') THEN
 1004			READ (IN,'(A)',END=10) IOB160
			IF (IOB160(1:1).NE.'!') GOTO 1004
		ENDIF
		GOTO 1
C
C       ANY STRING WITHOUT ! OR @ RETURNED TO CALLING PGM
C
        ELSEIF (BYT160(1).NE.'@') THEN
		RETURN
C
C	STRING STARTING WITH "@@" PASSED AS A STRING STARTING WITH "@".
C
	ELSEIF (IOB160(1:2).EQ.'@@') THEN
		IOB160(1:IOLEN-1)=IOB160(2:IOLEN)
		IOB160(IOLEN:IOLEN)=' '
		IOLEN=IOLEN-1
		RETURN
C
C       STRING STARTS WITH '@'.  MEANS SPECIAL COMMAND TO INBUF
C
C      '@filename': INPUT FROM NEXT LEVEL.  INCREMENT IN AND OPEN FILE
C
        ELSEIF (IOB160(1:2).NE.'@#') THEN
                IF (IN.EQ.MAXUNT) THEN
                        WRITE (ICRT,22) MAXUNT
   22                   FORMAT (' INDIRECT NESTING OF MORE THAN',I2,
     &                   ' NOT ALLOWED')
                        DO 20 I=1,IN
   20                   CLOSE (UNIT=I)
                        IN=ICRT
                        IORET=2
                        RETURN
                ELSEIF (IOLEN.EQ.1) THEN
C
C		"@" RETURNS TO CRT INPUT
C
	                IF (IN.LE.MAXUNT) THEN
	                        DO 21 I=1,IN
	                        IF (SHOW) WRITE (ICRT,28) I
   28                   	FORMAT (' ',11X,'UNIT =',I2,' CLOSED.'/' ')
   21                   	CLOSE (UNIT=I)
	                ENDIF
	                IN=IKEY
			GOTO 1
C
		ELSE
                        IOB160=IOB160(2:IOLEN)
                        IOLEN=IOLEN-1
C
			IF (NPRE.NE.0) THEN
				DO 2020 I=1,NPRE
				L1=LPREID(I)
				IF (PREID(I)(1:L1).EQ.IOB160(1:L1)) THEN
					INLIN=IOB160
					L2=LPRESB(I)
					IOB160=PRESUB(I)(1:L2)//
     &					 INLIN(L1+1:)
					IOLEN=L2+IOLEN-L1
					GOTO 2021
				ENDIF
 2020			CONTINUE
			ENDIF
 2021			CONTINUE
C
                        IF (IN.EQ.IKEY) THEN
                                IN=1
                        ELSE
                                IN=IN+1
                        ENDIF
                        OPEN (UNIT=IN,FILE=IOB160,STATUS='OLD',ERR=90)
C						READONLY
                        IF (SHOW) WRITE(ICRT,24) IOB160(1:IOLEN),IN
   24                   FORMAT (' ---------- INPUT FROM FILE = ',
     &                   A,',  UNIT =',I3,' ----------'/' ')
                        GOTO 1
                ENDIF
C
C       '@#END' FORCES END OF ALL INPUT (ALSO TOO MANY INDIRECTS)
C
        ELSEIF (IOB160(1:5).EQ.'@#END') THEN
                IF (IN.LE.MAXUNT) THEN
                        DO 2101 I=1,IN
                        IF (SHOW) WRITE (ICRT,28) I
 2101                   CLOSE (UNIT=I)
                ENDIF
                IN=IKEY
                IORET=2
                RETURN
C
C       @#SH ... SHOW INDIRECT INPUT LINES
C       @#NS ... DON'T SHOW INDIRECT INPUT
C	@#SK ... SKIP UNTIL "@#"
C	@#   ... IGNORED
C
        ELSEIF (IOB160(1:4).EQ.'@#SH') THEN
                SHOW=.TRUE.
                GOTO 1
C
        ELSEIF (IOB160(1:4).EQ.'@#NS') THEN
                SHOW=.FALSE.
                GOTO 1
C
        ELSEIF (IOB160(1:4).EQ.'@#SK') THEN
 1002	        READ (IN,'(A)',END=10) IOB160
		IF (IOB160(1:2).EQ.'@#') GOTO 1
	        IF (SHOW.AND.IN.NE.IKEY) WRITE (ICRT,7) '(SKIP)',
     &		 IOB160(1:LNBLNK(IOB160))
                GOTO 1002
C
        ELSEIF (IOB160(1:2).EQ.'@#') THEN
                GOTO 1
C
C       UNRECOGNIZED COMMAND STARTING WITH '@#'
C
        ELSE
                WRITE (ICRT,94) IOB160(1:32)
   94           FORMAT (' UNRECOGNIZED INBUF COMMAND = ''',A4,'''')
                GOTO 1
C
        ENDIF
C
C--------------------------------------------------------------
C
C       END OF FILE.  INDICATE DONE WITH ALL INPUTS IF UNIT=5,
C       OTHERWISE, CLOSE FILE AND DEINCREMENT UNIT NO.
C
   10   IF (IN.EQ.IKEY) THEN
                IORET=2
                RETURN
        ELSE
                IF (SHOW) WRITE (ICRT,28) IN
                CLOSE (UNIT=IN)
                IF (IN.EQ.1) THEN
                        IN=IKEY
                        IF (NOKEY) THEN
                                IORET=2
                                RETURN
                        ELSE
                                GOTO 1
                        ENDIF
                ELSE
                        IN=IN-1
                        GOTO 1
                ENDIF
        ENDIF
C-------------------------------------------------------------------
C
C       ERROR IN OPENING FILE
C
   90   WRITE (ICRT,91) IOB160(1:IOLEN)
   91   FORMAT (' INBUF:  Error opening @file = ',A)
        IF (IN.GT.1) THEN
                IN=IN-1
                DO 93 I=1,IN
   93           CLOSE (UNIT=IN)
                IORET=2
CC              IOBF2(2)=1
                IN=-1
                RETURN
        ELSE
                IN=IKEY
                WRITE (ICRT,92)
   92           FORMAT (' Try again. ')
C$
                GOTO 1
        ENDIF
C
C--------------------------------------------------------------
C      ENTRY POINT TO INITIALIZE AND GIVE MAX NO INPUT FILES
C
        ENTRY INITIN (L)
        MAXUNT=MIN(L,4)
        SHOW=.FALSE.
        NOKEY=.FALSE.
	NPRE=0
        IF (IN.EQ.IKEY) RETURN
        DO 200 I=1,IN
  200   CLOSE (UNIT=I)
        IN=IKEY
        RETURN
C
C--------------------------------------------------------------------------
C      ENTRY POINT TO CLOSE ALL FILES, AND START INPUT FROM FILE
C      WHOSE NAME IS IN IOB160 ARRAY
C
        ENTRY FILEIN
C
        IORET=0
        IF (IN.LE.MAXUNT) THEN
                DO 302 I=1,IN
                IF (SHOW) WRITE (ICRT,28) I
  302           CLOSE (UNIT=I)
        ENDIF
        IN=1
        NOKEY=.TRUE.
        OPEN (UNIT=IN,FILE=IOB160,STATUS='OLD',ERR=320)	! READONLY
        IF (SHOW) WRITE (ICRT,324)
  324   FORMAT (' ---------- INPUT FROM FILE GIVEN AT CALL TO FILEIN'
     &   ,' ----------')
        RETURN
C
C       ERROR.  INDICATE SO.
C
  320   IORET=1
        RETURN
C
C----------------------------------------------------------------
C      ENTRY POINT TO START THE NEXT LEVEL OF INPUT FROM FILE
C      NAMED IN IOB160 ARRAY.  (SAME EFFECT AS @<FILENAME>,
C      EXCEPT SUBSTITUTIONS IGNORED.)
C
       ENTRY FILNXT
C
       IF (IN.EQ.MAXUNT) THEN
             WRITE (ICRT,52) MAXUNT
  52         FORMAT (' INDIRECT NESTING OF MORE THAN',I2,
     &        ' NOT ALLOWED')
             DO 50 I=1,IN
  50         CLOSE (UNIT=I)
             IN=IKEY
             IORET=2
       ELSE
             IF (IN.EQ.IKEY) THEN
                   IN=1
             ELSE
                   IN=IN+1
             ENDIF
C
             OPEN (UNIT=IN,FILE=IOB160,STATUS='OLD',ERR=90) ! READONLY
             IOLEN=LNBLNK(IOB160)
            IF (SHOW) WRITE (ICRT,54) IOB160(1:IOLEN),IN
  54        FORMAT (/' ----- INPUT FROM FILE = ',A,' AT CALL TO ', 
     &       'FILNXT',', UNIT=',I2,' -----')
       ENDIF
       RETURN
C
C=================================================================
C
C	ENTRY POINT TO ADD PREFIX FOR INCLUDE FILE (USUALLY
C	FROM MODELING.PRM)
C
	ENTRY ADDPRE (PROMPT,L)
C
	IF (L.EQ.0) THEN
		WRITE (6,*) 'Bad call to ADDPRE.  L=0.'
		IORET=1
		RETURN
	ELSEIF (PROMPT(1:2).NE.'@='.OR.PROMPT(3:3).EQ.' ') THEN
		WRITE (6,*) 'Bad call to ADDPRE.  Arg = "',
     &		 PROMPT(1:L),'"'
		IORET=1
		RETURN
	ELSEIF (NPRE.EQ.MAXPRE) THEN
		WRITE (ICRT,*) 'TOO MANY "@" SUBSTITUTIONS.  ',
     &		 'INCREASE MAXPRE IN NEWINBUF.FOR'
		WRITE (ICRT,*) PROMPT(1:L),' IGNORED.'
		IORET=1
		RETURN
	ENDIF
	NPRE=NPRE+1
	CALL PARSE0 (2,PROMPT(3:80),78)
	CALL PARSE1 (1,PREID(NPRE),LPREID(NPRE),8,PROMPT(3:80))
	CALL PARSE1 (2,PRESUB(NPRE),LPRESB(NPRE),40,PROMPT(3:80))
	IORET=0
	IF (NPRE.EQ.1) RETURN
	DO 2030 I=1,NPRE-1
	IF (PREID(I).EQ.PREID(NPRE)) THEN
		PRESUB(I)=PRESUB(NPRE)
		LPRESB(I)=LPRESB(NPRE)
		NPRE=NPRE-1
		RETURN
	ENDIF
 2030	CONTINUE
	RETURN
	END
C
C=================================================================
       BLOCK DATA
C
C      INITIALIZE I/O BUFFER ARRAY FOR INBUF.
C
	INCLUDE 'NEWIOBUF.FOR'
C
C
       DATA IN/5/,NOKEY/.FALSE./,SHOW/.FALSE./,IOB160/' '/,MAXUNT/4/
       END
